/* regisztracio s szmla sszekapcsols (tbb regisztrcihoz tartozik egy sz_id+sz_tipus) */
create table if not exists rszlink (
  r_id integer,
  sz_id integer,
  tipus char(10)
);
create index rszlinki on rszlink (r_id);

/* szmla, elleg bekr s proforma szmla fej adatok */
create table if not exists szamla (
  sz_id integer,      /* sz_tipus -onknt eltr szmtartomny */
  sz_tipus char(12),  /* elolegbekero|proforma|szamla */
  sz_ev integer,
  sz_kelte date,
  sz_teljdat date,
  sz_fizhat date,
  sz_fizmod integer, /* 1 KP, 2 - bank, 3 - beszedsi, 4 - posta, 5 - utnvt, ... */
  sz_pazon char(8),
  sz_nev char(60),
  sz_irsz char(10),
  sz_varios char(40),
  sz_cim char(60),
  sz_adoszam char(16),
  sz_euadoszam char(20),
  sz_penznem char(3),
  sz_brutto numeric(14,2),
  sz_cimletker numeric(1),
  sz_levszoveg char(60),  /* levonas szvege */
  sz_levonas numeric(14,2),
  sz_fizetendo numeric(14,2),
  sz_kozlemeny text
);
create index szamlai on szamla (sz_id);

/* szmla, elleg bekr s proforma szmla ttel adatok */
create table if not exists sztetel (
  sz_id integer,
  sz_tipus char(12),  /* elolegbekero|proforma|szamla */
  szt_sorszam integer,  /* szmln belli sorszm 0,1,2... */
  szt_cikkszam char(20),
  szt_cikknev char(60),
  szt_jelzoszam char(20),
  szt_mennyiseg numeric(10,2),
  szt_mee char(60),
  szt_egysar numeric(14,2), /* nett egysgr */
  szt_afakulcs char(10),
  szt_ertek numeric(14,2),  /* HUF esetn egszre kerekitve */
  szt_afa numeric(14,2),    /* HUF esetn egszre kerekitve */
  szt_brutto numeric(14,2) /* HUF esetn egszre kerekitve */
);
create index szteteli on sztetel (sz_id);

