<?php
/*
E-mail log bngsz
Author: Fogler Tibor   foglert@robitbt.hu
Licence: GNU/GPL

ez hivja a emaillog0.php -t. (tblzatos megjelenits, sor zselekcival)
POST  act, top, selected, filter, order

*/
session_start();
global $config,$db,$q,$lastError;
global $act,$top,$selected,$order,$filter,$uniquekeyValue;
include("./class.phpmailer.php");
include("./class.smtp.php");
include_once('./config.php');
include_once('./mysqldb.php');
include_once('./login.php');  // $db konnektlja, $q -t krel
include_once('./header.php');

// sor/lap s tblzat mret definilsa
$pageSize = 12;
$ifrmHeight = 320;

// grid oszlop fejlc cimkk definilsa
$labels = array();
$labels[] = '<var>#</var>';
$labels[] = '<var>Idpont</var>';
$labels[] = '<var>E-mail</var>';
$labels[] = '<var>Sttusz</var>';
$labels[] = '<var>Tipus</var>';
$labels[] = '<var>Levl szveg kd</var>';
$labels[] = '<var>Proforma szm</var>';

// segd rutinok
function echoPager($j,$j0,$i) {
     if ($j == $j0)
         echo '<big><b>'.($j+1).'</b></big>&nbsp;';
      else
         echo '<a href="#" onclick="jump('.$i.')">'.($j+1).'</a>&nbsp;';
}
function echoOption($value,$label,$actValue) {
  if ($value==$actValue)
    echo '<option value="'.$value.'" selected="selected">'.$label.'</option>'."\n";
  else
    echo '<option value="'.$value.'">'.$label.'</option>'."\n";
}
function echoChkBox($table,$name) {
  if ($table->valuebyname($name)=='')
    echo '<input type="checkbox" name="'.$name.'" value="X" />'."\n";
  else
    echo '<input type="checkbox" checked="checked" name="'.$name.'" value="X" />'."\n";
}
function echoFilter($filter,$nev) {
  $i = stripos($filter,"fl.".$nev." <> ''");
  if ($i === false)
    echo '<input type="checkbox" name="fil'.$nev.'" value="X">';
  else
    echo '<input type="checkbox" name="fil'.$nev.'" checked="checked" value="X">';
}

// adat kperny
function echodataform($table,$formtitle) {
      global $config,$dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
      echo '<input type="hidden" name="id" value="'.$table->valuebyname('id').'">'."\n";
      echo '<h2>'.$formtitle.'</h2>'."\n";
      echo '<p>&nbsp;</p>'."\n";
      echo '<table border="0" cellspacing="0" cellpadding="2">'."\n";
      echo '  <tr><td align="right"><var>Kdszm:</var></td>'."\n";
      echo '      <td><input type="text" name="_id" '.
           '          value="'.$table->valuebyname('id').'" readonly="readonly" class="readonly" />'."\n";
      echo '      </td></tr>'."\n";
      echo '  <tr><td><val> idont:</val></td><td><input type="text" name="idopont" size="40" '.
           '          value="'.$table->valuebyname('idopont').'" />'."\n";
      echo '      </td></tr>'."\n";
      echo '  <tr><td><var>E-mail:</var></td>'."\n";
      echo '      <td><input type="text" name="email" '.
           '          value="'.$table->valuebyname('email').'"  size="40"/>'."\n";
      echo '      </td></tr>'."\n";
      echo '  <tr><td><var>Sttusz:</var></td>'."\n";
      echo '      <td><input type="text" name="errorinfo" '.
           '          value="'.$table->valuebyname('errorinfo').'"  size="40"/></td>'."\n";
      echo '  </tr>'."\n";
      echo '</table>'."\n";
      echo '<p>'.$table->valuebyname('tipus').'</p>'."\n";
      if ($table->valuebyname('proformaid') > 0)
        $url = $config['rooturl']."/visszaig/viszig_".$table->valuebyname('bodyid').".html";
      else
        $url = $config['rooturl']."/emlekeztetok/emlekezteto_".$table->valuebyname('bodyid').".html";
      echo '<p>'.$url.'</p>';
      echo '<iframe width="750" height="300" src="'.$url.'" style="background-color:white"></iframe>'."\n";

      if ($table->valuebyname('proformaid') > 0)
        $url = $config['rooturl']."/proforma/".$table->valuebyname('proformaid').".pdf";
      else
        $url = "";
      if ($url != '')
        echo '<p><a href="'.$url.'" target="">Proforma bizonylat</a></p>'."\n";
      else
        echo '<p></p>'."\n";
}

$act = getPOST('act'); if ($act=='') $act='browse';
$top = getPOST('top'); if ($top=='') $top=0;
$selected = getPOST('selected');  if ($selected=='') $selected=0;
$selectedId = getPOST('selectedId');  if ($selectedId=='') $selectedId='0';
$searchStr = getPOST('searchStr');
$filter = stripslashes(getPOST('filter'));  if ($filter == '') $filter = '';
$order = getPOST('order'); if ($order == '') $order='fl.idopont,fl.email';
$totalrecords = 0;
$errorMsg = '';

echo '<div id="divfaxtiltas" style="background-color:white; border-style:solid; position:absolute; z-index:2; left:30px; top:30px; width:750px">'."\n";

if ($act=='dofilter') {
  // j $filter kialakitsa
  $filter1 = '';
  if (getPOST('filkorzet') != '')
    $filter1 .= "(fl.korzet = '".getPOST('filkorzet')."')";
  $filter2 = '';
  if (getPOST('filtax') != '')
    $filter2 .= " or fl.tax <> ''";
  if (getPOST('filkozbeszerz') != '')
    $filter2 .= " or fl.kozbeszerz <> ''";
  if (getPOST('filonkormanyzat') != '')
    $filter2 .= " or fl.onkormanyzat <> ''";
  if (getPOST('filtanugyig') != '')
    $filter2 .= " or fl.tanugyig <> ''";
  if (getPOST('filmunkaugy') != '')
    $filter2 .= " or fl.munkaugy <> ''";
  if (getPOST('filjegyzo') != '')
    $filter2 .= " or fl.jegyzo <> ''";
  if (getPOST('filokmanyiroda') != '')
    $filter2 .= " or fl.okmanyiroda <> ''";
  if ($filter2 != '') {
    if ($filter1 != '')
      $filter = $filter1.' and (fl.id < 0 '.$filter2.')';
    else
      $filter = '(fl.id < 0 '.$filter2.')';

  } else {
    $filter = $filter1;
  }
  $top = 0;
  $selected = 0;
  $act = 'browse';
}
if ($act=='doorder') {
   // j $order kialakitsa
   if (getPOST('newOrder') != '') {
     $order = getPOST('newOrder');
     $top = 0;
     $selected = 0;
     $act = 'browse';
   }
}
if ($act=='searchFirst') {
  $top = 0;
  $selected = -1;
  $act='searchNext'; // r csorog a kvetkez if -re!
  if ($searchStr == '')
     $act='browse';
}
if ($act=='searchNext') {
  // sszes rekorszm lekr sql
  if ($filter=='')
       $q->sql = 'select count(*) from '.$config['dbpre'].'emaillog fl '.
                 'where fl.id >= 0 ';
  else
       $q->sql = 'select count(*) from '.$config['dbpre'].'emaillog fl '.
                 'where  fl.id >= 0 and '.$filter;
  $q->open();
  if ($q->recordCount > 0) {
      $q->first();
      $totalRecords = $q->fields[0]->value;
  } else {
      $totalRecords = 0;
  }
  $q->close();
  // sql lekrs, soros keress $top+$selected -tl
  // j $top, $selected belltsa
  $selected = $selected + 1;
  $sql = 'select fl.* from '.$config['dbpre'].'emaillog fl '.
               'where fl.id >= 0 ';
  if ($filter != '')
     $sql .= ' and '.$filter;
  if ($order != '')
     $sql .= ' order by '.$order.',id';
  $find = -1;
  // vgig olvass 1000 rekordos darabokban
  $recNo = $top + $selected;
  for ($top1 = ($top + $selected); (($top1 < $totalRecords) & ($find < 0)); $top1 = $top1 + 4000) {
    $q->sql = $sql.' limit '.$top1.',4000';
    $q->open();
    if ($q->recordCount > 0) {
       $q->first();
       while (!$q->eof) {
         $jo = false;
         for ($j=0; $j < count($q->fields); $j++) {
           if (!(stripos($q->fields[$j]->value,$searchStr) === false))
              $jo = true;
         }
         if ($jo) {
           $find = $recNo;
           $q->last();
         }
         $q->next();
         $recNo++;
       }
    }
    $q->close;
  }
  // j $top, $selected meghatrozsa a $fin -bl
  if ($find >= 0) {
    $top = 0;
    while ($find >= $pageSize) {
      $top = $top + $pageSize;
      $find = $find - $pageSize;
    }
    $selected = $find;
  } else {
    if ($selected > 0)
       $selected = $selected - 1;
    $errorMsg = 'Nincs ilyen! ('.$searchStr;
  }
  $act='browse';
}
if ($act=='doinsert') {
  // form ellenrzs
  // ha j felvitel s $act='browse'
  // ha nem j:
  //    hibajelzs s form ujra a POST -ban lv adatokkal
  //    $act='insertform'
  $t = new Ttable('t',$db,$config['pre'].'emaillog');
  $t->filter = 'id = -1';
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->append();
  for ($i=0; $i<count($t->fields); $i++)
    $t->fields[$i]->value = '';
  $t->getFromPOST();
  $t->post();
  $act = 'browse';
}
if ($act == 'doupdate') {
  // form ellenrzs
  // ha j modosits s $act='browse'
  // ha nem j:
  //    hibajelzs s form ujra a POST -ban lv adatokkal
  //    $act='updateform'


  $t = new Ttable('t',$db,$config['pre'].'emaillog');
  $t->filter = 'id = '.getPOST('id');
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->edit();
  for ($i=0; $i<count($t->fields); $i++)
    $t->fields[$i]->value = '';
  $t->getFromPOST();
  $t->post();
  $act = 'browse';
}
if ($act=='dodelete') {
  // trls s $act='browse'
  $t = new Ttable('t',$db,$config['pre'].'emaillog');
  $t->filter = 'id = '.$selectedId;
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->delete();
  $act = 'browse';
}

if ($act=='dosend') {
  // ujra klds s $act='browse'
  $t = new Ttable('t',$db,$config['dbpre'].'emaillog');
  $t->filter = 'id = '.$selectedId;
  $t->filtered = true;
  $t->open();
  $t->first();
  $to = $t->valuebyname('email');
  $toname = '';
  $q3 = new Tquery('q3',$db);
  // Levl tnyleges elkldse  viszig_id.html s proformaId.pdf
  if ($t->valuebyname('proformaid') > 0)
    $sorok = file('./visszaig/viszig_'.$t->valuebyname('bodyid').'.html');
  else
    $sorok = file('./emlekeztetok/emlekezteto_'.$t->valuebyname('bodyid').'.html');
  $body = '';
  for ($i=0; $i<count($sorok); $i++)
      $body .= $sorok[$i];
  $txtBody = strip_tags($body,'<p></p><br />');
  $txtBody = str_replace('<p>',"\n",$txtBody);
  $txtBody = str_replace('</p>',"\n",$txtBody);
  $txtBody = str_replace('<br />',"\n",$txtBody);
  $mail = new PHPMailer();
  $mail->IsSMTP();
  $mail->IsHTML(true); // send as HTML
  $mail->SMTPAuth   = $config['smtpauth'];     // enable SMTP authentication
  $mail->SMTPSecure = $config['smtpsecure'];   // sets the prefix to the servier
  $mail->Host       = $config['smtphost'];     // sets GMAIL as the SMTP server
  $mail->Port       = $config['smtpport'];     // set the SMTP port
  $mail->Username   = $config['smtpuser'];     // GMAIL username
  $mail->Password   = $config['smtppassword']; // GMAIL password

  
  // TEST
  // $to = 'tibor.fogler@gmail.com';

  $mail->AddAddress($to,$toname);

  $mail->Subject    = $t->valuebyname('tipus');
  $mail->From       = $config['senderemail'];
  $mail->FromName   = $config['sendername'];
  $mail->AddReplyTo($config['senderemail'],$config['sendername']);
  $mail->WordWrap   = 50; // set word wrap
  $mail->MsgHTML($body);
  $mail->AltBody    = $txtBody; //Text Body
  if ($t->valuebyname('proformaid') > 0)
     $mail->AddAttachment("./proforma/".$t->valuebyname('proformaid').".pdf"); // attachment
  $mailStatus = $mail->Send();
  if (!$mailStatus) {
      echo "Mailer Error: " . $mail->ErrorInfo;
  } else {
      echo "E-mail kldve ". $to;
  }
  // rekord irsa az email log -ba
  $q3->sql = 'insert into '.$config['dbpre'].'emaillog (idopont,email,errorinfo,tipus,bodyid,proformaid) '.
             'values ("'.date('Y.m.d H:i').'", '.
             '"'.$to.'", '.
             '"'.$mail->ErrorInfo.'", '.
             '"'.$t->valuebyname('tipus').'", '.
             '"'.$t->valuebyname('bodyid').'",'.
             '"'.$t->valuebyname('proformaid').'")';
  $q3->execsql();
  $act = 'browse';
}

// sszes rekorszm lekr sql
if ($filter=='')
   $q->sql = 'select count(*) from '.$config['pre'].'emaillog fl '.
             'where fl.id >= 0';
else
   $q->sql = 'select count(*) from '.$config['pre'].'emaillog fl '.
             'where fl.id >= 0 and '.$filter;

$q->open();
if ($q->recordCount > 0) {
  $q->first();
  $totalRecords = $q->fields[0]->value;
} else {
  $totalRecords = 0;
}
$q->close();

echo '<h1>E-mail kldsi napl</h1>'."\n";

// order form
echo '<div class="orderform">'."\n";
echo '<form name="frmorder" action="./emaillog.php" method="post">'."\n";

//echo '<p>('.$filter.')</p>';

echo '<input type="hidden" name="act" value="doorder">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p>Rendezs:<select name="newOrder">'."\n";
     echoOption('fl.id','Kdszm',$order);
     echoOption('fl.idopont,fl.email','Idpont',$order);
     echoOption('fl.email,fl.idopont','E-mail',$order);
echo '</select>'."\n";
echo '<button type="submit">trendez</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// filter form rajzolsa, kezd rtkek a $filter-bl jnnek
$filkorzet = '';
$w = explode(')',$filter);
if (count($w) > 1) {
  $w2 = explode("'",$w[0]);
  $filkorzet = $w2[1];
}
/*
echo '<div class="filterform">'."\n";
echo '<form name="frmfilter" action="./emaillog.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="dofilter">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p><b>Szrs:</b>&nbsp;&nbsp;&nbsp;'."\n";
echo '<var>Krzet:</var>'."\n";
echo '<input type="text" name="filkorzet" value="'.$filkorzet.'" /></p>'."\n";
echo '<p>'."\n";
echoFilter($filter,'tax'); echo 'Ad ';
echoFilter($filter,'kozbeszerz'); echo 'Kzbeszerzs ';
echoFilter($filter,'onkormanyzat'); echo 'nkormnyzat ';
echoFilter($filter,'tanugyig'); echo 'Tangy ';
echoFilter($filter,'munkaugy'); echo 'Munkagy ';
echoFilter($filter,'jegyzo'); echo 'Jegyz ';
echoFilter($filter,'okmanyiroda'); echo 'Okmnyiroda ';
echo '<button type="submit">Szrst alkalmaz</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";
*/
// bngsz iframe
echo '<center><iframe name="ifrm0" width="98%" height="'.$ifrmHeight.'"></iframe></center>'."\n";
// bngsz tblzat iframe-be betltshez szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmbongeszo" action="./emaillog0.php" method="post" target="ifrm0">'."\n";
echo '<input type="hidden" name="act" value="'.$browse.'">'."\n";
echo '<input type="hidden" name="pageSize" value="'.$pageSize.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<input type="hidden" name="labels" value="'.implode(';',$labels).'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// lapoz gombsor kiirsa
echo '<p class="gridjumper">';
echo 'sszesen '.$totalRecords.' sor &nbsp;&nbsp;&nbsp;';
echo 'Oldalak:&nbsp;'."\n";
       $j0 = ($top / $pageSize); // current page
       $jmax = ($totalRecords / $pageSize); // max page
       $elozoKiirva = false;
       $i = 0; // rekordszm
       $j = 0; // oldalszm
       while ($j <= $jmax) {
          if (($j < 5) |
              ($j > $jmax - 5) |
              (abs($j - $jmax/2) < 5) |
              (abs($j - $j0) < 5)
             ) {
               echoPager($j,$j0,$i);
               $elozoKiirva = treu;
          } else {
               if ($elozoKiirva) echo '...';
               $elozoKiirva = false;
          }
          $i = $i + $pageSize;
          $j++;
       }
echo '</p>'."\n";

// bngsz iframe feltltse
echo '<script type="text/javascript">'."\n";
echo 'document.forms.frmbongeszo.submit();'."\n";
echo '</script>'."\n";

// manipull gombsor
echo '<p><button type="button" onclick="viewform();"><img src="./images/info.gif">Megnz</button>&nbsp;';
echo '<button type="button" onclick="dodelete();"><img src="./images/buttondel.gif">Trl</button>&nbsp;';
echo '<button type="button" onclick="searchFirst();"><img src="./images/buttonfind.gif">Keres ellrl</button>&nbsp;'."\n";
echo '<button type="button" onclick="searchNext();"><img src="./images/buttonfind.gif">Tovbb Keres</button>&nbsp;'."\n";
echo '<button type="button" onclick="dosend();"><img src="./images/buttonup.gif">jra kld</button>&nbsp;'."\n";

$url = "'index.php'";
echo '<button type="button" onclick="location='.$url.'"><img src="images/buttoncancel.gif">Vissza a kezd lapra</button></p>'."\n";

// sajtmaga visszahivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="visszahivo" action="./emaillog.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="selectedId" value="'.$selectedId.'">'."\n";
echo '<input type="hidden" name="searchStr" value="'.$searchStr.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";
// mysql2excel hivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmcsv" action="./mysql2excel.php" method="post">'."\n";
echo '<input type="hidden" name="selectsql" value="">'."\n";
echo '<input type="hidden" name="countsql" value="">'."\n";
echo '<input type="hidden" name="csvnev" value="">'."\n";
echo '<input type="hidden" name="terminator" value=",">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

if ($act == 'insertform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:25px; top:20px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./emaillog.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'emaillog where id < 0';
  $q->open();
  $q->first();
  //$q->append();
  $q->setvaluebyname('datum', date('Y.m.d'));
  echodataform($q,'FAX tilts j sor felvitele');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}
if ($act == 'viewform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:25px; top:20px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./emaillog.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'emaillog where id = '.$selectedId;
  $q->open();
  $q->first();
  echodataform($q,'E-mail napl megtekints');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'inputs = document.getElementsByTagName("INPUT");'."\n";
  // input mezk set readonly
  echo 'for (i=0; i < inputs.length; i++) {'."\n";
  echo '  inputs[i].readOnly = true;'."\n";
  echo '  inputs[i].disabled = true;'."\n";
  echo '}'."\n";
  echo '</script>'."\n";
}
if ($act == 'updateform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:250px; top:20px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./emaillog.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'emaillog where id = '.$selectedId;
  $q->open();
  $q->first();
  echodataform($q,'FAX tilts mdosts');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}

echo '<script type="text/javascript">'."\n";
echo 'selected = '.$selected.';'."\n";
echo 'selectedId = '.$selectedId.';'."\n";
//echo 'document.getElementById("divemaillog").style.width=screen.width - 80;'."\n";
echo 'function jump(newTop) {'."\n";
echo '  selected = 0;'."\n";
echo '  document.forms.visszahivo.top.value=newTop;'."\n";
echo '  document.forms.visszahivo.selected.value="0";'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function viewform() {'."\n";
echo '  document.forms.visszahivo.act.value="viewform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function updateform() {'."\n";
echo '  document.forms.visszahivo.act.value="updateform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function insertform() {'."\n";
echo '  document.forms.visszahivo.act.value="insertform";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchFirst() {'."\n";
echo '  document.forms.visszahivo.searchStr.value=prompt("Keresend:");'."\n";
echo '  document.forms.visszahivo.act.value="searchFirst";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchNext() {'."\n";
echo '  document.forms.visszahivo.act.value="searchNext";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function dodelete() {'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  if (confirm("Trlni akarja ezt az adatot?")) ';
echo '     document.forms.visszahivo.act.value="dodelete";'."\n";
echo '  else'."\n";
echo '     document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function dosend() {'."\n";
echo '  document.getElementById("divturelem").style.display="block";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.act.value="dosend";'."\n";
echo '  document.forms.visszahivo.target.value="_self";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";

echo 'function doexcelexport() {'."\n";
echo '  document.forms.visszahivo.action="mysql2excel.php";'."\n";
if ($filter=='')
   $sql = $config['pre'].'emaillog fl '.
             'where fl.id >= 0';
else
   $sql = $config['pre'].'emaillog fl '.
             'where fl.id >= 0 and '.$filter;
echo '  document.forms.frmcsv.selectsql.value="'.
     'select fl.email,fl.fax,fl.korzet,fl.cegnev,fl.ugyfel '.
     'from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.countsql.value="select count(fl.id) from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.csvnev.value="emaillog";'."\n";
echo '  document.forms.frmcsv.submit();'."\n";
echo '}'."\n";

echo 'function doload() {'."\n";
echo '  location="./emaillogload.php";'."\n";
echo '}'."\n";
echo 'function ok() {'."\n";
echo '  inputs = document.getElementsByTagName("INPUT");'."\n";
echo '  for (i=0; i < inputs.length; i++) {'."\n";
echo '    inputs[i].readOnly = false;'."\n";
echo '    inputs[i].disabled = false;'."\n";
echo '  }'."\n";
if ($act == 'insertform')
   echo '  document.forms.adatform.act.value="doinsert";'."\n";
if ($act == 'updateform')
   echo '  document.forms.adatform.act.value="doupdate";'."\n";
if ($act == 'viewform')
   echo '  document.forms.adatform.act.value="browse";'."\n";
echo '  document.forms.adatform.submit();'."\n";
echo '}'."\n";
echo 'function cancel() {'."\n";
echo '  inputs = document.getElementsByTagName("INPUT");'."\n";
echo '  for (i=0; i < inputs.length; i++) {'."\n";
echo '    inputs[i].readOnly = false;'."\n";
echo '    inputs[i].disabled = false;'."\n";
echo '  }'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function celclick(row,col) {'."\n";
echo '  selected = row;'."\n";
echo '  document.forms.visszahivo.selected.value=row;'."\n";
echo '}'."\n";
if ($errorMsg != '')
    echo 'alert("'.$errorMsg.'");'."\n";
echo '</script>'."\n";
echo '</div>'."\n";
include_once('./footer.php');
?>
