// form maker
// Azthor: Fogler Tibor
// Licence: GNU/GPL
// exmples:
//   setFormValue('form1','field1','1245');
//   makeDateEdit('form1','field2');
//   makeIntegerEdit('form1','field3');
//   makeCurrencyEdit('form1','field4');
//   setReadOnly('form1','field2');
//   setReadOnlyAll('form1');
//+ config
datemask = 'yyyy.mm.dd';  // only 'yyyy.mm.dd' or 'mm.dd.yyyy' or 'dd.mm.yyyy'
decimalseparator = '.';
thousandsseparator = ' ';
currencystr = '';
currencyDigit = 2;
//- config

function trim(str, chars) {
	return ltrim(rtrim(str, chars), chars);
}
function ltrim(str, chars) {
	chars = chars || "\\s";
	return str.replace(new RegExp("^[" + chars + "]+", "g"), "");
}
function rtrim(str, chars) {
	chars = chars || "\\s";
	return str.replace(new RegExp("[" + chars + "]+$", "g"), "");
}
// set select selecteditem
function setSelect(sel,value) {
  for (i=0; i < sel.options.length; i++) {
     sel.options[i].selected = false;
  }
  for (i=0; i < sel.options.length; i++) {
     if (sel.options[i].value == value)
       sel.options[i].selected = 'selected';
  }
}
// set caret position
function setSelectionRange(input, selectionStart, selectionEnd) {
  if (input.setSelectionRange) {
    input.focus();
    input.setSelectionRange(selectionStart, selectionEnd);
  }
  else if (input.createTextRange) {
    var range = input.createTextRange();
    range.collapse(true);
    range.moveEnd('character', selectionEnd);
    range.moveStart('character', selectionStart);
    range.select();
  }
}
function setCaretToPos (input, pos, w) {
  setSelectionRange(input, pos, pos + w);
  return 0;
}
// set form's control value
function setFormValue(formName,fieldName,value) {
   c = eval('document.forms.'+formName+'.'+fieldName);
   if (c != undefined) {
     if (c.nodeName == 'INPUT') {
       if (c.type == 'text') {
         c.value = value;
       }
       if (c.type == 'hidden') {
         c.value = value;
       }
       if (c.type == 'password') {
         c.value = value;
       }
       if (c.type == 'checkbox') {
          c.checked = (value == c.value);
       }
       if (c.type == 'radio') {
          c.checked = (value == c.value);
       }
       if (c.className == 'currency')
         c.value = CRformat(c.value,currencyFigit);
       if (c.className == 'integer')
         c.value = CRformat(c.value,0);
     }
     if (c.nodeName == 'TEXTAREA') {
       c.value = value;
     }
     if (c.nodeName == 'SELECT') {
        setSelect(c,value);
     }
   }
}
// set form's control readOnly
function setReadOnly(formName,fieldName) {
   c = eval('document.forms.'+formName+'.'+fieldName);
   if (c != undefined) {
     if ((c.nodeName == 'INPUT') & (c.className == 'date')) {
        document.getElementById('b_'+c.id).disabled = true;
     }
     if ((c.nodeName == 'INPUT') & (c.readOnly != true)) {
        if (c.type == 'text') {
           c.name = '_'+c.name;
           c.readOnly = true;
           c.className = 'readonly';
           w = document.createElement('INPUT');
           w.type = 'hidden';
           w.name = fieldName;
           w.value = c.value;
           c.parentNode.appendChild(w);
        }
        if (c.type == 'hidden') {
         // eddig is rejtett ezrt read only volt
        }
        if (c.type == 'password') {
           c.name = '_'+c.name;
           c.readOnly = true;
           c.className = 'readonly';
           w = document.createElement('INPUT');
           w.type = 'hidden';
           w.name = fieldName;
           w.value = c.value;
           c.parentNode.appendChild(w);
        }
        if (c.type == 'checkbox') {
           c.name = '_'+c.name;
           c.readOnly = true;
           c.disabled = true;
           c.className = 'readonly';
           if (c.checked) {
             w = document.createElement('INPUT');
             w.type = 'hidden';
             w.name = fieldName;
             w.value = c.value;
             c.parentNode.appendChild(w);
           }
        }
        if (c.type == 'radio') {
           c.name = '_'+c.name;
           c.readOnly = true;
           c.disabled = true;
           c.className = 'readonly';
           if (c.checked) {
             w = document.createElement('INPUT');
             w.type = 'hidden';
             w.name = fieldName;
             w.value = c.value;
             c.parentNode.appendChild(w);
           }
        }
     }
     if ((c.nodeName == 'SELECT') & (c.readOnly != true)) {
           c.name = '_'+c.name;
           c.readonly = true;
           c.disabled = true;
           c.className = 'readonly';
           w = document.createElement('INPUT');
           w.type = 'hidden';
           w.name = fieldName;
           w.value = c.value;
           c.parentNode.appendChild(w);
     }
     if ((c.nodeName == 'TEXTAREA') & (c.readOnly != true)) {
           c.name = '_'+c.name;
           c.readOnly = true;
           c.className = 'readonly';
           w = document.createElement('INPUT');
           w.type = 'hidden';
           w.name = fieldName;
           w.value = c.value;
           c.parentNode.appendChild(w);
     }
     if ((c.nodeName == 'BUTTON') & (c.disabled != true)) {
       c.disabled = 'disabled';
       w = document.createElement('INPUT');
       w.type = 'hidden';
       w.name = fieldName;
       w.value = c.value;
       c.parentNode.appendChild(w);
     }
   }
}
function setReadOnlyAll(formName) {
   var f = document.forms[formName];
   for (i=0; i<f.items.count; i++)
     setReadOnly(formName,f.items[i].name);
}
// ------------ date Edit ------------------------------
// global
dateEditOldValue = '';
dateEditx = -1;
dateEditp1 = 0;
dateEditp2 = 0;
CEblurexit = false;
btn_x=0;
btn_y=0;
function makeDateEdit(formName,fieldName) {
   if (dateEditp1 == 0) {
      if (datemask === 'yyyy.mm.dd') {
         dateEditp1 = 4;
         dateEditp2 = 7;
      } else if (datemax = 'mm.dd.yyyy') {
         dateEditp1 = 2;
         dateEditp2 = 5;
      } else if (datemax = 'dd.dd.yyyy') {
         dateEditp1 = 2;
         dateEditp2 = 5;
      }
   }
   var btn = 0;
   var img = 0;
   var w = 0;
   var ctrl = eval('document.forms.'+formName+'.'+fieldName);
   ctrl.id = ctrl.name;
   ctrl.size=10;
   ctrl.className = 'date';
   ctrl.onfocus = dateEditFocus;
   ctrl.onblur = dateEditBlur;
   ctrl.onclick = dateEditFocus;
   ctrl.onkeyup = dateEditKeyUp;

   btn = document.createElement('BUTTON');
   btn.id = 'b_'+ctrl.id;
   //+IE7 bug
   if (btn.type != 'button') btn.type='button';
   //-IE7 bug
   btn.onmousedown=calendarpopup;
   btn.tabIndex = -1;
   w = ctrl.nextSibling;
   if (w)
     ctrl.parentNode.insertBefore(btn,w);
   else
     ctrl.parentNode.appendChild(btn);
   img = document.createElement('IMG');
   img.src = './images/calendar.gif';
   img.width=20;
   img.height=12;
   btn.appendChild(img);
}
function getYearFromStr(dateStr) {
   if (datemask == 'yyyy.mm.dd') {
     var cy = dateStr.substr(0,4);
   } else if (datemask == 'mm.dd.yyyy') {
     var cy = dateStr.substr(6,4);
   } else if (datemask == 'dd.mm.yyyy') {
     var cy = dateStr.substr(6,4);
   }
   y = Number(cy);
   if (y==NaN) y = 1900;
   return y;
}
function getMonthFromStr(dateStr) {
   if (datemask == 'yyyy.mm.dd') {
     var cm = dateStr.substr(5,2);
   } else if (datemask == 'mm.dd.yyyy') {
     var cm = dateStr.substr(0,2);
   } else if (datemask == 'dd.mm.yyyy') {
     var cm = dateStr.substr(3,2);
   }
   m = Number(cm);
   if (m==NaN) m = 1;
   return m;
}
function getDayFromStr(dateStr) {
   if (datemask == 'yyyy.mm.dd') {
     var cd = dateStr.substr(8,2);
   } else if (datemask == 'mm.dd.yyyy') {
     var cd = dateStr.substr(3,2);
   } else if (datemask == 'dd.mm.yyyy') {
     var cd = dateStr.substr(0,2);
   }
   d = Number(cd);
   if (d==NaN) d = 1;
   return d;
}
function makeDateStr(y,m,d) {
  if (datemask == 'yyyy.mm.dd') {
      var s = '' + y;
      if (m < 10)
        s = s + '.0' + m;
      else
        s = s + '.' + m;
      if (d < 10)
        s = s + '.0' + d;
      else
        s = s + '.' + d;
  }
  if (datemask == 'mm.dd.yyyy') {
      var s = '';
      if (m < 10)
        s = s + '0' + m;
      else
        s = s +  m;
      if (d < 10)
        s = s + '.0' + d;
      else
        s = s + '.' + d;
      s = s + '.' + y;
  }
  if (datemask == 'dd.mm.yyyy') {
      var s = '';
      if (d < 10)
        s = s + '0' + d;
      else
        s = s + d;
      if (m < 10)
        s = s + '.0' + m;
      else
        s = s + '.' + m;
      s = s + '.' + y;
  }
  return s;
}
function DEcheck(newValue) {
   // newvalue is corect?
   newValue = trim(newValue);
   if (newValue == '')
      return true;
   var ok = true;
   var y = getYearFromStr(newValue);
   var m = getMonthFromStr(newValue);
   var d = getDayFromStr(newValue);
   var gDays=[31,31,28,31,30,31,30,31,31,30,31,30,31];
   gDays[2]=y%4==0&&y%100!=0||y%400==0?'29':'28';
   if (y<1000||y>2100||m<1||m>12||d<1||d>gDays[m])
      ok=false;
   for (var i=0; (i<newValue.length)&&(i<datemask.length); i++) {
     if ((datemask.substr(i,1)!='y')&&
         (datemask.substr(i,1)!='m')&&
         (datemask.substr(i,1)!='d')&&
         (datemask.substr(i,1)!=newValue.substr(i,1)))
         ok=false;
   };
   return ok;
}
function dateEditFocus(event) {
    var ctrl = 0;
   if (event == undefined)
      event = window.event;
   if (this != undefined)
      ctrl = this;
   else
      ctrl = event.target;
   if (ctrl.value == '') ctrl.value = ' ';
   dateEditOldValue = ctrl.value;
   dateEditx = 0;
   setCaretToPos(ctrl, dateEditx, 1);

}
function dateEditBlur(event) {
   var ctrl = 0;
   if (event == undefined)
     event = window.event;
   if (this != undefined)
      ctrl = this;
   else
      ctrl = event.target;
   ctrl.value = trim(ctrl.value);
   if (!DEcheck(ctrl.value)) {
        ctrl.value = dateEditOldValue;
   }
   if (!DEcheck(ctrl.value)) {
        alert('Hibs dtum adat.'+ctrl.value+
              '\nDtum beirsnl CSAK a szmjegy gombokat hasznlja!\nA mez tartalma a DEL gombbal trlhet');
        setTimeout('document.forms.'+ctrl.form.name+'.'+ctrl.name+'.focus();',100);      
   }
}
function dateEditKeyUp(event) {
   var ctrl = '';
   var s = '';
   var y = 0;
   var m = 0;
   var d = 0;
   if (event == undefined)
     event = window.event;
   if (this != undefined)
      ctrl = this;
   else
      ctrl = event.target;
   var k = event.keyCode;
   if (ctrl.value.length < dateEditOldValue.length) {
      // trls
      ctrl.value = ' ';
      dateEditOldValue = ' ';
      dateEditx = 0;
      setCaretToPos(ctrl, dateEditx, 1);
      return;
   }
   if (ctrl.value == '')
      ctrl.value = ' ';
   if (ctrl.value.length == dateEditp1)
      ctrl.value = ctrl.value + '.';
   if (ctrl.value.length == dateEditp2)
      ctrl.value = ctrl.value + '.';
   if (k == 37) {
      //LEFT
      if (dateEditx > 0)
         dateEditx = dateEditx - 1;
      if (dateEditx == dateEditp1)
         dateEditx = dateEditx - 1;
      if (dateEditx == dateEditp2)
         dateEditx = dateEditx - 1;
   } else if (k == 38) {
      //UP
      y = getYearFromStr(ctrl.value);
      m = getMonthFromStr(ctrl.value);
      d = getDayFromStr(ctrl.value);
      if (dateEditx < 5)
         y = y + 1;
      else if (dateEditx < 8)
         m = m + 1 ;
      else
         d = d + 1;
      if (m > 12) m = 12;
      if (d > 31) d = 31;
      s = makeDateStr(y,m,d);
      ctrl.value = s;
   } else if (k == 39) {
      //RIGHT
      if (dateEditx < ctrl.value.length - 1)
         dateEditx = dateEditx + 1;
      if (dateEditx == dateEditp1)
         dateEditx = dateEditx + 1;
      if (dateEditx == dateEditp2)
         dateEditx = dateEditx + 1;
   } else if (k == 40) {
      //DOWN
      y = getYearFromStr(ctrl.value);
      m = getMonthFromStr(ctrl.value);
      d = getDayFromStr(ctrl.value);
      if (dateEditx < 5)
         y = y - 1;
      else if (dateEditx < 8)
         m = m - 1 ;
      else
         d = d - 1;
      if (y < 1900) y = 1900;
      if (m < 1) m = 1;
      if (d < 1) d = 1;
      s = makeDateStr(y,m,d);
      ctrl.value = s;
   } else if (k == 35) {
      //END
      dateEditx = 9;
   } else if (k == 36) {
      //HOME
      dateEditx = 0;
   } else if (k == 9) {
      //TAB
      ;
   } else if (k==67) {
        // "C"
      ctrl.value = ' ';
      dateEditOldValue = ' ';
      dateEditx = 0;
      setCaretToPos(ctrl, dateEditx, 1);
   } else {
      if (dateEditx < 9)
         dateEditx = dateEditx + 1;
      if (dateEditx == dateEditp1)
         dateEditx = dateEditx + 1;
      if (dateEditx == dateEditp2)
         dateEditx = dateEditx + 1;
   }
   dateEditOldValue = ctrl.value;
   if (ctrl.value.length < dateEditx + 1)
     ctrl.value = ctrl.value + ' ';
   setCaretToPos(ctrl, dateEditx, 1);
}
function calendarpopup(event){
  var ctrl = '';
  var x = 0;
  var y = 0;
  if (event == undefined)
     event = window.event;
  if (this != undefined)
      ctrl = this;
  else
      ctrl = event.target;
  var id = ctrl.id.substr(2,50);
  ctrl = document.getElementById(id);
  var formname = ctrl.form.name;
  var sdate = ctrl.value;
  // get position of screen
  var btn_x = event.screenX;
  var btn_y = event.screenY;
  // calculate position in window
  if (window.screenLeft != undefined) {
    x = btn_x - window.screenLeft;
    y = btn_y - window.screenTop;
  } else {
    x = btn_x - window.screenX;
    y = btn_y - window.screenY;
  }
  // calculate position in window's inner area
  if (window.outerWidth != undefined) {
    x = x - (window.outerWidth - window.innerWidth);
    y = y - (window.outerHeight - window.innerHeight);
  } else {
    y = y - 100;
  }
  // calculate position in document
  if( typeof( window.pageYOffset ) == 'number' ) {
      //Netscape compliant
      x = x + window.pageXOffset;
      y =  y + window.pageYOffset;
  } else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
      //DOM compliant
      x = x + document.body.scrollLeft;
      y = y + document.body.scrollTop;
  } else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
      //IE6 standards compliant mode
      x = x + document.documentElement.scrollLeft;
      y = y + document.documentElement.scrollTop;
  }
  // get year on mount in date string
  var cy = ctrl.value.substr(0,4);
  var cm = ctrl.value.substr(5,2);
  // show popup calendar
  if (cm > 0) cm = cm - 1;
  var surl = 'calendar.html?'+formname+'.'+ctrl.id+'&'+cm+','+cy;
  popup(surl, x, y, 310, 250);
  return true;
}
// Currency Edit
function makeCurrencyEdit(formName,fieldName) {
   var ctrl = eval('document.forms.'+formName+'.'+fieldName);
   ctrl.id = ctrl.name;
   ctrl.size=16;
   ctrl.className = 'currency';
   ctrl.style.textAlign = 'right';
   ctrl.onfocus = CEfocus;
   ctrl.onblur = CEblur;
   ctrl.onkeyup = CEkeyUp;
   ctrl.value = CEformat(ctrl.value,currencyDigit);
}
function makeIntegerEdit(formName,fieldName) {
   var ctrl = eval('document.forms.'+formName+'.'+fieldName);
   ctrl.id = ctrl.name;
   ctrl.size=16;
   ctrl.className = 'integer';
   ctrl.style.textAlign = 'right';
   ctrl.onfocus = CEfocus;
   ctrl.onblur = CEblur;
   ctrl.onkeyup = CEkeyUp;
   ctrl.value = CEformat(ctrl.value,0);
}
function CEcheck(newvalue) {
   var ok = true;
   var mindb=0;
   var pontdb=0;
   if (newvalue == '')
      return true;
   for (var i=0; i < newvalue.length; i++) {
     if (newvalue.substr(i,1)=='.') pontdb++;
     if (newvalue.substr(i,1)=='-') mindb++;
     if ((newvalue.substr(i,1) < '0')||
         (newvalue.substr(i,1) > '9')) {
        if ((newvalue.substr(i,1) != '-')&&
            (newvalue.substr(i,1) != '.'))
          ok=false;
     }
   };
   if (mindb>1) ok=false;
   if (pontdb>1) ok=false;
   if ((mindb==1)&&(newvalue.substr(0,1)!='-')) ok=false;
   return ok;
};
function CEgoodvalue(newvalue) {
  if (CEcheck(newvalue)) {
    return newvalue;
  } else {
    return '0';
  }
};
function CEfocus(event){
  if (event == undefined)
     event = window.event;
  if (this != undefined)
      ctrl = this;
  else
      ctrl = event.target;
  ctrl.value = CEreverseFormat(ctrl.value);
  if ((ctrl.className == 'currency') & (currencyDigit > 0))
     setCaretToPos(ctrl, ctrl.value.length - currencyDigit - 1, 0);
  else
     setCaretToPos(ctrl, ctrl.value.length, 0);
  return true;
};
function CEblur(event){
  if (event == undefined)
     event = window.event;
  if (this != undefined)
      ctrl = this;
  else
      ctrl = event.target;
 var newvalue = ctrl.value;
 if (CEcheck(newvalue)) {
     if (ctrl.className == 'currency')
        ctrl.value = CEformat(newvalue,2);
     else
        ctrl.value = CEformat(newvalue,0);
 } else {
        alert('Hibs szm adat');
        ctrl.focus();
 };
 return true;
}
function CEkeyUp(event){
  if (event == undefined)
     event = window.event;
  if (this != undefined)
      ctrl = this;
  else
      ctrl = event.target;
  var c = event.keyCode;
  ctrl.value = ctrl.value.replace(/,/g,'.');
  if (c==46) {
        // "DEL"
        ctrl.value = '';
        newvalue = '';
  }
  if (c==67) {
        // "C"
        ctrl.value = '';
        newvalue = '';
  }
  if (c==9) {
        // "TAB"
        ctrl.value = CEreverseFormat(ctrl.value);
        if ((ctrl.className == 'currency') & (currencyDigit > 0))
             setCaretToPos(ctrl, ctrl.value.length - currencyDigit - 1, 0);
        else
             setCaretToPos(ctrl, ctrl.value.length, 0);
  }
  return true;
}
function CEformat(val,digit) {
  if (val == "") return "";
  var floatVal = parseFloat(val);
  var valMoney = '';
  var val = '';
  if (isNaN(floatVal)) floatval = 0.0;
  if (digit>0) {
    valMoney = floatVal.toFixed(digit);
  } else {
    valMoney = floatVal.toFixed(1);
  }
  var valSep   = valMoney.toString().split(".");
  var theNum   = valSep[0].toString();
  var theCents = valSep[1].toString();
  var fmt      = new Array();
  var l        = theNum.length;
  var i        = 1;
  for(i=1; i<l+1; i++) {
	fmt[i] = theNum.charAt(i-1);
  }
  fmt = fmt.reverse();
  for(i=1; i<l; i++) {
    if (i%3 == 0) fmt[i] += thousandsseparator;
  }
  while (theCents.length < digit) thecents = thecents + '0';
  if (digit>0) {
     val = fmt.reverse().join("") + decimalseparator + theCents;
  } else {
     val = fmt.reverse().join("");
  }
  return val + currencystr;
}
function CEreverseFormat(fmt) {
  if (fmt == "") return "";
  var noFormat = "";
  var format   = fmt.toString();
  var l        = fmt.length;
  var i        = 0;
  var wcurrencystr = currencystr + '@';
  for (i=0; i<l && format.charAt(i)!=wcurrencystr.charAt(0); i++){
    if (format.charAt(i) != thousandsseparator) {
       	noFormat += format.charAt(i);
    }
  }
  return noFormat;
}