<?php
session_start();
global $config,$db,$q;
include_once('./config.php');
include_once('./mysqldb.php');
include_once('./login.php');
include_once('./header.php');

function charset_decode_utf_8($string) {
    /* Only do the slow convert if there are 8-bit characters */
    /* avoid using 0xA0 (\240) in ereg ranges. RH73 does not like that */
    /* HTML &####; kodokat is szri */
    if (ereg("[\200-\237]", $string) or  ereg("[\241-\377]", $string)) {
      // decode three byte unicode characters
      $string = preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e",
      "'&#'.((ord('\\1')-224)*4096 + (ord('\\2')-128)*64 + (ord('\\3')-128)).';'",
      $string);

      // decode two byte unicode characters
      $string = preg_replace("/([\300-\337])([\200-\277])/e",
      "'&#'.((ord('\\1')-192)*64+(ord('\\2')-128)).';'",
      $string);
    }
    $string = html_entity_decode($string);

    $string = str_replace(chr(192),'',$string);
    $string = str_replace(chr(194),'',$string);
    $string = str_replace(chr(195),'',$string);
    $string = str_replace(chr(196),'',$string);
    $string = str_replace(chr(197),'',$string);

    $string = str_replace(chr(200),'',$string);
    $string = str_replace(chr(202),'',$string);
    $string = str_replace(chr(203),'',$string);

    $string = str_replace(chr(204),'',$string);
    $string = str_replace(chr(206),'',$string);
    $string = str_replace(chr(207),'',$string);

    $string = str_replace(chr(210),'',$string);
    $string = str_replace(chr(212),'',$string);

    $string = str_replace(chr(213),'',$string);

    $string = str_replace(chr(217),'',$string);
    $string = str_replace(chr(219),'',$string);

    $string = str_replace(chr(224),'',$string);
    $string = str_replace(chr(226),'',$string);
    $string = str_replace(chr(227),'',$string);
    $string = str_replace(chr(228),'',$string);
    $string = str_replace(chr(229),'',$string);

    $string = str_replace(chr(232),'',$string);
    $string = str_replace(chr(234),'',$string);
    $string = str_replace(chr(235),'',$string);

    $string = str_replace(chr(236),'',$string);
    $string = str_replace(chr(238),'',$string);
    $string = str_replace(chr(239),'',$string);

    $string = str_replace(chr(242),'',$string);
    $string = str_replace(chr(244),'',$string);

    $string = str_replace(chr(249),'',$string);
    $string = str_replace(chr(251),'',$string);

    $string = str_replace(chr(251),'',$string);
    $string = str_replace(chr(245),'',$string);

    return $string;
}
function echoFilter($filter,$nev) {
  $i = stripos($filter,"fl.".$nev." ");
  if ($i === false)
    echo '<input type="checkbox" name="'.$nev.'" value="X">';
  else
    echo '<input type="checkbox" name="'.$nev.'" checked="checked" value="X">';
}
function csakszam($be) {
  $ki = '';
  for ($i=0; $i < strlen($be); $i++) {
    if ((substr($be,$i,1) >= '0') &
        (substr($be,$i,1) <= '9'))
       $ki .= substr($be,$i,1);
  }
  return $ki;
}
//be: karakteres FAX szm a "szoksos" irsmdokban
//ki: kknn..nn  ahol kk a krzetszm jobbra igazitva
//                    nn..nn a fax szm
function faxJavito($be) {
       $oldFax = csakszam(trim($be));
       $javFax = '  '.$oldFax;
       $javKorzet = '';
       // 36 vagy 06 eltvoltsa
       if ((strlen($oldFax)==10) &
           ((substr($oldFax,0,2)=='06') | (substr($oldFax,0,2)=='36')))
         $oldFax = substr($oldFax,2,8);
       // krzetszm kiemelse
       if (strlen($oldFax)==7)  {
         // Budapest krzet nlkl
         $javKorzet = ' 1';
         $jacvax = trim($oldfax);
       } else if (strlen($oldFax)==8)  {
         if (substr($oldFax,0,1)=='1') {
            // Budapest krzetszmmal
            $javKorzet = ' 1';
            $javFax = substr($oldFax,1,7);
         } else {
            // vidki krzetszmmal
            $javKorzet = substr($oldFax,0,2);
            $javFax = substr($oldFax,2,6);
         }
       }
       return $javKorzet.$javFax;
}

$act = getPOST('act');
if ($act == '') {
   // kperny kirajzols
   echo '<h2>Konferencia jelentkezk adatainak ttltse a kampny adatbzisokba</h2>'."\n";
    echo '<h3>Figyelem az adat ttltssel dupla FAX szmok '.
         's dupla e-mail cmek kerlhetnek a kampny tblzatokba.</h3>';
    echo '<h3>Ellenrizni javtani kell !!!</h3>';
   echo '<p>Vlassza ki a konferencit, aminek az '.
        'adatait t kell tlteni a kampny adatbzisokba!</p>';
   echo '<p>Fontos, hogy a FAX szmoknl a krzetszm kln legyen vlasztva!</p>';
   echo '<p>Ezen kivl meg kell adni a "szakma kdokat" is.</p>';
   echo '<p>A program csak az j FAX szmokat s E-mail cimeket tlti t, ';
   echo '<form name="frmfilter" action="./kampanyhoz.php" method="post">'."\n";
   echo '<input type="hidden" name="act" value="doatad">'."\n";
   echo '<var>Konferencia:</var>'."\n";
   echo '<select name="konfid">'."\n";
    $q->sql = 'select k_id, k_ido, k_cim from '.$config['dbpre'].'konferenciak order by k_ido';
    $q->open();
    if ($q->recordCount > 0) {
      $q->first();
      while (!$q->eof) {

        echo '<option value="'.$q->fields[0]->value.'">'.
            '('.$q->fields[0]->value.') '.
            charset_decode_utf_8(substr($q->fields[1]->value.' '.$q->fields[2]->value,0,100)).'</option>'."\n";

        $q->next();
      }
    }
    $q->close();
    echo '</select><br>'."\n";
    echo '<p>Szakma kdok:'."\n";
    $filter = '';
    echo '<p>'."\n";
    echoFilter($filter,'tax'); echo 'Ad ';
    echoFilter($filter,'kozbeszerz'); echo 'Kzbeszerzs ';
    echoFilter($filter,'onkormanyzat'); echo 'nkormnyzat ';
    echoFilter($filter,'tanugyig'); echo 'Tangy ';
    echoFilter($filter,'munkaugy'); echo 'Munkagy ';
    echoFilter($filter,'jegyzo'); echo 'Jegyz ';
    echoFilter($filter,'okmanyiroda'); echo 'Okmnyiroda ';
    echo '<br />';
    echoFilter($filter,'termekdij'); echo 'Termkdj ';
    echoFilter($filter,'tartalek2'); echo 'Szakkpzs ';
    echoFilter($filter,'tartalek3'); echo 'Tartalk3 ';
    echoFilter($filter,'tartalek4'); echo 'Tartalk4 ';
    echoFilter($filter,'tartalek5'); echo 'Tartalk5 ';
    echo '</p>'."\n";
    $url = "'index.php'";
    echo '<p style="text-align:right"><button type="submit"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
    echo '<button type="button" onclick="location='.$url.'"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
    echo '</form>';
}
if ($act == 'doatad') {
   // adat tads vgrehajtsa
    echo '<h2>Figyelem az adat ttltssel dupla FAX szmok '.
         's dupla e-mail cmek kerlhettek a kampny tblzatokba.</h2>';
    echo '<h2>Ellenrizni javtani kell !!!</h2>';
   $konfid = getPOST('konfid');
   $tax = getPOST('tax');
   $kozbeszerz = getPOST('kozbeszerz');
   $munkaugy = getPOST('munkaugy');
   $tanugyig = getPOST('tanugyig');
   $onkormanyzat = getPOST('onkormanyzat');
   $jegyzo = getPOST('jegyzo');
   $okmanyiroda = getPOST('okmanyiroda');
   $termekdij = getPOST('termekdij');
   $tartalek1 = getPOST('tartalek1');
   $tartalek2 = getPOST('tartalek2');
   $tartalek3 = getPOST('tartalek3');
   $tartalek4 = getPOST('tartalek4');
   $tartalek5 = getPOST('tartalek5');

   // FAX szm standartizls
   $q2 = new Tquery('q2',$db);
   $q->sql = 'select fax,korzet,id from '.$config['dbpre'].konfadmin.' '.
             'where konfid = '.$konfid.' and fax <> "" and korzet = "" '.
             'order by 1';
   $q->open();
   if ($q->recordCount > 0) {
     $q->first();
     while (!$q->eof) {
       $newFax = faxJavito($q->fields[0]->value);
       $javKorzet = trim(substr($newFax,0,2));
       $javFax = trim(substr($newFax,2,10));
       $q2->sql = 'update '.$config['dbpre'].'konfadmin '.
                  'set fax="'.$javFax.'",korzet="'.$javKorzet.'" '.
                  'where id='.$q->valuebyname('id');
       $q2->execsql();
       echo '<p>FAX szm javits '.$q->fields[0]->value.
            ' --&gt;  '.$javKorzet.' / '.$javFax.' '.$lastError.'</p>';
       $q->next();
     }
   }
   $q->close();
   echo '<hr />'."\n";

   // ----------------- email listba betlts --------------
   // munkatbla azokrol az email cimekrl amik mr megvannak
   $q->sql = 'drop table if exists '.$config['dbpre'].'worktabla';
   $q->execsql();
   $q->sql = 'create table '.$config['dbpre'].'worktabla '.
             'select distinct k.email '.
             'from '.$config['dbpre'].'konfadmin k '.
             'inner join '.$config['dbpre'].'emaillista e '.
             '     on  k.email = e.email '.
             'where k.email <> "" and k.konfid = '.$konfid;
   $q->execsql();
   if ($lastError != '') echo '<p>E-mail munka tbla ltrehozs '.$lastError.'</p>'."\n";
   // hny j email cim van?
   $q->sql = 'select k.email '.
             'from '.$config['dbpre'].'konfadmin k '.
             'left outer join '.$config['dbpre'].'worktabla w '.
             '  on w.email = k.email '.
             'left outer join '.$config['dbpre'].'konferenciak kon '.
             '  on kon.k_id = k.konfid '.
             'where w.email is null and k.email <> "" and k.konfid = '.$konfid;
   $q->open();
   $darab = $q->recordCount;
   $q->close();
   // j email cimek insert
   $q->sql = 'insert into '.$config['dbpre'].'emaillista '.
	         '(email, cegnev, ugyfel, beosztas,	irsz, varos, cim, tel, '.
             'korzet, fax,konferencia, '.
             'tax, kozbeszerz, munkaugy, '.
	         'tanugyig, onkormanyzat, jegyzo, okmanyiroda, termekdij, '.
             'tartalek1, tartalek2, tartalek3, tartalek4,tartalek5,forras,lakcim) '.
             'select '.
             'k.email, k.cegnev, k.nev, k.beosztas, k.irsz, k.varos, k.cim, k.tel, '.
             'k.korzet, k.fax, kon.k_ido, '.
             "'$tax', '$kozbeszerz', '$munkaugy', ".
	         "'$tanugyig', '$onkormanyzat', '$jegyzo', '$okmanyiroda', '$termekdij', ".
             "'$tartalek1', '$tartalek2', '$tartalek3', '$tartalek4', '$tartalek5','' forras,k.lakcim ".
             'from '.$config['dbpre'].'konfadmin k '.
             'left outer join '.$config['dbpre'].'worktabla w '.
             '  on w.email = k.email '.
             'left outer join '.$config['dbpre'].'konferenciak kon '.
             '  on kon.k_id = k.konfid '.
             'where w.email is null and k.email <> "" and k.konfid = '.$konfid;
    $q->execsql();
    if ($lastError != '')
      echo '<p>E-mail ttlts '.$lastError.'</p>'."\n";
    else
      echo '<p>'.$darab.' j E-mail cim betltve a kampny adatbzisba.</p>';
    // munkatbla drop
    $q->sql = 'drop table if exists '.$config['dbpre'].'worktabla';
    $q->execsql();
    // ----------------- FAX listba betlts --------------
   // munkatbla azokrol a FAX szmokrl amik mr megvannak
   $q->sql = 'drop table if exists '.$config['dbpre'].'worktabla';
   $q->execsql();
   $q->sql = 'create table '.$config['dbpre'].'worktabla '.
             'select distinct k.fax, k.korzet '.
             'from '.$config['dbpre'].'konfadmin k '.
             'inner join '.$config['dbpre'].'faxlista f '.
             '  on k.fax = f.fax and k.korzet = f.korzet '.
             'where  k.fax <> ""  and k.konfid = '.$konfid;
   $q->execsql();
   if ($lastError != '') echo '<p>FAX munka tbla ltrehozs '.$lastError.'</p>'."\n";
   // hny j FAX cim van?
   $q->sql = 'select k.fax '.
             'from '.$config['dbpre'].'konfadmin k '.
             'left outer join '.$config['dbpre'].'worktabla w '.
             '  on w.fax = k.fax and w.korzet = k.korzet '.
             'left outer join '.$config['dbpre'].'konferenciak kon '.
             '  on kon.k_id = k.konfid '.
             'where w.fax is null and k.fax <> "" and k.konfid = '.$konfid;
   $q->open();
   $darab = $q->recordCount;
   $q->close();
   // j FAX cimek insert
   $q->sql = 'insert into '.$config['dbpre'].'faxlista '.
	         '(email, cegnev, ugyfel, beosztas,	irsz, varos, cim, tel, '.
             'korzet, fax,konferencia, '.
             'tax, kozbeszerz, munkaugy, '.
	         'tanugyig, onkormanyzat, jegyzo, okmanyiroda, termekdij, '.
             'tartalek1, tartalek2, tartalek3, tartalek4,tartalek5,forras) '.
             'select '.
             'k.email, k.cegnev, k.nev, k.beosztas, k.irsz, k.varos, k.cim, k.tel, '.
             'k.korzet, k.fax, kon.k_ido, '.
             "'$tax', '$kozbeszerz', '$munkaugy', ".
	         "'$tanugyig', '$onkormanyzat', '$jegyzo', '$okmanyiroda', '$termekdij', ".
             "'$tartalek1', '$tartalek2', '$tartalek3', '$tartalek4', '$tartalek5','' forras ".
             'from '.$config['dbpre'].'konfadmin k '.
             'left outer join '.$config['dbpre'].'worktabla w '.
             '  on w.fax = k.fax and w.korzet = k.korzet '.
             'left outer join '.$config['dbpre'].'konferenciak kon '.
             '  on kon.k_id = k.konfid '.
             'where w.fax is null and k.fax <> "" and k.konfid = '.$konfid;
    $q->execsql();
    if ($lastError != '')
      echo '<p>FAX ttlts '.$lastError.'</p>'."\n";
    else
      echo '<p>'.$darab.' j FAX szm betltve a kampny adatbzisba.</p>';
    // munkatbla drop
    $q->sql = 'drop table if exists '.$config['dbpre'].'worktabla';
    $q->execsql();
}
include_once('./footer.php');
?>

