<?php
  /*
  Delphi dataset szer szintaxist megvalsit mysql interface
  Required PHP5
  Szerz : Fogler Tibor   foglert@robitbt.hu
           2008.03.11
  Licensz: GNU/GPL

  classes:

  Tdatabase
    $databaseName;
    $user;
    $password;
    $host;
    $charSet;
    $connected;
    connect();
    disconnect();
  Tfield
    $name;
    $value;
    $displayLabel;
    $uniqueId
    $autoInc
    $visible
  Tquery(name,database)
    $name;
    $database;
    $sql;
    $state;
    $fields;  (array of Tfield)
    $eof;
    $bof;
    $recordCount;
    $fieldCount;
    setparams(pnev,pvalue);
    open();
    close();
    execsql();
    first();
    last();
    next();
    previos();
    bm := getbookmark();
    gotobookmark();
    field = fieldbyname('fieldnev');
  Ttable extends Tquery
    tableName
    filtered
    filter
    indexfields
    readOnly
    edit()
    append()
    post()
    cancel()
    putToPOST()
    putToSESSION()
    getFromPOST()
    getFromSESSION()
    edhoDataForm()
  other functions
    getPOST(name)
    getGET(name)
    getSESSION(name)


*/
global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError,$debugLevel;
$dsClosed = 0;
$dsBrowse = 1;
$dsInsert = 2;
$dsEdit = 3;
$lastError = '';
$debugLevel = 'ERROR';
//$debugLevel = 'ALL';
//$debugLevel = 'NONE';
if (! is_dir('./teszt')) mkdir('./teszt',0777);

// load php module
if (!defined('PMA_PHP_INT_VERSION')) {
    if (!ereg('([0-9]{1,2}).([0-9]{1,2}).([0-9]{1,2})', phpversion(), $match)) {
        $result = ereg('([0-9]{1,2}).([0-9]{1,2})', phpversion(), $match);
    }
    if (isset($match) && !empty($match[1])) {
        if (!isset($match[2])) {
            $match[2] = 0;
        }
        if (!isset($match[3])) {
            $match[3] = 0;
        }
        define('PMA_PHP_INT_VERSION', (int)sprintf('%d%02d%02d', $match[1], $match[2], $match[3]));
        unset($match);
    } else {
        define('PMA_PHP_INT_VERSION', 0);
    }
    define('PMA_PHP_STR_VERSION', phpversion());
}
if (!defined('PMA_MYSQL_CLIENT_API')) {
    if (function_exists('mysql_get_client_info')) {
        $client_api = mysql_get_client_info();
    } else {
        // for compatibility with php <= 4.0.5
        // expect the worst!
        $client_api = '3.21.0';
    }
    $client_api = explode('.', $client_api);
    define('PMA_MYSQL_CLIENT_API', (int)sprintf('%d%02d%02d', $client_api[0], $client_api[1], intval($client_api[2])));
    unset($client_api);
}
if (!defined('PMA_IS_WINDOWS')) {
    if (defined('PHP_OS') && eregi('win', PHP_OS)) {
        define('PMA_IS_WINDOWS', 1);
    } else {
        define('PMA_IS_WINDOWS', 0);
    }
}
function PMA_dl($module) {
    if (!isset($GLOBALS['PMA_dl_allowed'])) {
        if (((PMA_PHP_INT_VERSION >= 40000 && !@ini_get('safe_mode') && @ini_get('enable_dl'))
            || (PMA_PHP_INT_VERSION < 40000 && PMA_PHP_INT_VERSION > 30009 && !@get_cfg_var('safe_mode')))
            && @function_exists('dl')) {

            ob_start();
            phpinfo(INFO_GENERAL);
            $a = strip_tags(ob_get_contents());
            ob_end_clean();
            if (ereg('Thread Safety[[:space:]]*enabled', $a)) {
                if (ereg('Server API[[:space:]]*\(CGI\|CLI\)', $a)) {
                    $GLOBALS['PMA_dl_allowed'] = TRUE;
                } else {
                    $GLOBALS['PMA_dl_allowed'] = FALSE;
                }
            } else {
                $GLOBALS['PMA_dl_allowed'] = TRUE;
            }
        } else {
            $GLOBALS['PMA_dl_allowed'] = FALSE;
        }
    }
    if (PMA_IS_WINDOWS) {
        $suffix = '.dll';
    } else {
        $suffix = '.so';
    }
    if ($GLOBALS['PMA_dl_allowed']) {
        return @dl($module . $suffix);
    } else {
        return FALSE;
    }
}
if (!@function_exists('mysql_connect')) {
    if (PMA_PHP_INT_VERSION < 40000) {
        $extension = 'MySQL';
    } else {
        $extension = 'mysql';
    }
    PMA_dl($extension);
}

class Tdatabase {
   var $databaseName;
   var $user;
   var $password;
   var $host;
   var $charSet;
   var $connected;
   var $h = 0;


  function Tdatabase() {
   // ============ C O N F I G U R E ====================
   $this->databasename = 'test';
   $this->user = 'root';
   $this->password = '';
   $this->host = 'localhost';
   $this->charSet = '';
   $this->connected = false;
   $this->h = 0;
   // ============ C O N F I G U R E =====================
  }
  function connect() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError,$debugLevel;
    $this->h = mysql_connect($this->host,$this->user,$this->password);
    $lastError = mysql_error();
    if ($this->charSet != '')
      $r = mysql_query("SET CHARACTER SET ".$this->charSet);
    $lastError .= '/'.mysql_error();
    mysql_select_db($this->databasename);
    $lastError .= '/'.mysql_error();
    if ($lastError == '//') $lastError = '';
    $this->connected = true;
    $s = '';
    if (($debugLevel == 'ERROR') & ($lastError != ''))
         $s = $lastError;
    if ($debugLevel == 'ALL')
         $s = $lastError;
    if ($s != '')
       echo '<script type="text/Javascript">alert("'.$s.'");</script>';
  }
  function disconnect() {
     @mysql_close();
     $this->connected = false;
  }
}

class Tfield {
  var $name;
  var $value;
  var $displayLabel;
  var $uniqueId;
  var $autoIc;
  var $visible;
  var $align;
  function Tfield() {
   $this->name = '';
   $this->value = '';
   $this->displayLabel = '';
   $this->uniqueId = false;
   $this->autoInc =false;
   $this->visible = true;
   $this->align = 'LEFT';
  }
}

class Tquery {
  //public
  var $name;
  var $database;
  var $sql;
  var $state;
  var $fields;
  var $eof;
  var $bof;
  var $recordCount;
  var $fieldCount;
  // private
  var $params;
  var $rows;
  var $row;
  var $h;
  function Tquery($name,&$database) {
   global $dsClosed,$dsBrowse,$lastError;
   $this->name = $name;
   $this->database = $database;
   $this->sql = '';
   $this->state = $dsClosed;
   $this->fields = array();
   $this->eof = true;
   $this->bof = true;
   $this->recordCount = 0;
   $this->fieldCount = 0;
   $this->params = array();
   $this->rows = array();
   $this->row = -1;
   $this->h = 0;
  }

  function setparams($paramName,$paramValue) {
    array_push($this->params, array());
    $this->params[count($this->params) - 1][0] = $paramName;
    $this->params[count($this->params) - 1][1] = $paramValue;
  }
  function execsql() {
    global $dsClosed,$dsBrowse,$lastError,$debugLevel;
    $sql = $this->changeParams();
    //$qr = split(";\n",$sql);   az &xxxx; kodok miatt nem j!
    $qr = array();
    $qr[] = $sql;
    foreach($qr as $qry) {
      if(trim($qry)) {
        mysql_query(trim($qry),$this->database->h);
        $lastError = mysql_error();
        if (file_exists('./teszt.ini')) {
          $fp = fopen('./teszt.sql','w+');
          fwrite($fp,$qry);
          fwrite($fp,$lastError);
          fclose($fp);
        }
      }
    }
    $lastError = mysql_error();
    $s = '';
    if (($debugLevel == 'ERROR') & ($lastError != ''))
         $s = $lastError.' '.$this->sql;
    if ($debugLevel == 'ALL')
         $s = $lastError.' '.$this->sql;
    if ($s != '')
       echo '<script type="text/Javascript">alert("'.$s.'");</script>';
  }
  function qopen() {
    global $dsClosed,$dsBrowse,$lastError,$debugLevel;
    $this->recordCount = 0;
    $sql = $this->changeParams();
    if (file_exists('./teszt.ini')) {
        $fp = fopen('./teszt.sql','w+');
        fwrite($fp,$sql);
        fclose($fp);
    }
    $this->h = mysql_query($sql,$this->database->h);
    $lastError = mysql_error();
    array_splice ($this->fields, 0);
    if ($lastError == '') {
      // field list feltltse
      $this->fieldCount = mysql_num_fields($this->h);
      $i = 0;
      while ($i < $this->fieldCount) {
    		$meta = mysql_fetch_field($this->h);
    		if ($meta) {
    		   array_push($this->fields, new Tfield());
    		   $this->fields[$i]->name = $meta->name;
    		   $this->fields[$i]->displayLabel = $meta->name;
                  }
  		$i=$i+1;
      };
    }
    // rekordok elrse
    array_splice ($this->rows, 0);
    if ($lastError == '') {
        $record =  mysql_fetch_row($this->h);
        while ($record) {
          array_push($this->rows, $record);
          $record =  mysql_fetch_row($this->h);
        }
        $this->recordCount = count($this->rows);
    }
    $s = '';
    if (($debugLevel == 'ERROR') & ($lastError != ''))
         $s = $lastError.' '.$this->sql;
    if ($debugLevel == 'ALL')
         $s = $lastError.' '.$this->sql;
    if ($s != '')
       echo '<script type="text/Javascript">alert("'.$s.'");</script>';
    $this->state = $dsBrowse;
  }
  function open() {
    $this->qopen();
  }
  function close() {
    global $dsClosed,$dsBrowse,$lastError;
    $this->state = $dsClosed;
    $this->fieldCount = 0;
    $this->row = -1;
    $this->bof = true;
    $this->eof = true;
    array_splice ($this->fields, 0);
    array_splice ($this->rows, 0);
    if ($this->recordCount > 0)
       mysql_free_result($this->h);
    $this->recordCount = 0;
  }
  function first() {
    global $dsClosed,$dsBrowse,$lastError;
    if ($this->state == $dsBrowse) {
      $this->row = 0;
      if ($this->row < $this->recordCount)
        $this->row2fields();
      $this->bof = ($this->row < 0);
      $this->eof = ($this->row >= $this->recordCount);
    }
  }
  function last() {
    global $dsClosed,$dsBrowse,$lastError;
    if ($this->state == $dsBrowse) {
      $this->row = $this->recordCount - 1;
      if (($this->row < $this->recordCount) & ($this->row >= 0))
        $this->row2fields();
      $this->bof = ($this->row < 0);
      $this->eof = ($this->row >= $this->recordCount);
    }
  }
  function next() {
    global $dsClosed,$dsBrowse,$lastError;
    if ($this->state == $dsBrowse) {
      $this->row = $this->row + 1;
      if (($this->row < $this->recordCount) & ($this->row >= 0))
        $this->row2fields();
      $this->bof = ($this->row < 0);
      $this->eof = ($this->row >= $this->recordCount);
    }
  }
  function previos() {
    global $dsClosed,$dsBrowse,$lastError;
    if ($this->state == $dsBrowse) {
      $this->row = $this->row - 1;
      if (($this->row < $this->recordCount) & ($this->row >= 0))
        $this->row2fields();
      $this->bof = ($this->row < 0);
      $this->eof = ($this->row >= $this->recordCount);
    }
  }
  function getbookmark() {
     return $this->row;
  }
  function gotobookmark($bookMark) {
    global $dsClosed,$dsBrowse,$lastError;
    if ($this->state == $dsBrowse) {
      $this->row = $bookMark;
      if (($this->row < $this->recordCount) & ($this->row >= 0))
        $this->row2fields();
      $this->bof = ($this->row < 0);
      $this->eof = ($this->row >= $this->recordCount);
    }
  }
  function fieldbyname($fieldName) {
    global $dsClosed,$dsBrowse,$lastError;
    $i = 0;
    $result = null;
    for ($i=0; $i<$this->fieldCount; $i++) {
      $w = $this->fields[$i];
      if ($w->name == $fieldName)
         $result = $this->fields[$i];
    }
    return $result;
  }
  function valuebyname($fieldName) {
    global $dsClosed,$dsBrowse,$lastError;
    $w = $this->fieldbyname($fieldName);
    return $w->value;
  }
  function setvaluebyname($fieldName,$value) {
    global $dsClosed,$dsBrowse,$lastError;
    $i = 0;
    $j = -1;
    $result = null;
    for ($i=0; $i<$this->fieldCount; $i++) {
      $w = $this->fields[$i];
      if ($w->name == $fieldName) $j = $i;
    }
    if ($j >= 0)
      $this->fields[$j]->value = $value;
    return;
  }
  function row2fields() {
    global $dsClosed,$dsBrowse,$lastError;
    $i = 0;
    if ($this->state == $dsBrowse) {
      for ($i=0; $i<$this->fieldCount; $i++) {
       $this->fields[$i]->value = $this->rows[$this->row][$i];
      }
    }
  }
  function active() {
    global $dsClosed,$dsBrowse,$lastError;
    return ($this->state == $dsBrowse);
  }
  function changeParams() {
    global $dsClosed,$dsBrowse,$lastError;
    // change params in sql
    $result = $this->sql;
    $i = 0;
    for ($i=0; $i < count($this->params); $i++) {
      $paramName = $this->params[$i][0];
      $paramValue = $this->params[$i][1];
      $result = str_replace(':'.$paramName, $paramValue, $result);
    }
    return $result;
  }
  function echoTable() {
    $this->first();
    echo '<table border="1">'."\n";
    echo '  <tr>'."\n";
    for ($j=0; $j < count($this->fields); $j++)
      echo '<th>'.$this->fields[$j]->displayLabel.'</th>'."\n";
    echo '  </tr>'."\n";
    while (!$this->eof) {
    echo '  <tr>'."\n";
      for ($j=0; $j < count($this->fields); $j++)
        echo '<td>'.$this->fields[$j]->value.'</td>'."\n";
      echo '  </tr>'."\n";
      $this->next();
    }
    echo '</table border="1">'."\n";
  }
}
class Ttable extends Tquery {
  var $tableName;
  var $readOnly;
  var $indexFields;
  var $filter;
  var $filtered;
  var $limit;
  var $oldrec;
  function Ttable($name,&$database,$tableName) {
    $this->name = $name;
    $this->database = $database;
    $this->tableName = $tableName;
    $this->indexFields = '';
    $this->filter = '';
    $this->filtered = false;
    $this->limit = '';
    $this->oldrec = array();
    $this->Tquery($name,$database);
  }
  function open() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
    $this->sql = 'select * from '.$this->tableName;
    if ($this->filtered)
      $this->sql .= ' where '.$this->filter;
    if ($this->indexFields != '')
      $this->sql .= ' order by '.$this->indexFields;
    if ($this->limit != '')
      $this->sql .= ' limit '.$this->limit;
    $this->qopen();
  }
  function edit() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
    $this->state = $dsEdit;
    for ($i=0; $i < $this->fieldCount; $i++) {
      $this->oldrec[$this->fields[$i]->name] = $this->fields[$i]->value;
    }
  }
  function append() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
    $this->state = $dsInsert;
    for ($i=0; $i < $this->fieldCount; $i++) {
      $this->fields[$i]->value = '';
    }
  }
  function post() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
    if ($this->state == $dsEdit) {
      // update sql sszelltsa, autoInc, uniqueId mezk nem modosithatak,
      // ha van uniqueId mez akkor ez van a where -ben egybknt az oldrec
      $ID = '';
      $s = 'update '.$this->tableName.' set ';
      for ($i=0; $i < $this->fieldCount; $i++) {
        if ((!$this->fields[$i]->autoInc) &
            (!$this->fields[$i]->uniqueId)) {
           $s .= $this->fields[$i]->name.' = "'.$this->fields[$i]->value.'"';
           if ($i < $this->fieldCount - 1) $s .= ',';
        }
        if ($this->fields[$i]->uniqueId) $ID = $this->fields[$i]->name;
      }
      $s .= ' where ';
      if ($ID == '') {
        for ($i=0; $i < $this->fieldCount; $i++) {
          $s .= $this->fields[$i]->name.' ="'.
             $this->oldrec[$this->fields[$i]->name].'"';
          if ($i < $this->fieldCount - 1) $s .= ' and ';
        }
      } else {
         $s .= $ID.' ="'.$this->oldrec[$ID].'"';
      }
      $this->sql = $s;
    } else if ($this->state == $dsInsert) {
      // insert sql sszellitsa, az autoInc mezk kimaradnak
      $s = 'insert into '.$this->tableName.' (';
      for ($i=0; $i < $this->fieldCount; $i++) {
        if (!$this->fields[$i]->autoInc) {
           $s .= $this->fields[$i]->name;
           if ($i < $this->fieldCount - 1) $s .= ',';
        }
      }
      $s .=') values(';
      for ($i=0; $i < $this->fieldCount; $i++) {
        if (!$this->fields[$i]->autoInc) {
           $s .= '"'.$this->fields[$i]->value.'"';
           if ($i < $this->fieldCount - 1) $s .= ',';
        }
      }
      $s .= ')';
      $this->sql = $s;
    }
    $this->execsql();
    $this->state = $dsBrowse;
  }
  function cancel() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
    $this->state = $dsBrowse;
  }
  function delete() {
      $ID = '';
      $s = 'delete from '.$this->tableName.' where ';
      for ($i=0; $i < $this->fieldCount; $i++) {
        if ($this->fields[$i]->uniqueId) $ID = $this->fields[$i]->name;
        $this->oldrec[$this->fields[$i]->name] = $this->fields[$i]->value;
      }
      if ($ID == '') {
        for ($i=0; $i < $this->fieldCount; $i++) {
          $s .= $this->fields[$i]->name.' ="'.
             $this->oldrec[$this->fields[$i]->name].'"';
          if ($i < $this->fieldCount - 1) $s .= ' and ';
        }
      } else {
         $s .= $ID.' = "'.$this->oldrec[$ID].'"';
      }
      $this->sql = $s;
      $this->execsql();
  }
  function putToSESSION() {
     // sszes mez rtke ->SESSION vars
    for ($i=0; $i < $this->fieldCount; $i++) {
      $_SESSION[$this->fields[$i]->name] = $this->fields[$i]->value;
    }
  }
  function getFromSESSION() {
    for ($i=0; $i < $this->fieldCount; $i++) {
      $this->fields[$i]->value = getSESSION($this->fields[$i]->name);
    }
  }
  function putToPOST() {
    // sszes mez rtke hidden input fieldba
    for ($i=0; $i < $this->fieldCount; $i++) {
      echo '<input type="hidden" name="'.$this->fields[$i]->name.'" '.
           'value="'.$this->fields[$i]->value.'" />'."\n";
    }
  }
  function getFromPOST() {
    for ($i=0; $i < $this->fieldCount; $i++) {
      if (isset($_POST[$this->fields[$i]->name]))
        $this->fields[$i]->value = getPOST($this->fields[$i]->name);
    }
  }
  function echoDataForm() {
    global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
    echo '<table border="0" cellspacing="2" cellpadding="2">'."\n";
    for ($i=0; $i < $this->fieldCount; $i++) {
      $visible = $this->fields[$i]->visible;
      $readonly = $this->readonly;
      if (($this->fields[$i]->iniqueid) & ($this->state != dsInsert))
        $readonly = true;
      if ($this->fields[$i]->autoInc)
        $readonly = true;
      if ($visible) {
        if (!$readonly)
          echo '<tr><td align="right" class="label">'.
               $this->field[$i]->displayLabel.'</td>'.
               '<td align=left" class="data">'.
               $this->field[$i]->value.'</td></tr>'."\n";
        else
          echo '<tr><td align="right" class="label">'.
               $this->field[$i]->displayLabel.'</td>'.
               '<input type="text" name="'.
               $this->fields[$i]->name.'" value="'.
               $this->field[$i]->value.'" /></td></tr>'."\n";
      }
    }
    echo '</table>'."\n";
    for ($i=0; $i < $this->fieldCount; $i++) {
      $visible = $this->fields[$i]->visible;
      if (!$visible)
        echo '<input type="hidden" name="'.$this->fields[$i]->name.'" '.
             'value="'.$this->fields[$i]->value.'+ />'."\n";
    }
  }
}

// other functions
function getPOST($name) {
  if (isset($_POST[$name])) $result = $_POST[$name]; else $result = '';
  return $result;
}
function getGET($name) {
  if (isset($_GET[$name])) $result = $_GET[$name]; else $result = '';
  return $result;
}
function getSESSION($name) {
  if (isset($_SESSION[$name])) $result = $_SESSION[$name]; else $result = '';
  return $result;
}





/* TEST
$db = new Tdatabase();
$q1 = new Tquery('q1',$db);


$db->connect();
echo "<br>connect utn $lastError";
$q1->sql = 'select * from varos where irsz > :PIRSZ';
$q1->setParams('PIRSZ','1500');
$q1->open();
echo "<br>open utn $lastError ".$q1->recordCount;
$q1->first();
while (! $q1->eof) {
  $f = $q1->fieldByName('varos1');
  echo "<br>".$q1->fields[0]->value." ".$f->value." ";
  $q1->next();
}
$q1->close();
echo "<br>close utn $lastError";
$db->disconnect();
echo "<br>disconnect utn $lastError";
*/

?>
