<?php
/*  szmla Pdf -be ir rutin
    Licensz: GNU/GPL  foglert@robitbt.hu

    a rutin feladata: a ./work/szamla.sz -hez hozzirni a megadott szmlt
    2 pldnyban
*/
global $config,$debugLevel;
include_once('./config.php');
include_once('./mysqldb.php');
include_once "./Numbers/Words.php";
include_once './html2fpdf.php';

function pdfText($pdf,$x,$y,$txt) {
  $txt = html_entity_decode($txt);
  $txt = strip_tags($txt);
  $txt = str_replace("_"," ",$txt);
  $pdf->text($x,$y,$txt);
}

class TafaSum2 {
  var $db = 0;
  var $kulcsok = array();
  var $nettok = array();
  var $bruttok = array();
  function TafaSum2() {
    $this->db = 0;
    $this->kulcsok = array();
    $this->nettok = array();
    $this->bruttok = array();
  }
  function add($netto,$afakulcs,$brutto) {
    $i = 0;
	$J = count($this->kulcsok);
	while ($i < $J) {
	   if ($this->kulcsok[$i]==$afakulcs) {
	      $this->nettok[$i] = $this->nettok[$i] + round($netto);
	      $this->bruttok[$i] = $this->bruttok[$i] + round($brutto);
		  $i = 999;
	   }
	   $i++;
	}
	if ($i == $J) {
       $this->kulcsok[$i] = $afakulcs;
   	   $this->nettok[$i] = round($netto);
	   $this->bruttok[$i] = round($brutto);
	}
  }
  function count() {
    return count($this->kulcsok);
  }
  function printel($pdf, &$y) {
      $pdf->SetFont('courier','','','medium');
	  $y = $y + 10;
      pdftext($pdf,10,$y,'FA sszests');
	  $snetto = 0;
	  $sbrutto = 0;
	  for ($i=0; $i<count($this->kulcsok); $i++) {
  	    $y = $y + 5;
	    $snetto = $snetto + $this->nettok[$i];
	    $sbrutto = $sbrutto + $this->bruttok[$i];
        pdftext($pdf,20,$y,$this->kulcsok[$i]);
        pdftext($pdf,50,$y,'Nett:');
        pdftext($pdf,65,$y,rpad(round($this->nettok[$i]),10));
        pdftext($pdf,100,$y,'AFA:');
        pdftext($pdf,115,$y,rpad(round($this->bruttok[$i] - $this->nettok[$i]),8));
        pdftext($pdf,150,$y,'Brutt:');
        pdftext($pdf,165,$y,rpad(round($this->bruttok[$i]),10));
	  }
	  $y = $y + 10;
      pdftext($pdf,20,$y,'Vg sszessen');
      pdftext($pdf,50,$y,'Nett: ');
      pdftext($pdf,65,$y,rpad(round($snetto),10));
      pdftext($pdf,100,$y,'FA: ');
      pdftext($pdf,115,$y,rpad(round($sbrutto - $snetto),8));
      pdftext($pdf,150,$y,'Brutt: ');
      pdftext($pdf,165,$y,rpad(round($sbrutto),10));
   }
}


function textWordWrap($pdf,$x,$y,$charWidth,$txt) {
     // html entity-k szrse
     $txt = html_entity_decode($txt);
     $w = '';
     $wy = $y;
     $txt = str_replace("\n"," \n ",$txt);
     $words = explode(' ',strip_tags($txt));
     $i = 0;
     for ($i = 0; $i < count($words); $i++) {
       if ($words[$i] == "\n") {
         pdfText($pdf,$x,$wy,$w);
         $w = $words[$i].' ';
         $wy = $wy + 5;
       } else if (strlen($w.' '.$words[$i]) <= $charWidth)
          $w .= $words[$i].' ';
       else {
         pdfText($pdf,$x,$wy,$w);
         $w = $words[$i].' ';
         $wy = $wy + 5;
       }
     }
     pdfText($pdf,$x,$wy,$w);
}
function szamlaPdfbe($szid,$db,$szoveg) {
  global $config;
  $q1 = new Tquery('q1',$db);
  $q2 = new Tquery('q2',$db);
  $q1->sql = 'select * from szamla where id = '.$szid;
  $q1->open();
  if ($q1->recordCount > 0) {
    $q1->first();

    $nyomtatva = $q1->valuebyname('nyomtatva');
    $nyomtatva = $nyomtatva + 1;
    $szlszam = $q1->valuebyname('szlszam');
    $nev = $q1->valuebyname('id');
    $FH = 10;   // font size pt
    $H =  4;   // sor magassg mm
    $L =  0.2;  // vonal vastagsag mm
    $FIZHAT = $config['fizhat'];  // fizetsi hatrid napban
    $pdf = new HTML2FPDF();

    $pdf->AddPage();
    $pdf->SetFont('times','','','12');
    $pdf->Image('./images/szamlasema.jpg',  5,0,200,97,'','',true);
    $pdf->SetFont('times','B',16);
    if ($q1->valuebyname('tipus') == 'ELOLEG')
      $w = 'Elleg szmla';
    else
      $w = 'Szmla';
    if ($q1->valuebyname('jelleg') != 'NORMAL')
      $w = 'SZMLVAL EGY TEKINTET AL ES OKIRAT';
    $pdf->SetFont('times','B',16);
    pdfText($pdf,15,12,$w);
    $pdf->SetFont('times','B','12');

    // szmla szma
    $pdf->SetFont('times','B','',16);
    pdfText($pdf,162,23,$q1->valuebyname('szlszam'));

    $pdf->SetFont('times','','','12');
    // szllt
    pdfText($pdf,30,35,$config['cegnev0']);
    pdfText($pdf,30,40,$config['cegnev1']);
    pdfText($pdf,30,45,$config['cegnev2']);
    pdfText($pdf,30,50,$config['cegnev3']);
    pdfText($pdf,30,55,$config['cegnev4']);
    pdfText($pdf,30,60,$config['cegnev5']);
    pdfText($pdf,30,65,$config['cegnev6']);
    // vev
    textWordWrap($pdf,110,40,45,$q1->valuebyname('cegnev'));
    pdfText($pdf,110,55,$q1->valuebyname('adoszam'));
    pdfText($pdf,110,60,$q1->valuebyname('varos'));
    pdfText($pdf,110,65,$q1->valuebyname('cim'));
    pdfText($pdf,110,70,$q1->valuebyname('irsz'));

    // dtumok s fizmod
    $pdf->SetFont('times','B','12');
    if ($q1->valuebyname('fizmod') == 'KP')
       pdfText($pdf,20,85,'Kszpnz');
    else if ($q1->valuebyname('fizmod') == 'ATUT')
       pdfText($pdf,20,85,'tutals');
    else
       pdfText($pdf,20,85,$q1->valuebyname('fizmod'));
    pdfText($pdf,70,85,$q1->valuebyname('teljdat'));
    pdfText($pdf,120,85,$q1->valuebyname('datum'));
    pdfText($pdf,170,85,$q1->valuebyname('fizhat'));

    $afaSum = new TafaSum2();
    $pdf->SetFont('courier','','8');
    $snetto = 0;
    $sbrutto = 0;
    $T = '';
    $K = '';
    $y = 103;
    $q2->sql = 'select * from szamlatetel where szamlaid = '.$szid.
               ' order by id';
    $q2->open();
    if ($q2->recordCount > 0) {
      $q2->first();
      while (!$q2->eof) {
        $netto1 = round($q2->valuebyname('nertek'));
        $brutto1 = round($q2->valuebyname('bertek'));
		$afaSum->add(round($q2->valuebyname('nertek')),
		                   $q2->valuebyname('afa'),
						   round($q2->valuebyname('bertek')));
        pdfText($pdf,10,$y,$q2->valuebyname('cikknev'));
        pdfText($pdf,65,$y,$q2->valuebyname('cikkod'));
        pdfText($pdf,90,$y,rpad(round($q2->valuebyname('mennyiseg')),2).
                             $q2->valuebyname('me'));
        pdfText($pdf,115,$y,rpad(round($q2->valuebyname('negysar')),8).' ');
        pdfText($pdf,135,$y,rpad($netto1,8).' ');
        pdfText($pdf,155,$y,$q2->valuebyname('afa'));
        pdfText($pdf,165,$y,rpad(round($brutto1 - $netto1),8).' ');
        pdfText($pdf,185,$y,rpad(round($brutto1),8).' ');
        $snetto = $snetto + $netto1;
        $sbrutto = $sbrutto + $brutto1;
        if (strpos($T,$q2->valuebyname('kontirT').',')===false)
           $T .= $q2->valuebyname('kontirT').',';
        if (strpos($K,$q2->valuebyname('kontirK').',')===false)
           $K .= $q2->valuebyname('kontirK').',';
        $y = $y + 5;
        $q2->next();
      }
      $q2->close();
    }
    $pdf->Line(10,$y,200,$y);

    // sszesen
	if ($afaSum->count() > 1) {
	  $afaSum->printel($pdf,$y);
	} else {
      $pdf->SetFont('courier','','12');
      pdfText($pdf,100,119,'sszesen');
      pdfText($pdf,137,119,'Nett:     '.rpad(round($snetto),8).' ');
      pdfText($pdf,137,125,'fa:       '.rpad(round($sbrutto - $snetto),8).' ');
      pdfText($pdf,137,131,'Brutt:    '.rpad(round($sbrutto),8).' ');
      pdfText($pdf,195,131,$q1->valuebyname('penznem'));
	}
    if (($sbrutto - $snetto) >= 0)
       $K .= '4671';
    if (($sbrutto - $snetto) < 0)
       $T .= '4671';
    if ((abs($sbrutto) <= 0) | ($q1->valuebyname('fizmod') == 'Fizetve')) {
       pdfText($pdf,195,167,$q1->valuebyname('penznem'));
       pdfText($pdf,115,167,'Pnzgyi rendezst nem ignyel.');
    } else {
       pdfText($pdf,137,167,'Fizetend: '.rpad(round($sbrutto),8).' ');
       pdfText($pdf,195,167,$q1->valuebyname('penznem'));
    }
    $azaz = new Numbers_Words();
    $pdf->SetFont('times','B','12');
    pdfText($pdf,20,170, 'Azaz: '.$azaz->toWords($sbrutto,'hu_HU'));
    $pdf->SetFont('times','','12');

    // kzlemny s mellkletek szveg
    textWordWrap($pdf,10,180,90,$q1->valuebyname('kozlemeny'));
    $pdf->SetFont('times','','12');
    textWordWrap($pdf,10,200,90,$q1->valuebyname('mellekletek'));
    textWordWrap($pdf,10,220,90,$szoveg);

    $pdf->SetFont('times','','12');
    // kontirozs
    if ((trim($T) != '') | trim($K != ''))
       pdfText($pdf,10,260,'T: '.$T.'&nbsp;&nbsp;&nbsp;  K: '.$K);

    pdfText($pdf,22,22,'az eredeti msolata (csak tjkoztatsra)');
    $pdf->Line(10,270,230,270);
    $pdf->SetFont('times','','10');
    pdfText($pdf,10,274,'Kszlt a RoBIT Bt. Konferencia-admin programjval. http://robitbt.hu');
    //$pdf->Output("./work/szamla.szl");
    $pdf->Output("./work/szamla.pdf");
    $pdf->SetFont('times','','12');
  } // megvan a szamla rekord
  $q1->close();
}

?>
