<?php
/*
    Ellegszmla kszits a systemmedia konferencia szervez rendszerben
    Licensz: GNU/GPL  foglert@robitbt.hu
    POST selectedId = konfadmin.id --> konfid

    2009.05.28 Felhasznli krsre (Zelei Mara)
    az ellegszmln teljdat=fizhet=fizets dtuma, szladat a szmla killts dtuma

*/
session_start();
global $config,$q,$db,$debugLevel;
include_once('./config.php');
include_once('./mysqldb.php');
include_once('./szamlaprn.php');
include_once('./login.php');  // $db konnektlja, $q -t krel
include_once('./header.php');

$PLD = 2;    // ennyi pldny szmlt nyomtat

function datumValidate($sdatum) {
   $ev =  0 + substr($sdatum,0,4);
   $ho =  0 + substr($sdatum,5,2);
   $nap =  0 + substr($sdatum,8,2);
   $ki = checkdate($ho, $nap  , $ev);
   if ((substr($sdatum,4,1) != '.') & (substr($sdatum,4,1) != '-')) $ki = false;
   if ((substr($sdatum,7,1) != '.') & (substr($sdatum,7,1) != '-')) $ki = false;
   if (substr($sdatum,4,1) != substr($sdatum,7,1)) $ki = false;
   return $ki;
}

$act = getPOST('act');
$konfid = -1;
$q->sql = 'select konfid from konfadmin where id='.getPOST('selectedId');
$q->open();
if ($q->recordCount > 0) {
  $q->first();
  $konfid = $q->valuebyname('konfid');
} else {
  $konfid = -1;
  echo ' elolegszamla.php  Hibs aktivls '.$selectedId;
  exit();
}
$q->close();

if ($act == 'step2') {
  if (!datumValidate(getPOST('szladat'))) {
   echo '<script type="text/javascript">'."\n";
   echo 'alert("nem j dtum adat! '.getPOST('szladat').'");';
   echo '</script>'."\n";
   $act = 'step1'; // r csorog a kvetkez if re
  }
}
if ($act != 'step2') {
   if (file_exists('./semak/'.$konfid.'_eloleg.frg')) {
      $sorok = file('./semak/'.$konfid.'_eloleg.frg');
   } else {
      $sorok = array();
   }
   $txt = implode($sorok,"");

    // konferencia r adatok kiolvassa (ha nincs ltrehozsa)
    $listaar = 0;
    $onlinear = 0;
    $kedvar = 0;
    $etkezes = 0;
    $szallas = 0;
    $ifh = 0;
    $q->sql = 'select * from '.$config['dbpre'].'konfar where konfid = '.$konfid;
    $q->open();
    echo $lastError;
    if ($q->recordCount > 0) {
      $q->first();
      $listaar = $q->valuebyname('listaar');
      $onlinear =  $q->valuebyname('onlinear');
      $kedvar =  $q->valuebyname('kedvar');
      $etkezes =  $q->valuebyname('etkezes');
      $szallas =  $q->valuebyname('szallas');
      $ifh =  $q->valuebyname('ifh');

      $q->close();
    } else {
      $q->close();
      $q->sql = 'insert into '.$config['dbpre'].'konfar (konfid,listaar,kedvar,promptar,onlinear,etkezes,szallas,ifh) '.
                ' values ('.$konfid.',0,0,0,0,0,0,0)';
      $q->execsql();
      echo $lastError;
    }

   echo '<h2>Elleg szmla kszts</h2>'."\n";
   echo '<p>Ellegszmla azoknak kszl akik elleget ',
        ' fizettek (fizetve > 0), s mg nem kaptak elleg szmlt, '.
        ' s nem egyedi ras, s nem egyedi szla belltsuak.'."\n";
   echo '<p>Ha elleget nem kellett volna fizetni, akkor csak az kap elleg szmlt '.
        ' aki a a konferencia dtumtl eltr honapban fizetett.</p>'."\n";
   echo '<p><b>Ellegszmla csak a konferencia dtuma eltt kszlhet.</b></p>';
   echo ' Az ellegszmla sszegt a konferencia rai, a ltszm s a jelentkezs mdja hatrozza meg.'."\n";
   echo ' Az ellegszmln a fizetsi mdnl a "Fizetve" felirat szerepel.</p>'."\n";

   echo '<form name="form1" method="post" action="./elolegszamla.php">'."\n";
   echo '<input type="hidden" name="selectedId" value="'.getPOST('selectedId').'">'."\n";
   echo '<input type="hidden" name="act" value="step2">'."\n";

   echo '<table border="0">'."\n";
   echo '  <tr>'."\n";
   echo '    <td align="right">Listar:</td><td><input type="text" name="listaar" size="12" value="'.$listaar.'">/f '."\n";
   echo '       &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;On-line r:<input type="text" name="onlinear" size="12" value="'.$onlinear.'">/f</td>'."\n";
   echo '  </tr>'."\n";
   echo '  <tr>'."\n";
   echo '    <td align="right">Egyb kedvezmnyes r:</td><td><input type="text" name="kedvar" size="12" value="'.$kedvar.'">/f '."\n";
   echo '       Ebbl tkezs:<input type="text" name="etkezes" size="12" value="'.$etkezes.'">/f</td>'."\n";
   echo '  </tr>'."\n";
   echo '  <tr>'."\n";
   echo '    <td align="right">Szlls:</td><td><input type="text" name="szallas" size="12" value="'.$szallas.'">/f '."\n";
   echo '       &nbsp;Idegen.forg.h.:<input type="text" name="ifh" size="12" value="'.$ifh.'">/f</td>'."\n";
   echo '  </tr>'."\n";
   echo '</table>'."\n";
   echo '<p>Elleget kell fizetni:'."\n";
   echo '<select name="eloleg">'."\n";
   if ($eloleg == 'I') {
     echo '                                <option value="I" selected="selected">Igen</option>'."\n";
     echo '                                <option value="N">Nem</option>'."\n";
   } else {
     echo '                                <option value="I">Igen</option>'."\n";
     echo '                                <option value="N" selected="selected">Nem</option>'."\n";
   }
   echo '</select></p>'."\n";
   echo '<p>Szveg a szmla vgre (a konferencia nv s idpont, kontirozs '.
        'automatikusan rajta lesz, ezeket ide nem kell beirni)</p>'."\n";
   echo '<p><textarea name="txt" rows="10" cols="60">'."\n";
   echo $txt;
   echo '</textarea></p>'."\n";
   echo '<p>Szmla dtuma:<input type="text" name="szladat" value="'.date('Y.m.d').'" /></p>';
   echo '<p><button type="submit">Rendben</button>&nbsp'."\n";
   $url = "'./index.php';";
   echo '<button type="button" onclick="location='.$url.'">Mgsem</button></p>'."\n";
   echo '</form>'."\n";
   echo '<script type="text/javascript">'."\n";
   echo 'makeDateEdit("form1","szladat");'."\n";
   echo 'makeCurrencyEdit("form1","listaar");'."\n";
   echo 'makeCurrencyEdit("form1","onlinear");'."\n";
   echo 'makeCurrencyEdit("form1","kedvar");'."\n";
   echo 'makeCurrencyEdit("form1","etkezes");'."\n";
   echo 'makeCurrencyEdit("form1","szallas");'."\n";
   echo 'makeCurrencyEdit("form1","ifh");'."\n";
   echo 'document.forms.form1.listaar.focus();'."\n";
   echo '</script>'."\n";
   echo '<p></p>'."\n";
   echo '<p>A szmla nyomtatshoz a RoBIT Bt szlaprint szmla nyomtat kliens programra van szksg. Ezt az albbi link segitsgvel telepitheti:</p>'."\n";
   echo '<p><a href="http://robitbt.hu/hu/instals/szlaprint_setup.exe">Szmla nyomtat kliens teleptse</a></p>'."\n";
   include_once('./footer.php');
   exit();
}

$txt = getPOST('txt');
$fp = fopen('./semak/'.$konfid.'_eloleg.frg','w+');
fwrite($fp,$txt);
fclose($fp);

$listaar = str_replace(' ','',getPOST('listaar'));
$onlinear = str_replace(' ','',getPOST('onlinear'));
$kedvar = str_replace(' ','',getPOST('kedvar'));
$etkezes = str_replace(' ','',getPOST('etkezes'));
$szladat = str_replace(' ','',getPOST('szladat'));
$eloleg = str_replace(' ','',getPOST('eloleg'));
$szallas = str_replace(' ','',getPOST('szallas'));
$ifh = str_replace(' ','',getPOST('ifh'));

$szladatw = str_replace('.','-',$szladat);
$fizhat =  date('Y.m.d.',strtotime($szladatw) + ($config['fizhat'] * 24 * 3600));

// rak kitrolsa az adatbzisba
$q->sql = 'update '.$config['dbpre'].'konfar '.
          'set listaar='.$listaar.', '.
          '    onlinear='.$onlinear.', '.
          '    kedvar='.$kedvar.', '.
          '    etkezes='.$etkezes.', '.
          '    szallas='.$szallas.', '.
          '    ifh='.$ifh.' '.
          'where konfid='.$konfid;
$q->execsql();
echo $lastError;

/* j elleg szmla fej rekordok generlsa */
/* Ha elleget kell fizetni akkor mindenkinek aki fizetett,
   ha nem kell csak annak aki az elz hnapban fizetett */
$q->sql = "
insert into szamla
    (tipus, jelleg, ev, szlszam,
    fizmod, teljdat, datum, fizhat,
    helyesbitett, nyomtatva, cegnev,
	irsz, varos, cim, adoszam, ugyfelszam,
	pnev, pirsz, pvaros, pcim, rendelesszam,
	szallitolevel, koltseghely, munkaszam,
	kozlemeny, mellekletek, penznem, tartalek1,
	tartalek2, tartalek3)
select distinct
	'ELOLEG', 'NORMAL', '".substr($szladat,0,4)."', '',
	'ATUT', ka.fizdat, '".$szladat."', ka.fizdat ,
	'', 0, ka.cegnev,
	ka.irsz, ka.varos, ka.cim, ka.cegadosz, '',
	ka.cegnev, ka.irsz, ka.varos, ka.cim, 'UJ',
	'', '', ka.konfid,
	concat(k.k_cim,'\n',k.k_ido), '', 'Ft', '',
	'', ''
from konfadmin ka
left outer join konferenciak k on k.k_id = ka.konfid
where ka.konfid = $konfid and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and ka.konfid = $konfid and
      ((MONTH(ka.fizdat) <> substring(k.k_ido,5,2)) or (ka.prf_elolegbekero = 'I')) and
      k.k_ido > '$szladat';";
$q->execsql();
if ($lastError != '')
   echo '<hr>'.$lastError.'<hr>'.$q->sql.'<hr>'."\n";

/* adoszam szptse */
$q->sql = "update szamla
           set adoszam = concat('Adszm:',adoszam)
           where adoszam <> '' and adoszam not like 'Adszm:%'";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

/* szamlaszam kpzs */
$q->sql = "
update szamla
set szlszam = concat(ev,'/',substr((100000+id),2,5))
where szlszam = '';";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

if ($szladat >= '2009.07.01') {
  $afakulcs = 25;
  $afaszorzo = 1.25;
  $afakulcs2 = 18;  // szllsdj afakulcs
} else {
  $afakulcs = 20;
  $afakulcs = 20;
  $afaszorzo = 1.2;
}

/* 1. ttelsor generls   T3111 K453  illetve K3111 K 9211 */
$q->sql = "
insert into szamlatetel
    (szamlaid, cikkid, cikkat, cikkod,
    cikknev, tovabszsz, mennyiseg, me,
    negysar, afa, nertek, bertek, elolegszla,
    kontirT, kontirK,
    tartalek1, tartalek2, tartalek3
	)
select sz.id, '','','',
       'Elleg','N', sum(ka.letszam), 'f',
       kar.onlinear, '$afakulcs',0,0,'',
       '3111','453',
       '','',''
from szamla sz, konfar kar, konfadmin ka
where sz.munkaszam = kar.konfid and
      sz.cegnev = ka.cegnev and sz.munkaszam = ka.konfid and
      sz.irsz = ka.irsz and sz.varos = ka.varos and
      sz.rendelesszam = 'UJ' and ka.jelmod='ONLINE' and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and ka.konfid = $konfid
group by sz.id, kar.onlinear, kar.etkezes;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
$q->sql = "
insert into szamlatetel
	(szamlaid, cikkid, cikkat, cikkod,
	cikknev, tovabszsz, mennyiseg, me,
	negysar, afa, nertek, bertek, elolegszla,
        kontirT, kontirK,
	tartalek1, tartalek2, tartalek3
	)
select sz.id, '','','',
       'Elleg','N', sum(ka.letszam), 'f',
       kar.kedvar, '$afakulcs',0,0,'',
       '3111','453',
       '','',''
from szamla sz, konfar kar, konfadmin ka
where sz.munkaszam = kar.konfid and
      sz.cegnev = ka.cegnev and sz.munkaszam = ka.konfid and
      sz.irsz = ka.irsz and sz.varos = ka.varos and
      sz.rendelesszam = 'UJ' and ka.jelmod='IDOBEN' and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and ka.konfid = $konfid
group by sz.id, kar.kedvar, kar.etkezes;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
$q->sql = "
insert into szamlatetel
	(szamlaid, cikkid, cikkat, cikkod,
	cikknev, tovabszsz, mennyiseg, me,
	negysar, afa, nertek, bertek, elolegszla,
        kontirT, kontirK,
	tartalek1, tartalek2, tartalek3
	)
select sz.id, '','','',
       'Elleg','N', sum(ka.letszam), 'f',
       kar.listaar, '$afakulcs',0,0,'',
       '3111','453',
       '','',''
from szamla sz, konfar kar, konfadmin ka
where sz.munkaszam = kar.konfid and
      sz.cegnev = ka.cegnev and sz.munkaszam = ka.konfid and
      sz.irsz = ka.irsz and sz.varos = ka.varos and
      sz.rendelesszam = 'UJ' and ka.jelmod='KESON' and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and ka.konfid = $konfid
group by sz.id, kar.listaar, kar.etkezes;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

if ($szallas > 0) {
/* szallasdj ttelsor generlsa */
$q->sql = "
insert into szamlatetel
	(szamlaid, cikkid, cikkat, cikkod,
	cikknev, tovabszsz, mennyiseg, me,
	negysar, afa, nertek, bertek, elolegszla,
        kontirT, kontirK,
	tartalek1, tartalek2, tartalek3
	)
select sz.id, '','','',
       'Elleg (szllsdj)','N', sum(ka.letszam), 'f',
       kar.szallas, '$afakulcs2',0,0,'',
       '3111','453',
       '','',''
from szamla sz, konfar kar, konfadmin ka
where sz.munkaszam = kar.konfid and
      sz.cegnev = ka.cegnev and sz.munkaszam = ka.konfid and
      sz.irsz = ka.irsz and sz.varos = ka.varos and
      sz.rendelesszam = 'UJ' and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and ka.konfid = $konfid
group by sz.id, kar.szallas, kar.etkezes;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
}
if ($ifh > 0) {
/* idegen forg. hozzjruls generlsa */
$q->sql = "
insert into szamlatetel
	(szamlaid, cikkid, cikkat, cikkod,
	cikknev, tovabszsz, mennyiseg, me,
	negysar, afa, nertek, bertek, elolegszla,
        kontirT, kontirK,
	tartalek1, tartalek2, tartalek3
	)
select sz.id, '','','',
       'Elleg (id.forg.h.)','N', sum(ka.letszam), 'f',
       kar.ifh, '0',0,0,'',
       '3111','453',
       '','',''
from szamla sz, konfar kar, konfadmin ka
where sz.munkaszam = kar.konfid and
      sz.cegnev = ka.cegnev and sz.munkaszam = ka.konfid and
      sz.irsz = ka.irsz and sz.varos = ka.varos and
      sz.rendelesszam = 'UJ' and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and ka.konfid = $konfid
group by sz.id, kar.ifh, kar.etkezes;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
}
/* j ttelekben nertek s bertek szmtsa */
$q->sql = "
update szamlatetel
set nertek = round(mennyiseg * negysar),
    bertek = round(round(mennyiseg * negysar)*(1 + afa/100))
where nertek = 0 and (afa = '0' or afa = '5' or afa = '15' or afa = '18' or afa = '20' or afa = '25');";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

$q->sql = "
update szamlatetel
set nertek = round(mennyiseg * negysar),
    bertek = round(round(mennyiseg * negysar))
where nertek = 0 and (afa <> '0' and afa <> '5' and afa <> '15' and afa <> '18' and afa <> '20' and afa <> '25'); ";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

/* merllkletek - be a rszvevk neve ott ahol ezt krtk */
$q->sql = "
update szamla sz,
     (select konfid, cegnev, szlanev, GROUP_CONCAT(distinct nev SEPARATOR ',') nevek
      from konfadmin
      group by konfid, cegnev, szlanev) w
set sz.mellekletek = concat('Rsztvev:',w.nevek)
where w.konfid = sz.munkaszam and w.cegnev = sz.cegnev and
      sz.rendelesszam = 'UJ' and w.szlanev='I' and w.konfid = $konfid;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

/* szmlaszm s szmla dtum a konfadminba */
$q->sql = "
update konfadmin ka, szamla sz
set eszla_szam = sz.szlszam,
    eszla_datum = sz.datum
where sz.cegnev = ka.cegnev and
      sz.irsz = ka.irsz and sz.varos = ka.varos and sz.cim = ka.cim and
      ((sz.adoszam=ka.cegadosz) or (ka.cegadosz <> 'I')   ) and
      sz.munkaszam = ka.konfid and sz.rendelesszam = 'UJ' and
      ka.ervenyes='I' and ka.fizetett > 0 and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.eszla_szam = '' and
      ka.egyediszla <> 'I' and ka.egyediar <> 'I' and
      ka.konfid = $konfid;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
// ellegszmla sszegnek beirsa a konfadminba
$q->sql = "
update konfadmin ka,
 (select sz.szlszam szlszam, sum(szt.bertek) brutto
  from szamla sz,
       szamlatetel szt
  where sz.id = szt.szamlaid
  group by sz.szlszam) w
set ka.eszla_osszeg = w.brutto
where ka.eszla_szam = w.szlszam and
      ka.eszla_osszeg = 0;";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

/* rendelsszm ritse */
$q->sql = "
update szamla
set rendelesszam = ''
where rendelesszam = 'UJ';";
$q->execsql();
if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

/* mg nem nyomtatott j ellegszmlk nyomtatsa */
$q->sql = "select id
           from szamla
           where nyomtatva <= 0 and munkaszam = $konfid
           order by id";
$q->open();
if ($q->recordCount > 0) {
   if (file_exists('./work/szamla.szl'))
      unlink('./work/szamla.szl');
   $fp = fopen('./work/szamla.szl','w+');
   fwrite($fp,'<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/html40/loose.dtd">'."\n");
   fwrite($fp,'<html>'."\n");
   fwrite($fp,'<head>'."\n");
   fwrite($fp,'  <meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-2">'."\n");
   fwrite($fp,'  <title>Systemmedia szmlz rendszer</title>'."\n");
   fwrite($fp,'</head>'."\n");
   fwrite($fp,'<body>'."\n");
   $q->first();
   while (!$q->eof) {
     for ($J = 1; $J <= $PLD; $J++)
       szamlanyomtato($q->valuebyname('id'),$db,$txt);
     $q->next();
   }
   $q->close();

   // szmla file nyomtatsa+
   $fp = fopen('./work/szamla.szl','a+');
   fwrite($fp,'</body></html>');

   // block print popups from Javascript
   echo '<p>Az el ugr ablakban a fjl megnyitst kell vlasztani!'."\n";
   echo '<iframe name="ifrmszlaprn" id="ifrmszlaprn" width="500" height="300"></iframe>'."\n";
   echo '<p></p>'."\n";
   echo '<script type="text/javascript">'."\n";
   echo 'document.getElementById("ifrmszlaprn").src = "./dwl.php?f='.$config['rootpath'].'/work/szamla.szl";'."\n";
   echo '</script>';
} else {
   echo '<h3>Nincs kinyomtattand ellegszmla</h3>';
}
$q->close();

include_once('./footer.php');
?>
