<?php
/* emailduplak tblzatos megjelenit

   iframe-ben fut, feladata aaz adatok tblzatos megjelenitse
   egrklik esetn ai iframet tartalmaz lapon lltja be a
   selectedId -t s hivja az ott lv celclick(row,col) rutint.

   Szerz : Fogler Tibor
   Licensz: GNU/GPL

   szksges: mysqldb.php
              config.php
              login.php

   POST      act       = 'browse'
             labels
             aligns
             top
             selected
             filter
             order
             pageSize

   hasznlt styles
      .grid                       table
      .grid * th                  table headers cell
      .grid * td or .fieldname    data cell
      .gridrow                    grid row
      .selectedgridrow            selected grid row

*/

session_start();
global $q,$db,$config,$lastError;
include_once ('login.php'); //$q-t crelt, $db connectlt
include_once ('config.php');
include_once ('mysqldb.php');

$act = getPOST('act'); if ($act=='') $act = 'browse';
$top = getPOST('top'); if ($top=='') $top=0;
$selected = getPOST('selected'); if ($selected=='') $selected=0;
$labels = explode(';',getPOST('labels')); // implode(';',$array) llitja el.
$aligns = explode(';',getPOST('aligns'));
$order = getPOST('order');
$filter = stripslashes(getPOST('filter'));
$pageSize = getPOST('pageSize'); if ($pageSize=='') $pageSize = 10;
$gridId = '';

if ($act == 'browse') {
     $q->sql = 'select ed.* from '.$config['dbpre'].'emaildupla ed '.
               'where ed.id >= 0 ';
     if ($filter != '')
       $q->sql .= ' and '.$filter;
     if ($order != '')
       $q->sql .= ' order by '.$order.',id';
     $q->sql .= ' limit '.$top.','.$pageSize;
     $q->open();
     for ($i=0; $i<count($q->fields); $i++) {
        if (!isset($labels[$i]))
          $labels[$i] = $q->fields[$i]->name;
     }
     for ($i=0; $i<count($q->fields); $i++) {
        if (!isset($aligns[$i]))
          $aligns[$i] = 'LEFT';
     }
     echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/html40/loose.dtd">'."\n";
     echo '<html>'."\n";
     echo '<head>'."\n";
     echo '  <meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-2">'."\n";
     echo '  <link rel="stylesheet" type="text/css" href="szamlazostyle.css">'."\n";
     echo '  <title>emaildupla0</title>'."\n";
     echo '</head>'."\n";
     echo '<body class="mysqlgrid0">'."\n";
     //------------- tblzat mret !!! --------------------
     echo '<table class="grid" width="3000" id="tableemaildupla" border="1" cellspacing="0" cellpadding="0">'."\n";
     //------------- tblzat mret !!! --------------------
     echo '  <tr>';
     for ($i=0; $i < $q->fieldCount; $i++) {
         echo '    <th>'.$labels[$i].'</th>'."\n";
     }
     echo '  </tr>'."\n";
     if ($q->recordCount > 0) {
       $j = 0;
       $q->first();
       while (!$q->eof) {
          echo '  <tr id="tr'.$j.'" class="gridrow">'."\n";
          for ($i=0; $i < $q->fieldCount; $i++) {
            if ($q->fields[$i]->value=='')
               $q->fields[$i]->value = '&nbsp;';
            // ----------------------------------------------------!! FONTOS ID jells
            if ($i == 0)
              $tdclass = 'class="td_id"';
            else
              $tdclass = 'class="td_data"';
            // ----------------------------------------------------!! FONTOS
           if ($aligns[$i]=='LEFT') {
              echo '    <td '.$tdclass,' '.
                   'onclick="cellclick('.$j.','.$i.')" style="cursor:pointer; padding-left:5px; padding-right:5px;">'.
                   $q->fields[$i]->value.
                   '</button></td>';
            } else {
              echo '    <td align="right" '.$tdclass.' '.
                   ' onclick="cellclick('.$j.','.$i.')" style="cursor:pointer;  padding-left:5px; padding-right:5px; text-align:right">'.
                   $q->fields[$i]->value.
                   '</td>';
            }
          }
          $q->next();
          $j++;
          echo '  </tr>'."\n";
       }
       while ($j < ($pageSize - 1)) {
          echo '  <tr id="_'.$j.'" class="gridrow">'."\n";
          for ($i=0; $i < $q->fieldCount; $i++) {
            echo '<td>&nbsp;</td>';
          }
          $j++;
          echo '  </tr>'."\n";
       }
       echo '</table>'."\n";
     }
     $q->close();
     echo '<script language="JavaScript">'."\n";
     echo 'var selected = '.$selected.';'."\n";
     echo 'var gridrowBg = "white";'."\n";
     echo 'var gridrowColor = "black";'."\n";
     echo 'var selectedgridrowBg = "cyan";'."\n";
     echo 'var selectedgridrowColor = "black";'."\n";
     ?>
     // read from css file
     for (i=0; i<document.styleSheets.length; i++) {
        pos = document.styleSheets[i];
        if (pos.cssRules)
          rules = pos.cssRules; //Firefox
        else
          rules = pos.rules;    //IE
        for (j=0; j<rules.length; j++) {
           if (rules[j].selectorText == 'gridwow') {
               gridrowBg = rules[j].style.backgroundColor;
               gridrowColor = rules[j].style.Color;
           }
           if (rules[j].selectorText == 'selectedgridwow') {
               selectedgridrowBg = rules[j].style.backgroundColor;
               selectedgridrowColor = rules[j].style.Color;
           }
         }
     }
     if (gridrowBg=='') gridrowBg = 'white';
     if (selectedgridrowBg=='') selectedgridrowBg = 'cyan';
     if (gridrowColor=='') gridrowColor = 'blacke';
     if (selectedgridrowColor=='') selectedgridrowColor = 'blacl';
     <?php
     echo 'function cellclick(rowno,colno) {'."\n";
     echo ' var tr = document.getElementById("tr"+selected);'."\n";
     echo ' var w = false;'."\n";
     echo ' if (tr)'."\n";
     echo '    w = tr.firstChild;'."\n";
     echo ' while (w) {'."\n";
     echo '  if ((w.nodeName=="td") | (w.nodeName=="TD")) {'."\n";
     echo '     w.style.backgroundColor = gridrowBg;'."\n";
     echo '     w.style.Color = gridrowColor;'."\n";
     echo '  }'."\n";
     echo '  w = w.nextSibling;'."\n";
     echo ' }'."\n";
     echo ' var i = 0;'."\n";
     echo ' tr = document.getElementById("tr"+rowno);'."\n";
     echo ' w = false;'."\n";
     echo ' if (tr)'."\n";
     echo '    w = tr.firstChild;'."\n";
     echo ' while (w) {'."\n";
     echo '  if ((w.nodeName=="td") | (w.nodeName=="TD")) {'."\n";
     echo '     w.style.backgroundColor = selectedgridrowBg;'."\n";
     echo '     w.style.Color = selectedgridrowColor;'."\n";
     echo '     if (w.className == "td_id") {'."\n";
     echo '        parent.selected_Id = w.firstChild.nodeValue;'."\n";
     echo '     }'."\n";
     echo '     if (i==1) '."\n";
     echo '        parent.selected_email = w.firstChild.nodeValue;'."\n";
     echo '     i++'."\n";
     echo '  }'."\n";
     echo '  w = w.nextSibling;'."\n";
     echo ' }'."\n";
     echo ' selected = rowno;'."\n";
     echo '   parent.cel_click(rowno,colno);'."\n";
     echo '}'."\n";
     echo 'function keyup(event) {'."\n";
     echo '  if (event == null) event = window.event;'."\n";
     echo '  var k = event.keyCode;'."\n";
     echo '  var sel = selected;'."\n";
     //echo '  document.getElementById("'.$gridId.'"+'.$gridId.'selected).className = "gridrow";'."\n";
     echo '  if (k==38) { //up'."\n";
     echo '    if (sel > 0) sel = sel - 1;'."\n";
     echo '  }'."\n";
     echo '  if (k==40) { //down'."\n";
     echo '    if (document.getElementById("tr"+(1+selected)) != undefined)  sel = sel + 1;'."\n";
     echo '  }'."\n";
     echo '  click(sel);'."\n";
     echo '}'."\n";
     echo 'cellclick(selected,0);'."\n";
     echo 'document.onkeyup = keyup;'."\n";
     echo '</script>'."\n";
     echo '</body></html>'."\n";
} // browse
?>
