<?php
/*
faxlista bngsz
Author: Fogler Tibor   foglert@robitbt.hu
Licence: GNU/GPL

ez hivja a faxlista0.php -t. (tblzatos megjelenits, sor zselekcival)
POST  act, top, selected, filter, order

*/
session_start();
global $config;
global $act,$top,$selected,$order,$filter,$uniquekeyValue;
include_once('./config.php');
include_once('./mysqldb.php');
include_once('./login.php');  // $db konnektlja, $q -t krel
include_once('./header.php');

// sor/lap s tblzat mret definilsa
$pageSize = 12;
$ifrmHeight = 320;

// grid oszlop fejlc cimkk definilsa
$labels = array();
$labels[0] = '<var>#</var>';
$labels[1] = '<var>Fax szm</var>';
$labels[2] = '<var>Krzet</var>';
$labels[3] = '<var>Cg nv</var>';
$labels[4] = '<var>gyfl</var>';
$labels[5] = '<var>Beoszts</var>';
$labels[6] = '<var>Irsz</var>';
$labels[7] = '<var>Telepls</var>';
$labels[8] = '<var>Cm</var>';
$labels[9] = '<var>Telefon</var>';
$labels[10] = '<var>E-mail</var>';
$labels[11] = '<var>Konferencia</var>';
$labels[12] = '<var>Ad</var>';
$labels[13] = '<var>Kzbe.</var>';
$labels[14] = '<var>Munkagy</var>';
$labels[15] = '<var>Tangyig.</var>';
$labels[16] = '<var>nkorm.</var>';
$labels[17] = '<var>Jegyz</var>';
$labels[18] = '<var>Okmny iroda</var>';

// segd rutinok
function echoPager($j,$j0,$i) {
     if ($j == $j0)
         echo '<big><b>'.($j+1).'</b></big>&nbsp;';
      else
         echo '<a href="#" onclick="jump('.$i.')">'.($j+1).'</a>&nbsp;';
}
function echoOption($value,$label,$actValue) {
  if ($value==$actValue)
    echo '<option value="'.$value.'" selected="selected">'.$label.'</option>'."\n";
  else
    echo '<option value="'.$value.'">'.$label.'</option>'."\n";
}
function echoChkBox($table,$name) {
  if ($table->valuebyname($name)=='')
    echo '<input type="checkbox" name="'.$name.'" value="X" />'."\n";
  else
    echo '<input type="checkbox" checked="checked" name="'.$name.'" value="X" />'."\n";
}
function echoFilter($filter,$nev) {
  $i = stripos($filter,"fl.".$nev." <> ''");
  if ($i === false)
    echo '<input type="checkbox" name="fil'.$nev.'" value="X">';
  else
    echo '<input type="checkbox" name="fil'.$nev.'" checked="checked" value="X">';
}

// adat kperny
function echodataform($table,$formtitle) {
      global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
      echo '<input type="hidden" name="id" value="'.$table->valuebyname('id').'">'."\n";
      echo '<h2>'.$formtitle.'</h2>'."\n";
      echo '<p>&nbsp;</p>'."\n";
      echo '<table border="0" cellspacing="0" cellpadding="2">'."\n";
      echo '  <tr><td align="right"><var>Kdszm:</var></td>'."\n";
      echo '      <td><input type="text" name="_id" '.
           '          value="'.$table->valuebyname('id').'" readonly="readonly" class="readonly" size="6"/>'."\n";
      echo '      <var>FAX szm:</var>'."\n";
      echo '      <input type="text" name="fax" '.
           '          value="'.$table->valuebyname('fax').'" />'."\n";
      echo '      <var>Krzet:</var>'."\n";
      echo '      <input type="text" name="korzet" '.
           '          value="'.$table->valuebyname('korzet').'" /></td>'."\n";
      echo '  </tr>'."\n";
      echo '  <tr><td align="right"><var>Cgnv:</var></td>'."\n";
      echo '      <td colspan="2"><input type="text" name="cegnev" '.
           '          value="'.$table->valuebyname('cegnev').'" size="80" /></td>'."\n";
      echo '  </tr>'."\n";
      echo '  <tr><td align="right"><var>gyfl:</var></td>'."\n";
      echo '      <td><input type="text" name="ugyfel" '.
           '          value="'.$table->valuebyname('ugyfel').'" size="80" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '  <tr><td align="right"><var>Beoszts:</var></td>'."\n";
      echo '      <td><input type="text" name="beosztas" '.
           '          value="'.$table->valuebyname('beosztas').'" size="40" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '  <tr><td align="right"><var>Irsz:</var></td>'."\n";
      echo '      <td><input type="text" name="irsz" '.
           '          value="'.$table->valuebyname('irsz').'" size="10" />'."\n";
      echo '          <var>Telepls:</var>'."\n";
      echo '          <input type="text" name="telepules" '.
           '          value="'.$table->valuebyname('telepules').'" size="40" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '  <tr><td align="right"><var>Cm:</var></td>'."\n";
      echo '      <td><input type="text" name="cim" '.
           '          value="'.$table->valuebyname('cim').'" size="60" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '  <tr><td align="right"><var>Telefon:</var></td>'."\n";
      echo '      <td><input type="text" name="tel" '.
           '          value="'.$table->valuebyname('tel').'" size="30" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '  <tr><td align="right"><var>E-mail:</var></td>'."\n";
      echo '      <td><input type="text" name="email" '.
           '          value="'.$table->valuebyname('email').'" size="40" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '  <tr><td align="right"><var>Konferencia:</var></td>'."\n";
      echo '      <td><input type="text" name="konferencia" '.
           '          value="'.$table->valuebyname('konferencia').'" size="60" /></td>'."\n";
      echo '   </tr>'."\n";
      echo '</table>'."\n";
      echo '<table border="0" cellspacing="0" cellpadding="2">'."\n";
      echo '<tr>'."\n";
      echo '   <td width="100">&nbsp;</td>'."\n";
      echo '   <td valign="top" width="200">'."\n";
                 echoChkBox($table,'tax'); echo 'Ad<br>';
                 echoChkBox($table,'kozbeszerz'); echo 'Kzbeszerzs<br>';
                 echoChkBox($table,'onkormanyzat'); echo 'nkormnyzat<br>';
                 echoChkBox($table,'tanugyig'); echo 'Tangy<br>';
      echo '    </td>'."\n";
      echo '    <td valign="top">'."\n";
                 echoChkBox($table,'munkaugy'); echo 'Munka gy<br>';
                 echoChkBox($table,'jegyzo'); echo 'Jegyz<br>';
                 echoChkBox($table,'okmanyiroda'); echo 'Okmny iroda<br>';
      echo '    </td>'."\n";
      echo '    <td>'."\n";
      echo '    </td>'."\n";
      echo '</table>'."\n";
}

$act = getPOST('act'); if ($act=='') $act='browse';
$top = getPOST('top'); if ($top=='') $top=0;
$selected = getPOST('selected');  if ($selected=='') $selected=0;
$selectedId = getPOST('selectedId');  if ($selectedId=='') $selectedId='0';
$searchStr = getPOST('searchStr');
$filter = getPOST('filter');  if ($filter == '') $filter = 'fl.id >= 0';
$order = getPOST('order'); if ($order == '') $order='fl.cegnev';
$totalrecords = 0;

echo '<div id="divfaxlista" style="background-color:white; border-style:solid; position:absolute; z-index:2; left:30px; top:30px; width:750px">'."\n";

if ($act=='dofilter') {
  // j $filter kialakitsa
  $filter1 = '';
  if (getPOST('filkorzet') != '')
    $filter1 .= "(fl.korzet = '".getPOST('filkorzet')."')";
  $filter2 = '';
  if (getPOST('filtax') != '')
    $filter2 .= " or fl.tax <> ''";
  if (getPOST('filkozbeszerz') != '')
    $filter2 .= " or fl.kozbeszerz <> ''";
  if (getPOST('filonkormanyzat') != '')
    $filter2 .= " or fl.onkormanyzat <> ''";
  if (getPOST('filtanugyig') != '')
    $filter2 .= " or fl.tanugyig <> ''";
  if (getPOST('filmunkaugy') != '')
    $filter2 .= " or fl.munkaugy <> ''";
  if (getPOST('filjegyzo') != '')
    $filter2 .= " or fl.jegyzo <> ''";
  if (getPOST('filokmanyiroda') != '')
    $filter2 .= " or fl.okmanyiroda <> ''";
  if ($filter2 != '') {
    if ($filter1 != '')
      $filter = $filter1.' and (fl.id < 0 '.$filter2.')';
    else
      $filter = '(fl.id < 0 '.$filter2.')';

  } else {
    $filter = $filter1;
  }
  $act = 'browse';
}
if ($act=='doorder') {
   // j $order kialakitsa
   if (getPOST('newOrder') != '') {
     $order = getPOST('newOrder');
     $act = 'browse';
   }
}
if ($act=='searchFirst') {
  $top = 0;
  $selected = -1;
  $act='searchNext'; // r csorog a kvetkez if -re!
}
if ($act=='searchNext') {
  // sql lekrs, soros keress ellrl
  // $top, $selected belltsa
  $selected = $selected + 1;
  $q->sql = 'select fl.* from '.$config['dbpre'].'faxlista fl '.
               'left outer join '.$config['dbpre'].'faxtiltas ft on ft.fax=fl.fax and ft.korzet=fl.korzet '.
               'where ft.id is null ';
  if ($filter != '')
     $q->sql .= ' and '.$filter;
  if ($order != '')
     $q->sql .= ' order by '.$order;
  $find = -1;
  $q->open();
  if ($q->recordCount > 0) {
     $q->first();
     $recNo = 0;
     while ((!$q->eof) & ($recNo < ($top + $selected))) {
       $q->next();
       $recNo ++;
     }
     while (!$q->eof) {
       $jo = false;
       for ($j=0; $j < count($q->fields); $j++) {
         if (!(stripos($q->fields[$j]->value,$searchStr) === false))
            $jo = true;
       }
       if ($jo) {
         $find = $recNo;
         $q->last();
       }
       $q->next();
       $recNo++;
     }
  }
  $q->close;
  if ($find >= 0) {
    $top = 0;
    while ($find > $pageSize) {
      $top = $top + $pageSize;
      $find = $find - $pageSize;
    }
    $selected = $find;
  } else {
    if ($selected > 0)
       $selected = $selected - 1;
  }
  $act='browse';
}
if ($act=='doinsert') {
  // form ellenrzs
  // ha j felvitel s $act='browse'
  // ha nem j:
  //    hibajelzs s form ujra a POST -ban lv adatokkal
  //    $act='insertform'
  $t = new Ttable('t',$db,$config['pre'].'faxlista');
  $t->filter = 'id = -1';
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->append();
  for ($i=0; $i<count($t->fields); $i++)
    $t->fields[$i]->value = '';
  $t->getFromPOST();
  $t->post();
  $act = 'browse';
}
if ($act == 'doupdate') {
  // form ellenrzs
  // ha j modosits s $act='browse'
  // ha nem j:
  //    hibajelzs s form ujra a POST -ban lv adatokkal
  //    $act='updateform'


  $t = new Ttable('t',$db,$config['pre'].'faxlista');
  $t->filter = 'id = '.getPOST('id');
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->edit();
  for ($i=0; $i<count($t->fields); $i++)
    $t->fields[$i]->value = '';
  $t->getFromPOST();
  $t->post();
  $act = 'browse';
}
if ($act=='dodelete') {
  // trls s $act='browse'
  $t = new Ttable('t',$db,$config['pre'].'faxlista');
  $t->filter = 'id = '.$selectedId;
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->delete();
  $act = 'browse';
}
if ($act=='doletilt') {
   $q->sql = 'insert into '.$config['dbpre'].'faxtiltas '.
             'select id, now(), fax, korzet, cegnev, ugyfel, beosztas, irsz, varos, cim, tel, email, konferencia,'.
	     'tax, kozbeszerz, munkaugy, tanugyig, onkormanyzat, jegyzo,'.
	     'okmanyiroda, tartalek1, tartalek2, tartalek3, tartalek4,'.
	     'tartalek5 '.
             'from '.$config['dbpre'].'faxlista '.
             'where id = '.$selectedId;
  $q->execsql();
  $act='browse';
}



// sszes rekorszm lekr sql
if ($filter=='')
   $q->sql = 'select count(*) from '.$config['pre'].'faxlista fl '.
             'left outer join '.$config['pre'].'faxtiltas ft '.
             '  on ft.fax=fl.fax and ft.korzet = fl.korzet '.
             'where ft.id is null';
else
   $q->sql = 'select count(*) from '.$config['pre'].'faxlista fl '.
             'left outer join '.$config['pre'].'faxtiltas ft '.
             '  on ft.fax=fl.fax and ft.korzet = fl.korzet '.
             'where ft.id is null and '.$filter;

$q->open();
if ($q->recordCount > 0) {
  $q->first();
  $totalRecords = $q->fields[0]->value;
} else {
  $totalRecords = 0;
}
$q->close();

echo '<h1>FAX lista</h1>'."\n";

// order form
echo '<div class="orderform">'."\n";
echo '<form name="frmorder" action="./faxlista.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="doorder">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p>Rendezs:<select name="newOrder">'."\n";
     echoOption('fl.id','Kdszm',$order);
     echoOption('fl.cegnev','Cg neve',$order);
     echoOption('fl.ugyfel','gyfl neve',$order);
     echoOption('fl.varos','Telepls',$order);
     echoOption('fl.korzet,fl.fax','Krzet+fax szm',$order);
echo '</select>'."\n";
echo '<button type="submit">trendez</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// filter form rajzolsa, kezd rtkek a $filter-bl jnnek
$filkorzet = '';
$w = explode(')',$filter);
if (count($w) > 1) {
  $w2 = explode("'",$w[0]);
  $filkorzet = $w2[1];
}
echo '<div class="filterform">'."\n";
echo '<form name="frmfilter" action="./faxlista.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="dofilter">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p><b>Szrs:</b>&nbsp;&nbsp;&nbsp;'."\n";
echo '<var>Krzet:</var>'."\n";
echo '<input type="text" name="filkorzet" value="'.$filkorzet.'" /></p>'."\n";
echo '<p>'."\n";
echoFilter($filter,'tax'); echo 'Ad ';
echoFilter($filter,'kozbeszerz'); echo 'Kzbeszerzs ';
echoFilter($filter,'onkormanyzat'); echo 'nkormnyzat ';
echoFilter($filter,'tanugyig'); echo 'Tangy ';
echoFilter($filter,'munkaugy'); echo 'Munkagy ';
echoFilter($filter,'jegyzo'); echo 'Jegyz ';
echoFilter($filter,'okmanyiroda'); echo 'Okmnyiroda ';
echo '<button type="submit">Szrst alkalmaz</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// bngsz iframe
echo '<center><iframe name="ifrm0" width="98%" height="'.$ifrmHeight.'"></iframe></center>'."\n";
// bngsz tblzat iframe-be betltshez szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmbongeszo" action="./faxlista0.php" method="post" target="ifrm0">'."\n";
echo '<input type="hidden" name="act" value="'.$browse.'">'."\n";
echo '<input type="hidden" name="pageSize" value="'.$pageSize.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<input type="hidden" name="labels" value="'.implode(';',$labels).'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// lapoz gombsor kiirsa
echo '<p class="gridjumper">';
echo 'sszesen '.$totalRecords.' sor &nbsp;&nbsp;&nbsp;';
echo 'Oldalak:&nbsp;'."\n";
       $j0 = ($top / $pageSize); // current page
       $jmax = ($totalRecords / $pageSize); // max page
       $elozoKiirva = false;
       $i = 0; // rekordszm
       $j = 0; // oldalszm
       while ($j <= $jmax) {
          if (($j < 5) |
              ($j > $jmax - 5) |
              (abs($j - $jmax/2) < 5) |
              (abs($j - $j0) < 5)
             ) {
               echoPager($j,$j0,$i);
               $elozoKiirva = treu;
          } else {
               if ($elozoKiirva) echo '...';
               $elozoKiirva = false;
          }
          $i = $i + $pageSize;
          $j++;
       }
echo '</p>'."\n";

// bngsz iframe feltltse
echo '<script type="text/javascript">'."\n";
echo 'document.forms.frmbongeszo.submit();'."\n";
echo '</script>'."\n";

// manipull gombsor
echo '<p><button type="button" onclick="viewform();"><img src="./images/info.gif">Megnz</button>&nbsp;';
echo '<button type="button" onclick="updateform();"><img src="./images/buttonedit.gif">Mdosit</button>&nbsp;';
echo '<button type="button" onclick="insertform();"><img src="./images/buttoninsert.gif">j felvitel</button>&nbsp;';
echo '<button type="button" onclick="dodelete();"><img src="./images/buttondel.gif">Trl</button>&nbsp'."\n";
echo '<button type="button" onclick="searchFirst();"><img src="./images/buttonfind.gif">Keres ellrl</button>&nbsp;'."\n";
echo '<button type="button" onclick="searchNext();"><img src="./images/buttonfind.gif">Tovbb Keres</button>&nbsp;'."\n";
echo '<button type="button" onclick="doload();"><img src="./images/openfolder.gif">Betlt</button>&nbsp;'."\n";
echo '<button type="button" onclick="duplak();"><img src="./images/duplak.gif">Duplk</button>&nbsp;'."\n";
echo '<button type="button" onclick="doletilt();"><img src="./images/stop.gif">Letilt</button>&nbsp;'."\n";
$url = "'faxtiltas.php'";
echo '<button type="button" onclick="location='.$url.'"><img src="images/tiltasok.gif">Letiltsok</button>&nbsp;'."\n";
echo '<button type="button" onclick="doexcelexport();"><img src="./images/grid.gif">Export EXCEL-be</button>&nbsp;'."\n";
echo '<button type="button" onclick="dokuld();"><img src="./images/start.gif">Klds indtsa</button>&nbsp;'."\n";
$url = "'index.php'";
echo '<button type="button" onclick="location='.$url.'"><img src="images/buttoncancel.gif">Vissza a kezd lapra</button></p>'."\n";

// sajtmaga visszahivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="visszahivo" action="./faxlista.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="selectedId" value="'.$selectedId.'">'."\n";
echo '<input type="hidden" name="searchStr" value="'.$searchStr.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

if ($act == 'insertform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:250px; top:20px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./faxlista.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'faxlista where id < 0';
  $q->open();
  $q->first();
  echodataform($q,'FAX lista j sor felvitele');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}
if ($act == 'viewform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:250px; top:20px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./faxlista.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'faxlista where id = '.$selectedId;
  $q->open();
  $q->first();
  echodataform($q,'FAX lista megtekints');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'inputs = document.getElementsByTagName("INPUT");'."\n";
  // input mezk set readonly
  echo 'for (i=0; i < inputs.length; i++) {'."\n";
  echo '  inputs[i].readOnly = true;'."\n";
  echo '  inputs[i].disabled = true;'."\n";
  echo '}'."\n";
  echo '</script>'."\n";
}
if ($act == 'updateform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:250px; top:20px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./faxlista.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'faxlista where id = '.$selectedId;
  $q->open();
  $q->first();
  echodataform($q,'FAX lista mdosts');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}

echo '<script type="text/javascript">'."\n";
echo 'selected = '.$selected.';'."\n";
echo 'selectedId = '.$selectedId.';'."\n";
echo 'document.getElementById("divfaxlista").style.width=screen.width - 80;'."\n";
echo 'function jump(newTop) {'."\n";
echo '  selected = 0;'."\n";
echo '  document.forms.visszahivo.top.value=newTop;'."\n";
echo '  document.forms.visszahivo.selected.value="0";'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function viewform() {'."\n";
echo '  document.forms.visszahivo.act.value="viewform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function updateform() {'."\n";
echo '  document.forms.visszahivo.act.value="updateform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function insertform() {'."\n";
echo '  document.forms.visszahivo.act.value="insertform";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchFirst() {'."\n";
echo '  document.forms.visszahivo.searchStr.value=prompt("Keresend:");'."\n";
echo '  document.forms.visszahivo.act.value="searchFirst";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchNext() {'."\n";
echo '  document.forms.visszahivo.act.value="searchNext";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function dodelete() {'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  if (confirm("Trlni akarja ezt az adatot?")) ';
echo '     document.forms.visszahivo.act.value="dodelete";'."\n";
echo '  else'."\n";
echo '     document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doload() {'."\n";
echo '  location="./faxlistaload.php";'."\n";
echo '}'."\n";
echo 'function doletilt() {'."\n";
// a selectedId rekordot t kell msolni a faxtiltas -ba
echo '  document.forms.visszahivo.act.value="doletilt";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function letiltasok() {'."\n";
echo '  location="./faxtiltasok.php";'."\n";
echo '}'."\n";
echo 'function duplak() {'."\n";
echo '  location="./faxdupla.php";'."\n";
echo '}'."\n";
echo 'function doexcelexport() {'."\n";
echo '  document.forms.visszahivo.action="mysql2excel.php";'."\n";
echo '  document.forms.visszahivo.act.value="faxlista";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function dokuld() {'."\n";
echo '}'."\n";
echo 'function ok() {'."\n";
if ($act == 'insertform')
   echo '  document.forms.adatform.act.value="doinsert";'."\n";
if ($act == 'updateform')
   echo '  document.forms.adatform.act.value="doupdate";'."\n";
if ($act == 'viewform')
   echo '  document.forms.adatform.act.value="browse";'."\n";
echo '  document.forms.adatform.submit();'."\n";
echo '}'."\n";
echo 'function cancel() {'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function celclick(row,col) {'."\n";
echo '  selected = row;'."\n";
echo '  document.forms.visszahivo.selected.value=row;'."\n";
echo '}'."\n";
echo '</script>'."\n";
echo '</div>'."\n";
include_once('./footer.php');
?>
