<?php
/*
konfadmin bngsz
Author: Fogler Tibor   foglert@robitbt.hu
Licence: GNU/GPL

ez hivja a konfadmin0.php -t. (tblzatos megjelenits, sor zselekcival)
POST  act, top, selected, filter, order
SESSION oldcegnev
*/
session_start();
global $config,$q,$q2,$q3,$db,$debugLevel;
global $act,$top,$selected,$order,$filter,$uniquekeyValue;
include_once('./config.php');
include_once('./mysqldb.php');
include_once('./login.php');  // $db konnektlja, $q -t krel
include_once('./header.php');
// sor/lap s tblzat mret definilsa
$pageSize = 7;
$ifrmHeight = 230;

// objektumok a msik gp adatbzisnak elrshez
$db2 = new Tdatabase();
$db2->databasename = $config['dbname2'];
$db2->user = $config['user2'];
$db2->password = $config['psw2'];
$db2->host = $config['host2'];
$db2->connect();
echo $lastError;
$q2 = new Tquery('q2',$db2);
echo $lastError;
$q3 = new Tquery('q3',$db);
echo $lastError;


// grid oszlop fejlc cimkk definilsa /lsd konfadmin0 select sql-t!/
$labels = array();
$labels[] = '#';
$labels[] = 'konf.#';
$labels[] = 'rv.';
$labels[] = 'gyf.sz';
$labels[] = 'Lemonds';
$labels[] = 'Cg nv';
$labels[] = 'Telepls';
$labels[] = 'Utca hzszm';
$labels[] = 'F';
$labels[] = 'Rsztvev';
$labels[] = 'Beoszts';
$labels[] = 'Nem';
$labels[] = 'Jel.mdja';
$labels[] = 'E-mail';
$labels[] = 'Krzet';
$labels[] = 'Fax';
$labels[] = 'Telefon';
$labels[] = 'Vegetrinus';
$labels[] = 'Kamara';
$labels[] = 'FAX-ot kr';
$labels[] = 'Egyedi r';
$labels[] = 'r';
$labels[] = 'Spec.szla';
$labels[] = 'Visszaig.';
$labels[] = 'Rsztvett';
$labels[] = 'Proforma szma';
$labels[] = 'Proforma dtuma';
$labels[] = 'Proforma md';
$labels[] = 'Ellegbekr';
$labels[] = 'Proforma sszeg';
$labels[] = 'Fizetett';
$labels[] = 'Fiz.dtuma';
$labels[] = 'Emlkeztet';
$labels[] = 'Elleg szla.szma';
$labels[] = 'Elleg szla.dtuma';
$labels[] = 'Elleg szla.sszeg';
$labels[] = 'Vgszmla szma';
$labels[] = 'Vgszmla dtuma';
$labels[] = 'Vgszmla sszege';
$labels[] = 'Krds';
$labels[] = 'Egyb';
$labels[] = 'T1';
$labels[] = 'T2';
$labels[] = 'S1';
$labels[] = 'S2';
$labels[] = 'Adszm';
$labels[] = 'Irsz';
$labels[] = 'P.irsz';
$labels[] = 'P.telepls';
$labels[] = 'P.cm';
$labels[] = 'Fiz.md';
$labels[] = 'Szlara adosz.kell';
$labels[] = 'Szlara nevek kellenek';

function datumValidate($sdatum) {
   $ev =  0 + substr($sdatum,0,4);
   $ho =  0 + substr($sdatum,5,2);
   $nap =  0 + substr($sdatum,8,2);
   $ki = checkdate($ho, $nap  , $ev);
   if ((substr($sdatum,4,1) != '.') & (substr($sdatum,4,1) != '-')) $ki = false;
   if ((substr($sdatum,7,1) != '.') & (substr($sdatum,7,1) != '-')) $ki = false;
   if (substr($sdatum,4,1) != substr($sdatum,7,1)) $ki = false;
   return $ki;
}

function charset_decode_utf_8($string) {
    /* Only do the slow convert if there are 8-bit characters */
    /* avoid using 0xA0 (\240) in ereg ranges. RH73 does not like that */
    /* HTML &####; kodokat is szri */
    if (ereg("[\200-\237]", $string) or  ereg("[\241-\377]", $string)) {
      // decode three byte unicode characters
      $string = preg_replace("/([\340-\357])([\200-\277])([\200-\277])/e",
      "'&#'.((ord('\\1')-224)*4096 + (ord('\\2')-128)*64 + (ord('\\3')-128)).';'",
      $string);

      // decode two byte unicode characters
      $string = preg_replace("/([\300-\337])([\200-\277])/e",
      "'&#'.((ord('\\1')-192)*64+(ord('\\2')-128)).';'",
      $string);
    }
    $string = str_replace('&#336;','',$string);
    $string = str_replace('&#337;','',$string);
    $string = str_replace('&#9642;','-',$string);
    $string = html_entity_decode($string);
    $string = str_replace("\n",'<br>',$string);
    $string = str_replace("\r",'',$string);
    $string = str_replace(chr(192),'',$string);
    $string = str_replace(chr(194),'',$string);
    $string = str_replace(chr(195),'',$string);
    $string = str_replace(chr(196),'',$string);
    $string = str_replace(chr(197),'',$string);
    $string = str_replace(chr(200),'',$string);
    $string = str_replace(chr(202),'',$string);
    $string = str_replace(chr(203),'',$string);
    $string = str_replace(chr(204),'',$string);
    $string = str_replace(chr(206),'',$string);
    $string = str_replace(chr(207),'',$string);
    $string = str_replace(chr(210),'',$string);
    $string = str_replace(chr(212),'',$string);
    $string = str_replace(chr(213),'',$string);
    $string = str_replace(chr(217),'',$string);
    $string = str_replace(chr(219),'',$string);
    $string = str_replace(chr(224),'',$string);
    $string = str_replace(chr(226),'',$string);
    $string = str_replace(chr(227),'',$string);
    $string = str_replace(chr(228),'',$string);
    $string = str_replace(chr(229),'',$string);
    $string = str_replace(chr(232),'',$string);
    $string = str_replace(chr(234),'',$string);
    $string = str_replace(chr(235),'',$string);
    $string = str_replace(chr(236),'',$string);
    $string = str_replace(chr(238),'',$string);
    $string = str_replace(chr(239),'',$string);
    $string = str_replace(chr(242),'',$string);
    $string = str_replace(chr(244),'',$string);
    $string = str_replace(chr(249),'',$string);
    $string = str_replace(chr(251),'',$string);
    $string = str_replace(chr(251),'',$string);
    $string = str_replace(chr(245),'',$string);
    return $string;
}

// segd rutinok
function echoPager($j,$j0,$i) {
     if ($j == $j0)
         echo '<big><b>'.($j+1).'</b></big>&nbsp;';
      else
         echo '<a href="#" onclick="jump('.$i.')">'.($j+1).'</a>&nbsp;';
}
function echoOption($value,$label,$actValue) {
  if ($value==$actValue)
    echo '<option value="'.$value.'" selected="selected">'.$label.'</option>'."\n";
  else
    echo '<option value="'.$value.'">'.$label.'</option>'."\n";
}
function echoChkBox($table,$name) {
  if ($table->valuebyname($name)=='')
    echo '<input type="checkbox" name="'.$name.'" value="X" />'."\n";
  else
    echo '<input type="checkbox" checked="checked" name="'.$name.'" value="X" />'."\n";
}
function echoFilter($filter,$nev) {
  $i = stripos($filter,"ka.".$nev." <> ''");
  if ($i === false)
    echo '<input type="checkbox" name="fil'.$nev.'" value="X">';
  else
    echo '<input type="checkbox" name="fil'.$nev.'" checked="checked" value="X">';
}
// adatkperny segd rutinok
function edit($ds,$label,$fieldName,$size,$readOnly) {
  if ($readOnly) {
     echo '<input type="hidden" name="'.$fieldName.'" value="'.$ds->valuebyname($fieldName).'">'."\n";
     echo '<span style="width:150px">'.$label.'</span><input type="text" name="ro_'.$fieldName.'" class="readonly" readonly="readonly"  size="'.$size.'" value="'.$ds->valuebyname($fieldName).'">'."\n";
  } else {
     echo '<span style="width:150px">'.$label.'</span><input type="text" name="'.$fieldName.'" size="'.$size.'" value="'.$ds->valuebyname($fieldName).'">'."\n";
  }
}
function checkBox($ds,$label,$fieldName,$size,$readOnly,$trueValue,$falseValue) {
  $options = array();
  $options[] = array($trueValue,'Igen');
  $options[] = array($falseValue,'Nem');
  if ($ds->valuebyname($fieldName) != $trueValue)
     $ds->setvaluebyname($fieldName,$falseValue);
  comboBox($ds,$label,$fieldName,$size,$readOnly,$options);
}
// $otions kt dimenzios array, [i][0]=value , [i][1]=label
function comboBox($ds,$label,$fieldName,$size,$readOnly,$options) {
  if ($readOnly) {
     echo '<input type="hidden" name="'.$fieldName.'" value="'.$ds->valuebyname($fieldName).'">'."\n";
     echo '<span style="width:150px">'.$label.'</span><input type="text" name="ro_'.$fieldName.'" class="readonly" readonly="readonly" value="'.$ds->valuebyname($fieldName).'" size="'.$size.'">'."\n";
  } else {
     echo '<span style="width:150px">'.$label."</span>\n";
     echo '<select name="'.$fieldName.'" size="1">'."\n";
     for ($i=0; $i<count($options); $i++) {
       if ($options[$i][0]==$ds->valuebyname($fieldName))
         echo '<option value="'.$options[$i][0].'" selected="selected">'.$options[$i][1].'</option>'."\n";
       else
         echo '<option value="'.$options[$i][0].'">'.$options[$i][1].'</option>'."\n";
     }
     echo '</select>'."\n";
  }
}
// rvnyes rekordokban kpzi a cegId-t (ha mg nincs neki)
function makeCegId($table) {
  global $db,$q3;
  if ($table->valuebyname('ervenyes')=='I') {
     if (($table->valuebyname('cegid')=='0') | ($table->valuebyname('cegid')=='') |
         ($table->valuebyname('cegid')=='?')) {
          $q3->sql = 'select max(cegid) cegid from '.$config['dbpre'].'konfadmin '.
                     'where konfid = '.$table->valuebyname('konfid');
          $q3->open();
          if ($q3->recordCount > 0) {
             $q3->first();
             $table->setvaluebyname('cegid',1 + $q3->valuebyname('cegid'));
          }
          $q3->close();
     }
  }
}

// adat kperny
function echodataform($table,$formtitle) {
      global $dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
      echo '<div style="font-family:Times New Roman; font-size:10pt; font-weight:normal; text-decoration:none; font-style:normal">'."\n";
      echo '<h2>'.$formtitle.'</h2>'."\n";
      edit($table,'Kd:','id',6,true);
      edit($table,'Konf.kd:','konfid',6,true);
      checkBox($table,'rvnyes:','ervenyes',6,false,'I','N');
      edit($table,'gyfl szm:','cegid',6,false);
      edit($table,'Lemonds:','lemondas',10,false);
      edit($table,'Ltszm:','letszam',2,false);
      $options = array();
      $options[] = array('ONLINE','On-line');
      $options[] = array('IDOBEN','Idben');
      $options[] = array('KESON','Ksn');
      comboBox($table,'Jelentkezs mdja:','jelmod',6,false,$options);
      echo '<hr>'."\n";
      edit($table,'Cg:','cegnev',100,false);
      edit($table,'Adszm:','cegadosz',14,false);
      edit($table,'Jel.dtum:','tartalek1',10,false);
      echo '<br>'."\n";
      edit($table,'Szmlzsi cm Irsz:','irsz',6,false);
      edit($table,'Telepls:','varos',40,false);
      edit($table,'Cm:','cim',60,false);
      echo '<br>'."\n";
      edit($table,'Postzsi cm &nbsp;&nbsp; irsz:','pirsz',6,false);
      edit($table,'Telepls:','pvaros',40,false);
      edit($table,'Cm:','pcim',60,false);
      echo '<hr>'."\n";
      edit($table,'<b>Rsztvev:</b>','nev',100,false);
      checkBox($table,'E-mailt kldeni neki:','viszigkell',6,false,'I','N');
      echo '<br>'."\n";
      edit($table,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Lakcm:','lakcim',100,false);
      echo '<br>'."\n";
      edit($table,'&nbsp;&nbsp;Beoszts:','beosztas',50,false);
      $options = array();
      $options[] = array('FFI','Frfi');
      $options[] = array('NO','N');
      $options[] = array('','?');
      comboBox($table,'Neme:','nem',6,false,$options);
      checkBox($table,'Vegetrinus:','vega',6,false,'I','');
      edit($table,'<b>kamarai szm:</b>','kamara',20,false);
      echo '<br>'."\n";
      edit($table,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;E-mail:','email',60,false);
      edit($table,'Krzet:','korzet',2,false);
      edit($table,'FAX:','fax',18,false);
      edit($table,'Telefon:','tel',18,false);
      checkBox($table,'Rsztvett:','resztvett',4,false,'I','');
      echo '<hr>'."\n";
      $options = array();
      $options[] = array('ATUT','tutals');
      $options[] = array('KP','KP');
      //$options[] = array('POSTA','Posta');
      comboBox($table,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Fizetsi md:','fizmod',6,false,$options);
      checkBox($table,'Szla.ra adszm:','szlaadosz',6,false,'I','N');
      checkBox($table,'Szla.ra nevek:','szlanev',6,false,'I','N');
      checkBox($table,'FAX-ot kr:','faxotker',6,false,'I','N');
      checkBox($table,'Egyedi r:','egyediar',6,false,'I','N');
      checkBox($table,'Spec.szmla:','egyediszla',6,false,'I','N');
      echo '<br>'."\n";
      edit($table,'&nbsp;&nbsp;&nbsp;Visszaigazols:','visszaig',12,false);
      edit($table,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;r/f:','ar',10,false);
      echo '<hr>'."\n";
      edit($table,'<b>Proforma</b> szma:','prf_szam',10,false);
      if ($table->valuebyname('prf_szam') != '') {
        $s = $table->valuebyname('prf_szam');
        $i = strpos($s,'/');
        if ($i > 0) {
          $s = substr($s,0,$i);
          echo '<a href="proforma/'.$s.'.pdf" target="">Megnz</a>&nbsp;'."\n";
        }
      }
      edit($table,'dtum:','prf_datum',10,false);
      $options = array();
      $options[] = array('EMAIL','E-mail');
      $options[] = array('FAX','FAX');
      //comboBox($table,'md:','prf_mod',6,false,$options);
      checkBox($table,'Ellegbekr:','prf_elolegbekero',6,false,'I','N');
      edit($table,'sszeg:','prf_osszeg',10,false);
      echo '<hr>'."\n";
      edit($table,'&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Emlkeztet','emlekezteto',10,false);
      echo '&nbsp;|&nbsp;';
      edit($table,'<b>Elleg szla</b> szma:','eszla_szam',10,false);
      edit($table,'dtuma:','eszla_datum',10,false);
      edit($table,'sszege:','eszla_osszeg',10,false);
      echo '<hr>'."\n";
      edit($table,'&nbsp;&nbsp;<b>Vg szla.</b> szma:','vszla_szam',10,false);
      edit($table,'dtuma:','vszla_datum',10,false);
      edit($table,'sszege:','vszla_osszeg',10,false);
      echo '&nbsp;&nbsp;|&nbsp;&nbsp;';
      edit($table,'<b>Fizetett:</b>','fizetett',10,false);
      edit($table,'Fiz.dtuma:','fizdat',10,false);
      echo '<hr>'."\n";
      echo 'Krds:<textarea name="kerdes" cols="50" rows="4">'.$table->valuebyname('kerdes'),'</textarea>'."\n";
      echo 'Egyb:<textarea name="egyeb" cols="50" rows="4">'.$table->valuebyname('egyeb'),'</textarea>'."\n";
      echo '<input type="hidden" name="r_id" value="'.$table->valuebyname('r_id').'" />'."\n";
      echo '</div>'."\n";
}
function makeOldcegNev($t) {
    return ' upper(cegnev)=upper("'.$t->valuebyname('cegnev').'") and '.
           ' upper(varos)=upper("'.$t->valuebyname('varos').'") and '.
           ' upper(irsz)=upper("'.$t->valuebyname('irsz').'")';
}

// insert s update utn hivand eljrs
function afterPost($id) {
  global $q;
  if ($id == '') {
    $q->sql = 'select max(id) maxid from konfadmin';
    $q->open();
    $q->first();
    $id = $q->valuebyname('maxid');
    $q->close();
  }
  $q->sql = 'select * from '.$config['dbpre'].'konfadmin where id = '.$id;
  $q->open();
  $q->first();
  $cegnev = $q->valuebyname('cegnev');
  $varos = $q->valuebyname('varos');
  $irsz = $q->valuebyname('irsz');
  $prf_szam = $q->valuebyname('prf_szam');
  $konfid = $q->valuebyname('konfid');
  if (isset($_SESSION['oldcegnev'])) {
    // cg szint adatok kiolvassa
    $s='';
    $s .= 'cegnev = "'.$q->valuebyname('cegnev').'"';
    $s .= ',cegadosz = "'.$q->valuebyname('cegadosz').'"';
    $s .= ',irsz = "'.$q->valuebyname('irsz').'"';
    $s .= ',varos = "'.$q->valuebyname('varos').'"';
    $s .= ',cim = "'.$q->valuebyname('cim').'"';
    $s .= ',pirsz = "'.$q->valuebyname('pirsz').'"';
    $s .= ',pvaros = "'.$q->valuebyname('pvaros').'"';
    $s .= ',pcim = "'.$q->valuebyname('pcim').'"';
    $s .= ',fizmod = "'.$q->valuebyname('fizmod').'"';
    $s .= ',szlaadosz = "'.$q->valuebyname('szlaadosz').'"';
    $s .= ',szlanev = "'.$q->valuebyname('szlanev').'"';
    $s .= ',faxotker = "'.$q->valuebyname('faxotker').'"';
    $s .= ',egyediszla = "'.$q->valuebyname('egyediszla').'"';
    $s .= ',prf_szam = "'.$q->valuebyname('prf_szam').'"';
    $s .= ',prf_datum = "'.$q->valuebyname('prf_datum').'"';
    $s .= ',prf_mod = "'.$q->valuebyname('prf_mod').'"';
    $s .= ',prf_elolegbekero = "'.$q->valuebyname('prf_elolegbekero').'"';
    $s .= ',prf_osszeg = "'.$q->valuebyname('prf_osszeg').'"';
    $s .= ',fizetett = "'.$q->valuebyname('fizetett').'"';
    $s .= ',fizdat = "'.$q->valuebyname('fizdat').'"';
    $s .= ',emlekezteto = "'.$q->valuebyname('emlekezteto').'"';
    $s .= ',eszla_szam = "'.$q->valuebyname('eszla_szam').'"';
    $s .= ',eszla_datum = "'.$q->valuebyname('eszla_datum').'"';
    $s .= ',eszla_osszeg = "'.$q->valuebyname('eszla_osszeg').'"';
    $s .= ',vszla_szam = "'.$q->valuebyname('vszla_szam').'"';
    $s .= ',vszla_datum = "'.$q->valuebyname('vszla_datum').'"';
    $s .= ',vszla_osszeg = "'.$q->valuebyname('vszla_osszeg').'"';
    $q->close();
    // cg szint adatok kitrolsa $_SESSION['oldcegnev'] felhasznlsval
    $q->sql = 'update '.$config['dbpre'].'konfadmin set '.$s.' where konfid = '.$konfid.' and '.
              $_SESSION['oldcegnev'];
    $q->execsql();

    if ($lastError != '')
       echo "<hr>".$lastError.' '.$q->sql."<hr>";

    unset($_SESSION['oldcegnev']);
  }
  // ha ebben a rekordban mg nincs hizz proforma akkor
  // az esetleges korbbi proforma s visszaigazols rvnytelen
  if ($prf_szam == '') {
    $q->sql = 'delete from proforma where konfid = '.$konfid.
              '  and cegnev = "'.$cegnev.'" and varos="'.$varos.'" and irsz="'.$irsz.'"';
    $q->execsql();
    $q->sql = 'update konfadmin '.
              'set prf_szam="",prf_datum="",visszaig="" '.
              'where konfid= '.$konfid.' and cegnev = "'.$cegnev.'" and varos="'.$varos.'" and irsz="'.$irsz.'"';
    $q->execsql();
  }
}
function getValueFromFilter($filter,$nev) {
  $result = '';
  $w = explode($nev."='",$filter);
  if (count($w) > 0) {
    $w2 = explode("'",$w[1]);
    $result = $w2[0];
  }
  return $result;
}
function getValueFromFilter2($filter,$nev) {
  $result = '';
  $w = explode($nev." like '%",$filter);
  if (count($w) > 0) {
    $w2 = explode("%'",$w[1]);
    $result = $w2[0];
  }
  return $result;
}
$act = getPOST('act'); if ($act=='') $act='browse';
$top = getPOST('top'); if ($top=='') $top=0;
$selected = getPOST('selected');  if ($selected=='') $selected=0;
$selectedId = getPOST('selectedId');  if ($selectedId=='') $selectedId='0';
$searchStr = getPOST('searchStr');
$filter = stripslashes(getPOST('filter'));  if ($filter == '') $filter = '(ka.konfid = -1)';
$order = getPOST('order'); if ($order == '') $order='4';
$totalrecords = 0;
$errorMsg = '';
if (isset($_SESSION['konfid']) & ($filter == '(ka.konfid = -1)'))
  $filter = '(ka.konfid = '.$_SESSION['konfid'].')';

echo '<div id="divkonfadmin" style="background-color:white; border-style:solid; position:absolute; z-index:2; left:30px; top:30px; width:750px">'."\n";
if (getPOST('act')=='') {
  unset($_SESSION['oldcegnev']);

  // adat tvtel a regist tblbl
  // lekri az ediigi mac regid -t
  $q->sql = 'select max(r_id) regid from '.$config['dbpre'].'konfadmin';
  $q->open();
  if ($q->recordCount > 0) {
    $q->first();
    $regid = $q->valuebyname('regid');
  } else {
    $regid = -1;
  }
  $q->close();
  if ($regid=='') $regid = -1;


  // sql -el lekri a regist adatbzis r_id > $regid (msik gpen van!)
  // s vgig olvassa az eredmnyt
  $q2->sql='set names utf8';
  $q2->execsql();
  $q2->sql = 'select * from regisztracio where r_id > '.$regid.' order by r_id';
  $q2->open();
  if ($q2->recordCount > 0) {
    $q2->first();
    while (!$q2->eof) {
      // a rsztvevk neveti vessznl sztbontom
      // mindegyik nv egy-egy sort eredmnyez
      $w = $q2->valuebyname('r_nev');
       $w = str_replace(';',',',$w);
       $w = str_replace('/',',',$w);
       $w = str_replace('+',',',$w);
       $nevek = explode(',',$w);
       for ($i=0; $i<count($nevek); $i++) {
         $q->sql = "insert into ".$config['dbpre']."konfadmin
              (konfid, r_id, ervenyes, cegid, visszaig,
              cegnev, cegadosz,
              irsz, varos, cim,
              pirsz, pvaros, pcim, fizmod,
	      letszam, nev, email,
              korzet, fax, tel, beosztas,
              jelmod,nem, vega,
              kamara, faxotker, szlaadosz, szlanev,
	      egyediar, ar, egyediszla, lemondas,
	      resztvett, prf_szam, prf_datum,
	      prf_mod, prf_elolegbekero, prf_osszeg,
              fizetett, fizdat,
              emlekezteto,  eszla_szam, eszla_datum,  eszla_osszeg,
              vszla_szam, vszla_datum,  vszla_osszeg,
              kerdes, egyeb,
              lakcim, viszigkell,
              tartalek1,  tartalek2, seged1, seged2) values (".
              '"'.$q2->valuebyname('k_konfid').'","'.$q2->valuebyname('r_id').'","N",0,"",'.
              '"'.charset_decode_utf_8($q2->valuebyname('r_koltsegviselo')).'","",'.
              '"'.$q2->valuebyname('r_iranyitoszam').'","'.charset_decode_utf_8($q2->valuebyname('r_helyseg')).'","'.charset_decode_utf_8($q2->valuebyname('r_cim')).'",'.
              '"","","'.charset_decode_utf_8($q2->valuebyname('r_postacim')).'","'.charset_decode_utf_8($q2->valuebyname('r_fizetes')).'",'.
              '"1","'.charset_decode_utf_8(trim($nevek[$i])).'","'.$q2->valuebyname('r_email').'",'.
              '"","'.$q2->valuebyname('r_fax').'","'.$q2->valuebyname('r_telefon').'","'.charset_decode_utf_8($q2->valuebyname('r_beosztas')).'",'.
              '"ONLINE","","'.$q2->valuebyname('r_vegamenu').'",'.
              '"'.$q2->valuebyname('r_mkk_tagszam').'","N","","",'.
              '"N",0.00,"N","",'.
              '"","","",'.
              '"","",0.0,'.
              '0.0,"",'.
              '"","","",0.0,'.
              '"","",0.0,'.
              '"'.charset_decode_utf_8($q2->valuebyname('r_kerdes')).'",'.'"'.charset_decode_utf_8($q2->valuebyname('r_egyeb')).'",'.
              '"'.charset_decode_utf_8($q2->valuebyname('r_lakcim')).'","I",'.
              '"'.date('Y-m-d',$q2->valuebyname('r_datum')).'","","",""'.
	      ")";
	   $q->execsql();
       }
       $q2->next();
    }
  }
  $q2->close();
  echo $lastError;
  $q2->sql='set names latin1';
  $q2->execsql();

  // adat tvtel a konferencia tblbl
  $q->sql = "CREATE TABLE IF NOT EXISTS konferenciak (
  k_id int(6) NOT NULL,
  k_cim text NOT NULL,
  k_ido varchar(50) NOT NULL,
  k_eloado text NOT NULL,
  k_helyszin int(4) NOT NULL,
  k_reszvetelidij int(7) NOT NULL,
  k_bevezeto text NOT NULL,
  k_tematika text NOT NULL,
  k_feltetelek text NOT NULL,
  k_modified int(14) NOT NULL DEFAULT '0',
  k_aktiv int(1) NOT NULL DEFAULT '0',
  k_mkk int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (k_id)
  )";
  $q->execsql();
  // lekri az ediigi mac k_id -t
  $q->sql = 'select max(k_id) maxk_id from '.$config['dbpre'].'konferenciak';
  $q->open();
  if ($q->recordCount > 0) {
    $q->first();
    $maxk_id = $q->valuebyname('maxk_id');
  } else {
    $maxk_id = -1;
  }
  $q->close();
  if ($maxk_id == '') $maxk_id = -1;
  // sql -el lekri a regist adatbzis r_id > $regid (msik gpen van!)
  // s vgig olvassa az eredmnyt
  $q2->sql='set names utf8';
  $q2->execsql();
  $q2->sql = 'select * from konferenciak where k_id > '.$maxk_id.' order by k_id';
  $q2->open();
  //DBG  echo '<hr>q2 open '.$q2->sql.' '.$lastError.'<hr>';
  if ($q2->recordCount > 0) {
    $q2->first();
    while (!$q2->eof) {
       $w = 'insert into konferenciak values('.$q2->fields[0]->value.',';
       for ($i=1; $i<count($q2->fields); $i++) {
         if ($i < 3)
            $w .= '"'.charset_decode_utf_8($q2->fields[$i]->value).'"';
         else
            $w .= '""';
         if ($i==count($q2->fields) - 1)
           $w .= ')';
         else
           $w .= ',';
       }
       $q->sql = $w;
       $q->execsql();
       //DBG echo '<hr>q exec '.$q->sql.' '.$lastError.'<hr>';
       $q2->next();
    }
  }
  $q2->close();
  echo $lastError;
  $q2->sql='set names latin1';
  $q2->execsql();
  //DBG exit();
  // tkodolsok
  $q->sql = 'update '.$config['dbpre'].'konfadmin set fizmod="ATUT" where fizmod="1"';
  $q->execsql();
  $q->sql = 'update '.$config['dbpre'].'konfadmin set fizmod="KP" where fizmod="2"';
  $q->execsql();
  $q->sql = 'update '.$config['dbpre'].'konfadmin set vega="I" where vega="1"';
  $q->execsql();
  $q->sql = 'update '.$config['dbpre'].'konfadmin set vega="" where vega="0"';
  $q->execsql();

  // ltszm meghatrozs (ahol letszam = -1 a nev -ben lv vesszk, s, '+' alapjn
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 5
            where ((letszam = -1) or (letszam is null)) and (nev like '%,%,%,%,%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 4
            where ((letszam = -1) or (letszam is null)) and (nev like '%,%,%,%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 3
            where ((letszam = -1) or (letszam is null)) and (nev like '%,%,%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 2
            where ((letszam = -1) or (letszam is null)) and (nev like '%,%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 2
            where ((letszam = -1) or (letszam is null)) and (nev like '%+%1%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 3
            where ((letszam = -1) or (letszam is null)) and (nev like '%+%2%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 4
            where ((letszam = -1) or (letszam is null)) and (nev like '%+%3')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 5
            where ((letszam = -1) or (letszam is null)) and (nev like '%+%4%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 5
            where ((letszam = -1) or (letszam is null)) and (nev like '%s%s%s%s%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 4
            where ((letszam = -1) or (letszam is null)) and (nev like '%s%s%s%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 3
            where ((letszam = -1) or (letszam is null)) and (nev like '%s%s%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 2
            where ((letszam = -1) or (letszam is null)) and (nev like '%s%s%s%')";
  $q->execsql();
  $q->sql = "update ".$config['dbpre']."konfadmin
            set letszam = 1
            where ((letszam = -1) or (letszam is null))";
  $q->execsql();
}
if ($act=='dofilter') {
  // j $filter kialakitsa
  $filter1 = '';
  if (getPOST('filkonfid') != '')
    $filter1 .= trim(getPOST('filkonfid'));
  $filter2 = '';
  if (getPOST('filervenyes') != '')
    $filter2 .= " and ka.ervenyes='I'";
  if (getPOST('filnemervenyes') != '')
    $filter2 .= " and ka.ervenyes<>'I'";
  if (getPOST('filnincsproforma') != '')
    $filter2 .= " and ka.prf_szam=''";
  if (getPOST('filvanproforma') != '')
    $filter2 .= " and ka.prf_szam<>''";
  if (getPOST('filfaxotker') != '')
    $filter2 .= " and ka.faxotker='I'";

  if (getPOST('filvega') != '')
    $filter2 .= " and ka.vega='I'";
  if (getPOST('filnemfizet') != '')
    $filter2 .= " and ka.fizdat=''";
  if (getPOST('filkamara') != '')
    $filter2 .= " and ka.kamara<>''";
  if (getPOST('fillemondas') != '')
    $filter2 .= " and ka.lemondas<>''";
  if (getPOST('filNlemondas') != '')
    $filter2 .= " and ka.lemondas=''";
  if (getPOST('filKP') != '')
    $filter2 .= " and ka.fizmod='KP'";


  if ($filter2 != '') {
    if ($filter1 != '')
      $filter = '('.$filter1.') '.$filter2;
    else
      $filter = $filter2;

  } else {
    if ($filter1 != '')
      $filter = '('.$filter1.')';
    else
      $filter = '';
  }
  if ($_POST['filcegnev'] != '') {
    if ($filter != '')
       $filter .= " and ka.cegnev like '%".$_POST['filcegnev']."%'";
    else
       $filter .= "ka.cegnev like '%".$_POST['filcegnev']."%'";
  }
  if ($_POST['filprf_szam'] != '') {
    if ($filter != '')
       $filter .= " and ka.prf_szam='".$_POST['filprf_szam']."'";
    else
       $filter .= "ka.prf_szam='".$_POST['filprf_szam']."'";
  }
  if ($_POST['filvszla_szam'] != '') {
    if ($filter != '')
       $filter .= " and ka.vszla_szam='".$_POST['filvszla_szam']."'";
    else
       $filter .= "ka.vszla_szam='".$_POST['filvszla_szam']."'";
  }
  if ($_POST['fileszla_szam'] != '') {
    if ($filter != '')
       $filter .= " and ka.eszla_szam='".$_POST['fileszla_szam']."'";
    else
       $filter .= "ka.eszla_szam='".$_POST['fileszla_szam']."'";
  }

  $top = 0;
  $selected = 0;
  $act = 'browse';
}
if ($act=='doorder') {
   // j $order kialakitsa
   if (getPOST('newOrder') != '') {
     $order = getPOST('newOrder');
     $top = 0;
     $selected = 0;
     $act = 'browse';
   }
}
if ($act=='searchFirst') {
  $top = 0;
  $selected = -1;
  $act='searchNext'; // r csorog a kvetkez if -re!
  if ($searchStr == '')
     $act='browse';
}
if ($act=='searchNext') {
  // sszes rekorszm lekr sql
  if ($filter=='')
       $q->sql = 'select count(*) from '.$config['dbpre'].'konfadmin ka ';
  else
       $q->sql = 'select count(*) from '.$config['dbpre'].'konfadmin ka '.
                 'where '.$filter;
  $q->open();
  if ($q->recordCount > 0) {
      $q->first();
      $totalRecords = $q->fields[0]->value;
  } else {
      $totalRecords = 0;
  }
  $q->close();
  // sql lekrs, soros keress $top+$selected -tl
  // j $top, $selected belltsa
  $selected = $selected + 1;

  $sql = "select 	ka.id, ka.konfid, ka.ervenyes,
        if (ka.cegid='','?',lpad(ka.cegid,6,' ')) cegid,
        ka.lemondas, ka.cegnev,
 	ka.varos, ka.cim, ka.letszam, ka.nev, ka.beosztas, ka.nem, ka.jelmod,
	ka.email, ka.korzet, ka.fax, ka.tel,
	ka.vega, ka.kamara, ka.faxotker, ka.egyediar, ka.ar, ka.egyediszla,
	ka.visszaig, ka.resztvett,
        ka.prf_szam, ka.prf_datum, ka.prf_mod, ka.prf_elolegbekero, ka.prf_osszeg,
	ka.fizetett, ka.fizdat,
        ka.emlekezteto,
	ka.eszla_szam, ka.eszla_datum, ka.eszla_osszeg,
        ka.vszla_szam, ka.vszla_datum, ka.vszla_osszeg,
	ka.kerdes, ka.egyeb, ka.tartalek1, ka.tartalek2,
	seged1, seged2, ka.cegadosz, ka.irsz, ka.pirsz, ka.pvaros, ka.pcim, ka.fizmod,
	ka.szlaadosz, ka.szlanev
	from ".$config['dbpre']."konfadmin ka ";

  if ($filter != '')
     $sql .= ' where '.$filter;
  if ($order != '')
     $sql .= ' order by '.$order.',id';
  $find = -1;
  // vgig olvass 1000 rekordos darabokban
  $recNo = $top + $selected;
  for ($top1 = ($top + $selected); (($top1 < $totalRecords) & ($find < 0)); $top1 = $top1 + 1000) {
    $q->sql = $sql.' limit '.$top1.',1000';
    $q->open();
    if ($q->recordCount > 0) {
       $q->first();
       while (!$q->eof) {
         $jo = false;
         for ($j=0; $j < count($q->fields); $j++) {
           if (!(stripos($q->fields[$j]->value,$searchStr) === false))
              $jo = true;
         }
         if ($jo) {
           $find = $recNo;
           $q->last();
         }
         $q->next();
         $recNo++;
       }
    }
    $q->close;
  }
  // j $top, $selected meghatrozsa a $fin -bl
  if ($find >= 0) {
    $top = 0;
    while ($find >= $pageSize) {
      $top = $top + $pageSize;
      $find = $find - $pageSize;
    }
    $selected = $find;
  } else {
    if ($selected > 0)
       $selected = $selected - 1;
    $errorMsg = 'Nincs a keressnek megfelel sor '.$searchStr;
  }
  $act='browse';
}
if ($act=='doinsert') {
  // form ellenrzs
  // ha j felvitel s $act='browse'
  // ha nem j:
  //    hibajelzs s form ujra a POST -ban lv adatokkal
  //    $act='insertform'
  $t = new Ttable('t',$db,$config['dbpre'].'konfadmin');
  $t->filter = 'id = -1';
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->append();
  for ($i=0; $i<count($t->fields); $i++)
    $t->fields[$i]->value = '';
  $t->getFromPOST();
  makeCegId($t);
  if ($t->valuebyname('email')=='')
    $t->setvaluebyname('faxotker','I');
  $t->post();
  afterPost('');
  $act = 'browse';
}
if ($act == 'doupdate') {
  // form ellenrzs
  // ha j modosits s $act='browse'
  // ha nem j:
  //    hibajelzs s form ujra a POST -ban lv adatokkal
  //    $act='updateform'
  $t = new Ttable('t',$db,$config['dbpre'].'konfadmin');
  $t->filter = 'id = '.getPOST('id');
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->edit();
  for ($i=0; $i<count($t->fields); $i++)
    $t->fields[$i]->value = '';
  $t->getFromPOST();
  makeCegId($t);
  if ($t->valuebyname('email')=='')
    $t->setvaluebyname('faxotker','I');
  $t->post();
  afterPost($t->valuebyname('id'));
  $act = 'browse';
}
if ($act=='doFizet') {
  if (!datumValidate(getPOST('datum'))) {
    echo '<script type="text/javascript">'."\n";
    echo 'alert("Hibs dtum adat! '.getPOST('datum').'");'."\n";
    echo '</script>'."\n";
    $act = 'browse';
  } else {
    $t = new Ttable('t',$db,$config['dbpre'].'konfadmin');
    $t->filter = 'id = '.getPOST('id');
    $t->filtered = true;
    $t->open();
    $t->first();
    $t->fields[0]->uniqueId = true;
    $t->edit();
    $t->setvaluebyname('fizdat',getPOST('datum'));
    $t->setvaluebyname('fizetett',getPOST('osszeg'));
    $t->post();
    $_SESSION['oldcegnev']=makeOldcegNev($t);
    afterPost($t->valuebyname('id'));
  }
  $act = 'browse';
}
if ($act=='dodelete') {
  // trls s $act='browse'
  $t = new Ttable('t',$db,$config['dbpre'].'konfadmin');
  $t->filter = 'id = '.$selectedId;
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->delete();
  $act = 'browse';
}
if ($act == 'doErvenyes') {
  $t = new Ttable('t',$db,$config['dbpre'].'konfadmin');
  $t->filter = 'id = '.$selectedId;
  $t->filtered = true;
  $t->open();
  $t->first();
  $t->fields[0]->uniqueId = true;
  $t->edit();
  $t->setvaluebyname('ervenyes','I');
  makeCegId($t);
  $t->post();
  $_SESSION['oldcegnev']=makeOldcegNev($t);
  afterPost($t->valuebyname('id'));
  $act = 'browse';
}
if ($act == 'doFfi') {
  $q->sql='update '.$config['dbpre'].'konfadmin set nem="FFI" where id='.$selectedId;
  $q->execsql();
  $act = 'browse';
}
if ($act == 'doNo') {
  $q->sql='update '.$config['dbpre'].'konfadmin set nem="NO" where id='.$selectedId;
  $q->execsql();
  $act = 'browse';
}
if ($act == 'doResztvett') {
  $q->sql='update '.$config['dbpre'].'konfadmin set resztvett="I" where id='.$selectedId;
  $q->execsql();
  $act = 'browse';
}
if ($act == 'doLemondta') {
  $q->sql='update '.$config['dbpre'].'konfadmin set lemondas="'.$searchStr.'" where id='.$selectedId;
  $q->execsql();
  $searchStr="";
  $act = 'browse';
}
// sszes rekorszm lekr sql
if ($filter=='')
   $q->sql = 'select count(*) from '.$config['dbpre'].'konfadmin ka ';
else
   $q->sql = 'select count(*) from '.$config['dbpre'].'konfadmin ka '.
             'where '.$filter;

$q->open();
if ($q->recordCount > 0) {
  $q->first();
  $totalRecords = $q->fields[0]->value;
} else {
  $totalRecords = 0;
}
$q->close();

echo '<h1>Konferencia szervezs</h1>'."\n";

// order form
echo '<div class="orderform">'."\n";
echo '<form name="frmorder" action="./konfadmin.php" method="post">'."\n";

echo '<input type="hidden" name="act" value="doorder">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p>Rendezs:<select name="newOrder">'."\n";
     echoOption('ka.id','Kdszm',$order);
     echoOption('ka.cegnev','Cg neve',$order);
     echoOption('4','gyfl szm',$order);
     echoOption('ka.nev','Rsztvev neve',$order);
     echoOption('ka.varos','Telepls',$order);
     echoOption('ka.korzet,ka.fax','Krzet+fax szm',$order);
     echoOption('ka.kamara','Kamarai szm',$order);
     echoOption('ka.vega','vegetrinus',$order);
     echoOption('ka.faxotker','FAX-ot kr',$order);

echo '</select>'."\n";
echo '<button type="submit">trendez</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// filter form rajzolsa, kezd rtkek a $filter-bl jnnek
$filkonfid = '';
$w = explode(')',$filter);
if (count($w) > 1) {
  $w2 = explode("=",$w[0]);
  if (count($w2) == 2)
    $filkonfid = trim($w2[1]);
  else {
    $w2 = explode("<>",$w[0]);
    if (count($w2) == 2)
       $filkonfid = trim($w2[1]);
  }
}

echo '<div class="filterform">'."\n";
echo '<form name="frmfilter" action="./konfadmin.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="dofilter">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p><b>Szrs:</b>&nbsp;&nbsp;&nbsp;'."\n";
echo '<var>Konferencia:</var>'."\n";
echo '<select name="filkonfid">'."\n";
if ($filkonfid == '-1')
  echo '<option value="ka.konfid=-1" selected="selected">Vlassz</option>'."\n";
$q->sql = 'select k_id, k_ido, k_cim from '.$config['dbpre2'].'konferenciak order by k_ido DESC';
$q->open();
if ($q->recordCount > 0) {
  $q->first();
  while (!$q->eof) {
    if ($filkonfid==$q->fields[0]->value)
      echo '<option value="ka.konfid='.charset_decode_utf_8($q->fields[0]->value).'" selected="selected">'.
            charset_decode_utf_8(substr($q->fields[1]->value.' '.$q->fields[2]->value,0,100)).'</option>'."\n";
    else
      echo '<option value="ka.konfid='.charset_decode_utf_8($q->fields[0]->value).'">'.
        charset_decode_utf_8(substr($q->fields[1]->value.' '.$q->fields[2]->value,0,100)).'</option>'."\n";
    $q->next();
  }
}
$q->close();
if ($filkonfid=='-2')
  echo '<option value="ka.konfid<>-2" selected="selected">sszes konferencia</option>'."\n";
else
  echo '<option value="ka.konfid<>-2">sszes konferencia</option>'."\n";
echo '</select><br>'."\n";
$filcegnev = getValueFromFilter2($filter,'cegnev');
$filproforma = getValueFromFilter($filter,'prf_szam');
$filvszamla = getValueFromFilter($filter,'vszla_szam');
$fileszamla = getValueFromFilter($filter,'eszla_szam');

echo 'cg nv (rszlet):<input type="text" name="filcegnev" value="'.$filcegnev.'" size="30"/>&nbsp;'."\n";
echo 'proforma szm:<input type="text" name="filprf_szam" value="'.$filproforma.'" size="10"/>&nbsp;'."\n";
echo 'vgszmla szm:<input type="text" name="filvszla_szam" value="'.$filvszamla.'" size="10"/>&nbsp;'."\n";
echo 'ellegszmla szm:<input type="text" name="fileszla_szam" value="'.$fileszamla.'" size="10"/><br />'."\n";

if (strpos($filter,"ka.ervenyes='I'")===false)
  echo '<input type="checkbox" name="filervenyes" value="I" />Csak az rvnyesek'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filervenyes" value="I" />Csak az rvnyesek'."\n";
if (strpos($filter,"ka.ervenyes<>'I'")===false)
  echo '<input type="checkbox" name="filnemervenyes" value="I" />Csak a nem rvnyesek'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filnemervenyes" value="I" />Csak a nem rvnyesek'."\n";
echo '<br>'."\n";
if (strpos($filter,"ka.prf_szam=''")===false)
  echo '<input type="checkbox" name="filnincsproforma" value="I" />Csak aki mg nem kapott proforma bizonylatot'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filnincsproforma" value="I" />Csak aki mg nem kapott proforma bizonylatot'."\n";
if (strpos($filter,"ka.prf_szam<>''")===false)
  echo '<input type="checkbox" name="filvanproforma" value="I" />Csak aki mr kapott proforma bizonylatot'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filvanproforma" value="I" />Csak aki mr kapott proforma bizonylatot'."\n";
if (strpos($filter,"ka.faxotker='I'")===false)
  echo '<input type="checkbox" name="filfaxotker" value="I" />Csak aki FAX-ot lr'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filfaxotker" value="I" />Csak aki FAX-ot lr'."\n";
if (strpos($filter,"ka.vega='I'")===false)
  echo '<br><input type="checkbox" name="filvega" value="I" />Csak aki vegetrinus'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filvega" value="I" />Csak aki vegetrinus'."\n";
if (strpos($filter,"ka.fizdat=''")===false)
  echo '<input type="checkbox" name="filnemfizet" value="I" />Csak aki nem fizetett'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filnemfizet" value="I" />Csak aki nem fizetett'."\n";
if (strpos($filter,"ka.kamara<>''")===false)
  echo '<input type="checkbox" name="filkamara" value="I" />Csak aki kamarai tag'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filkamara" value="I" />Csak aki kamarai tag'."\n";
if (strpos($filter,"ka.lemondas<>''")===false)
  echo '<input type="checkbox" name="fillemondas" value="I" />Csak aki lemondta'."\n";
else
  echo '<input type="checkbox" checked="checked" name="fillemondas" value="I" />Csak aki lemondta'."\n";
if (strpos($filter,"ka.lemondas=''")===false)
  echo '<input type="checkbox" name="filNlemondas" value="I" />Csak aki NEM mondta le'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filNlemondas" value="I" />Csak aki NEM mondta le'."\n";
if (strpos($filter,"ka.fizmod='KP'")===false)
  echo '<input type="checkbox" name="filKP" value="I" />Csak aki KP fizet'."\n";
else
  echo '<input type="checkbox" checked="checked" name="filKP" value="I" />Csak aki KP fizet'."\n";

echo '<button type="submit">Szrst alkalmaz</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// bngsz iframe
echo '<center><iframe name="ifrm0" width="98%" height="'.$ifrmHeight.'"></iframe></center>'."\n";
// bngsz tblzat iframe-be betltshez szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmbongeszo" action="./konfadmin0.php" method="post" target="ifrm0">'."\n";
echo '<input type="hidden" name="act" value="'.$browse.'">'."\n";
echo '<input type="hidden" name="pageSize" value="'.$pageSize.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<input type="hidden" name="labels" value="'.implode(';',$labels).'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// lapoz gombsor kiirsa
echo '<p class="gridjumper">';
echo 'sszesen '.$totalRecords.' sor &nbsp;&nbsp;&nbsp;';
echo 'Oldalak:&nbsp;'."\n";
       $j0 = ($top / $pageSize); // current page
       $jmax = ($totalRecords / $pageSize); // max page
       $elozoKiirva = false;
       $i = 0; // rekordszm
       $j = 0; // oldalszm
       while ($j <= $jmax) {
          if (($j < 5) |
              ($j > $jmax - 5) |
              (abs($j - $jmax/2) < 5) |
              (abs($j - $j0) < 5)
             ) {
               echoPager($j,$j0,$i);
               $elozoKiirva = treu;
          } else {
               if ($elozoKiirva) echo '...';
               $elozoKiirva = false;
          }
          $i = $i + $pageSize;
          $j++;
       }
echo '</p>'."\n";

// bngsz iframe feltltse
echo '<script type="text/javascript">'."\n";
echo 'document.forms.frmbongeszo.submit();'."\n";
echo '</script>'."\n";

// manipull gombsor
echo '<p><button type="button" onclick="viewform();"><img src="./images/info.gif">Megnz</button>&nbsp;';
echo '<button type="button" onclick="updateform();"><img src="./images/buttonedit.gif">Mdosit</button>&nbsp;';
echo '<button type="button" onclick="insertform();"><img src="./images/buttoninsert.gif">j felvitel</button>&nbsp;';
echo '<button type="button" onclick="copyform();"><img src="./images/buttoninsert.gif"><img src="./images/buttoninsert.gif">j felvitel msolssal</button>&nbsp;';
echo '<button type="button" onclick="dodelete();"><img src="./images/buttondel.gif">Trl</button>&nbsp'."\n";
echo '<button type="button" onclick="searchFirst();"><img src="./images/buttonfind.gif">Keres ellrl</button>&nbsp;'."\n";
echo '<button type="button" onclick="searchNext();"><img src="./images/buttonfind.gif">Tovbb Keres</button>&nbsp;'."\n";
echo '<button type="button" onclick="doload();"><img src="./images/openfolder.gif">Betlt</button>&nbsp;'."\n";
echo '<button type="button" onclick="doexcelexport();"><img src="./images/grid.gif">Export EXCEL-be</button>&nbsp;'."\n";
echo '<button type="button" onclick="doErvenyes();">rvmyes</button>&nbsp;'."\n";
echo '<button type="button" onclick="doFfi();">Ffi</button>&nbsp;'."\n";
echo '<button type="button" onclick="doNo();">N</button>&nbsp;'."\n";
echo '<button type="button" onclick="doReglap();">Reg.lap</button>&nbsp;'."\n";
echo '<button type="button" onclick="doLemondta();">Lemonds</button>&nbsp;'."\n";
echo '<button type="button" onclick="doResztvett();">Rsztvett</button>&nbsp;'."\n";
echo '<button type="button" onclick="formFizet();">Fizetett</button>&nbsp;'."\n";
echo '<button type="button" onclick="doVisszaigazol();">Visszaigazolst s Proforma biz.-t kld</button><br>'."\n";
echo '<button type="button" onclick="doEmlekezteto();">Emlkeztett kld</button>&nbsp;'."\n";
echo '<button type="button" onclick="doElolegszamla();">Elleg szmla</button>&nbsp;'."\n";
echo '<button type="button" onclick="doKPszamla();">KP vgszmla</button>&nbsp;'."\n";
echo '<button type="button" onclick="doATUTszamla();">tut. vgszmla</button>&nbsp;'."\n";
echo '<button type="button" onclick="doEgyediSzamla();">Egyedi szmla</button>&nbsp;'."\n";

$url = "'index.php'";
echo '<button type="button" onclick="location='.$url.'"><img src="images/buttoncancel.gif">Vissza a kezd lapra</button></p>'."\n";

// sajtmaga visszahivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="visszahivo" action="./konfadmin.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="selectedId" value="'.$selectedId.'">'."\n";
echo '<input type="hidden" name="searchStr" value="'.$searchStr.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";
// mysql2excel hivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmcsv" action="./mysql2excel.php" method="post">'."\n";
echo '<input type="hidden" name="selectsql" value="">'."\n";
echo '<input type="hidden" name="countsql" value="">'."\n";
echo '<input type="hidden" name="csvnev" value="">'."\n";
echo '<input type="hidden" name="terminator" value=",">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

if ($act == 'insertform') {
  unset($_SESSION['oldcegnev']);
  echo '<div style="display:block; position:absolute; z-index:99; left:10px; top:10px; background-color:silver; border-style:solid;">'."\n";

  $w = explode('=',$filter);
  $w2 = explode(')',$w[1]);
  $konfid = $w2[0];
  echo '<hr>'.$filter.' / '.$konfid.'<hr>';

  echo '<form name="adatform" action="./konfadmin.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'konfadmin where id < 0';
  $q->open();
  $q->first();
  //$q->append();
  $q->setvaluebyname('datum', date('Y.m.d'));
  $q->setvaluebyname('konfid', $konfid);
  $q->setvaluebyname('ervenyes', 'I');
  $q->setvaluebyname('jelmod', 'IDOBEN');
  $q->setvaluebyname('letszam', '1');
  echodataform($q,'Konferencia adminisztrls j sor felvitele');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}
if ($act == 'viewform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:10px; top:10px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./konfadmin.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'konfadmin where id = '.$selectedId;
  $q->open();
  $q->first();
  echodataform($q,'Konferencia adminisztrls megtekints');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  // input mezk set readonly
  echo 'inputs = document.getElementsByTagName("INPUT");'."\n";
  echo 'for (i=0; i < inputs.length; i++) {'."\n";
  echo '  inputs[i].readOnly = true;'."\n";
  echo '  inputs[i].disabled = true;'."\n";
  echo '  inputs[i].className = "readonly";'."\n";
  echo '}'."\n";
  echo 'selects = document.getElementsByTagName("SELECT");'."\n";
  echo 'for (i=0; i < selects.length; i++) {'."\n";
  echo '  selects[i].readOnly = true;'."\n";
  echo '  selects[i].disabled = true;'."\n";
  echo '  selects[i].className = "readonly";'."\n";
  echo '}'."\n";
  echo 'tas = document.getElementsByTagName("TEXTAREA");'."\n";
  echo 'for (i=0; i < tas.length; i++) {'."\n";
  echo '  tas[i].readOnly = true;'."\n";
  echo '  tas[i].disabled = true;'."\n";
  echo '  tas[i].className = "readonly";'."\n";
  echo '}'."\n";
  echo '</script>'."\n";
}
if ($act == 'updateform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:10px; top:10px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./konfadmin.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  echo '<input type="hidden" name="id" value="'.$selectedId.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'konfadmin where id = '.$selectedId;
  $q->open();
  $q->first();
  makeCegId($q);
  echodataform($q,'Konferencia adminisztrls / mdosts');
  $_SESSION['oldcegnev']=makeOldcegNev($q);
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}
if ($act == 'formFizet') {
  $q->sql = 'select prf_osszeg from '.$config['dbpre'].'konfadmin where id = '.$selectedId;
  $q->open();
  $q->first();
  $osszeg = $q->valuebyname('prf_osszeg');
  $q->close();
  echo '<div style="display:block; position:absolute; z-index:99; left:100px; top:100px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./konfadmin.php" method="post" class="fizetform">'."\n";
  echo '<input type="hidden" name="act" value="doFizet">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  echo '<input type="hidden" name="id" value="'.$selectedId.'">'."\n";
  echo '<h2>Fizetett</h2>'."\n";
  echo '<p>Dtum:<input type="text" name="datum" value="'.date('Y.m.d').'" />&nbsp;'."\n";
  echo 'sszeg:<input type="text" name="osszeg" value="'.$osszeg.'" /></p>'."\n";
  echo '<p style="text-align:right"><button type="submit"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.datum.focus();'."\n";
  echo '</script>'."\n";
}
if ($act == 'copyform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:10px; top:10px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./konfadmin.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="insertform">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select * from '.$config['dbpre'].'konfadmin where id = '.$selectedId;
  $q->open();
  $q->first();
  $w = explode('=',$filter);
  $w2 = explode(')',$w[1]);
  $konfid = $w2[0];
  $q->setvaluebyname('datum', date('Y.m.d'));
  $q->setvaluebyname('konfid', $konfid);
  $q->setvaluebyname('ervenyes', 'I');

  // 2009.04.27 Szigetvri krsre kivve $q->setvaluebyname('jelmod', 'IDOBEN');

  $q->setvaluebyname('id', '');
  $q->setvaluebyname('kerdes', '');
  $q->setvaluebyname('visszaig', '');
  $q->setvaluebyname('lemondas', '');
  $q->setvaluebyname('resztvett', '');
  $q->setvaluebyname('prf_szam', '');
  $q->setvaluebyname('prf_datum', '');
  $q->setvaluebyname('prf_osszeg', '0');
  $q->setvaluebyname('fizetett', '');
  $q->setvaluebyname('fizdat', '');
  $q->setvaluebyname('emlekezteto', '');
  $q->setvaluebyname('eszla_szam', '');
  $q->setvaluebyname('eszla_datum', '');
  $q->setvaluebyname('eszla_osszeg', '0');
  $q->setvaluebyname('vszla_szam', '');
  $q->setvaluebyname('vszla_datum', '');
  $q->setvaluebyname('vszla_osszeg', '0');
  $q->setvaluebyname('cegid', '0');
  echodataform($q,'Konferencia adminisztrls / j sor msolssal ');
  $_SESSION['oldcegnev']=makeOldcegNev($q);
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="ok()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'document.forms.adatform.fax.focus();'."\n";
  echo '</script>'."\n";
}
echo '<script type="text/javascript">'."\n";
echo 'selected = '.$selected.';'."\n";
echo 'selectedId = '.$selectedId.';'."\n";
echo 'document.getElementById("divkonfadmin").style.width=screen.width - 80;'."\n";
echo 'function jump(newTop) {'."\n";
echo '  selected = 0;'."\n";
echo '  document.forms.visszahivo.top.value=newTop;'."\n";
echo '  document.forms.visszahivo.selected.value="0";'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function viewform() {'."\n";
echo '  document.forms.visszahivo.act.value="viewform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function updateform() {'."\n";
echo '  document.forms.visszahivo.act.value="updateform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function copyform() {'."\n";
echo '  document.forms.visszahivo.act.value="copyform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function insertform() {'."\n";
echo '  document.forms.visszahivo.act.value="insertform";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchFirst() {'."\n";
echo '  s = prompt("Keresend:","keseresn");'."\n";
echo '  document.forms.visszahivo.searchStr.value=s;'."\n";
echo '  document.forms.visszahivo.act.value="searchFirst";'."\n";
echo '  document.getElementById("divturelem").style.display="block";'."\n";
echo '  if (s != null) '."\n";
echo '     document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchNext() {'."\n";
echo '  document.forms.visszahivo.act.value="searchNext";'."\n";
echo '  document.getElementById("divturelem").style.display="block";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function dodelete() {'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  if (confirm("Trlni akarja ezt az adatot?")) ';
echo '     document.forms.visszahivo.act.value="dodelete";'."\n";
echo '  else'."\n";
echo '     document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";

echo 'function doexcelexport() {'."\n";
echo '  document.forms.visszahivo.action="mysql2excel.php";'."\n";
if ($filter=='')
   $sql = $config['dbpre'].'konfadmin ka '.
             'where ka.id >= 0';
else
   $sql = $config['dbpre'].'konfadmin ka '.
             'where ka.id >= 0 and '.$filter;
echo '  document.forms.frmcsv.selectsql.value="'.
/*     'select ka.* '. */
     'select ka.cegid, ka.lemondas, ka.fizmod, ka.vega,'.
     ' ka.kamara, ka.cegnev, ka.nev, ka.beosztas,'.
     ' ka.irsz, ka.varos, ka.cim, ka.kerdes, ka.egyeb,'.
     ' ka.prf_osszeg, ka.korzet, ka.fax, ka.tel, ka.email,'.
     ' ka.lakcim, ka.pirsz, ka.pvaros, ka.pcim '.
     'from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.countsql.value="select count(ka.id) from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.csvnev.value="konfadmin";'."\n";
echo '  document.forms.frmcsv.submit();'."\n";
echo '}'."\n";
echo 'function doEgyediSzamla() {'."\n";
echo '  document.forms.visszahivo.action="mysql2excel.php";'."\n";
if ($filter=='')
   $sql = $config['dbpre'].'konfadmin ka '.
             "where ka.id >= 0 and (ka.egyediar='I' or ka.egyediszla='I') and ".
             "ka.resztvett='I' and ka.ervenyes='I' ";
else
   $sql = $config['dbpre'].'konfadmin ka '.
             "where ka.id >= 0 and (ka.egyediar='I' or ka.egyediszla='I') and ".
             "ka.resztvett='I' and ka.ervenyes='I' and ".
             $filter;
echo '  document.forms.frmcsv.selectsql.value="'.
     'select ka.* '.
     'from '.$sql.' order by cegnev";'."\n";
echo '  document.forms.frmcsv.countsql.value="select count(ka.id) from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.csvnev.value="egyediszamla";'."\n";
echo '  document.forms.frmcsv.submit();'."\n";
echo '}'."\n";
echo 'function doload() {'."\n";
echo '  location="./konfadminload.php";'."\n";
echo '}'."\n";
echo 'function ok() {'."\n";
echo '  inputs = document.getElementsByTagName("INPUT");'."\n";
echo '  for (i=0; i < inputs.length; i++) {'."\n";
echo '    inputs[i].readOnly = false;'."\n";
echo '    inputs[i].disabled = false;'."\n";
echo '  }'."\n";
if ($act == 'insertform')
   echo '  document.forms.adatform.act.value="doinsert";'."\n";
if ($act == 'updateform')
   echo '  document.forms.adatform.act.value="doupdate";'."\n";
if ($act == 'viewform')
   echo '  document.forms.adatform.act.value="browse";'."\n";
if ($act == 'copyform')
   echo '  document.forms.adatform.act.value="doinsert";'."\n";
echo '  document.forms.adatform.submit();'."\n";
echo '}'."\n";
echo 'function cancel() {'."\n";
echo '  inputs = document.getElementsByTagName("INPUT");'."\n";
echo '  for (i=0; i < inputs.length; i++) {'."\n";
echo '    inputs[i].readOnly = false;'."\n";
echo '    inputs[i].disabled = false;'."\n";
echo '  }'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function celclick(row,col) {'."\n";
echo '  selected = row;'."\n";
echo '  document.forms.visszahivo.selected.value=row;'."\n";
echo '}'."\n";
echo 'function doErvenyes() {'."\n";
echo '  document.forms.visszahivo.act.value="doErvenyes";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doFfi() {'."\n";
echo '  document.forms.visszahivo.act.value="doFfi";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doNo() {'."\n";
echo '  document.forms.visszahivo.act.value="doNo";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doResztvett() {'."\n";
echo '  document.forms.visszahivo.act.value="doResztvett";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doLemondta() {'."\n";
// a selectedId rekordot t kell msolni a faxtiltas -ba
echo '  d = new Date();'."\n";
echo '  w = prompt("Lemonds dtuma:",d.toLocaleString());'."\n";
echo '  document.forms.visszahivo.act.value="doLemondta";'."\n";
echo '  document.forms.visszahivo.searchStr.value=w;'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  if (w != null) '."\n";
echo '     document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doVisszaigazol() {'."\n";
echo '  document.forms.visszahivo.action="visszaig.php";'."\n";
echo '  document.forms.visszahivo.act.value="visszaigform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doElolegszamla() {'."\n";
echo '  document.forms.visszahivo.action="elolegszamla.php";'."\n";
echo '  document.forms.visszahivo.act.value="eloleg";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doKPszamla() {'."\n";
echo '  document.forms.visszahivo.action="kpszamla.php";'."\n";
echo '  document.forms.visszahivo.act.value="kpszamla";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doATUTszamla() {'."\n";
echo '  document.forms.visszahivo.action="atutszamla.php";'."\n";
echo '  document.forms.visszahivo.act.value="atutszamla";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doEmlekezteto() {'."\n";
echo '  document.forms.visszahivo.action="emlekezteto.php";'."\n";
echo '  document.forms.visszahivo.act.value="emlekeztetoform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function formFizet() {'."\n";
echo '  document.forms.visszahivo.act.value="formFizet";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function doReglap() {'."\n";
$url = 'reglap1.php?id=';
echo 'window.open("'.$url.'"+selectedId,"","left=100,top=100,width=500,height=500,menubar=yes,scrollbars=yes,resizable=yes,locationbar=yes");'."\n";
echo '}'."\n";
if ($errorMsg != '')
  echo 'alert("'.$errorMsg.'");'."\n";
echo '</script>'."\n";
echo '</div>'."\n";
include_once('./footer.php');
?>
