  // adatmagos POPUP window system
  // function: multy platform, multiply popup, movable,
  // Author: Fogler Tibor foglert@robitbt.hu
  // Lecence: GNU/GPL
  // Tested: Windows Vista 64 / Firefox 3.0, IE 7, Opera 9.5, Chrome 1.0 
  //
  // function popup(url,x,y,width,height,[title])
  //          x,y is position on document (not in screen, not in window)!
  // function popupClose()
  //
  popupI = -1;
  M_InitX = 0;
  M_InitY = 0;
  M_PosX = 0;
  M_PosY = 0;
  M_Moving = false;

  function popup(url,x,y,w,h,title) {
    if (title == undefined) title = ' ';
    if (document.getElementById('popupdiv_'+popupI) == undefined) {
        popupI = popupI + 1;
        var popupdiv = document.createElement('DIV');
        popupdiv.id='popupdiv_'+popupI;
        popupdiv.style.display='none';
        popupdiv.style.position='absolute';
        popupdiv.style.left='0px';
        popupdiv.style.top='0px';
        popupdiv.style.borderStyle = 'solid';
        popupdiv.style.borderWidth = 2;
        popupdiv.style.borderColor = 'blue';

        var b = document.getElementsByTagName('BODY');
        if (b == undefined)
                b = document.getElementsByTagName('body');
        b[0].appendChild(popupdiv);

        var wdiv = document.createElement('DIV');
        wdiv.style.backgroundColor = 'blue';
        wdiv.style.color = 'white';
        wdiv.style.textAlign = 'right';
        wdiv.style.cursor = 'move';
        wdiv.style.fontSize = '8';
        wdiv.onmousedown = doMDown;
        popupdiv.appendChild(wdiv);

        wdiv.appendChild( document.createTextNode(title+'    ') );

        var btn = document.createElement('INPUT');
        btn.type = 'button';
        btn.value = 'X';
        btn.style.fontSize = '8';
        btn.onclick = popupClose;
        wdiv.appendChild(btn);

        var popupiframe = document.createElement('IFRAME');
        popupiframe.id = 'popupiframe_'+popupI;
        popupiframe.frameBorder = 0;

        popupdiv.appendChild(popupiframe);
    }
    var d = document.getElementById('popupdiv_'+popupI);
    d.style.position = 'absolute';
    d.style.display='block';
    d.style.left = x;
    d.style.top = y;
    d.style.width = w;
    d.style.height = h;
    d.style.zIndex = 99;
    //d.firstChild.style.width = w;
    var wifrm = document.getElementById('popupiframe_'+popupI);
    wifrm.width = (w - 5);
    wifrm.height = (h - 20);
    wifrm.src=url;
  }
  function popupClose() {
    document.getElementById('popupdiv_'+popupI).style.display='none';
    popupI = popupI - 1;
  }
  function doMDown(e) {
    if(document.all)
       e = event;
    oTmp = document.getElementById('popupdiv_'+popupI);
    M_InitX = e.clientX;
    M_InitY = e.clientY;
    M_PosX = oTmp.style.left.replace('px','')/1;
    M_PosY = oTmp.style.top.replace('px','')/1;
    M_Moving = true;
    document.onmousemove = doMMove;
    document.onmouseup = doMUp;
    return false;
  }
  function doMUp(e) {
    document.onmousemove =  null;
    document.onmouseup = null;
    M_Moving = false;
    return false;
  }
  function doMMove(e)  {
    if(document.all)
       e = event;
    oTmp = document.getElementById('popupdiv_'+popupI);
    if(document.all){
      e = event;
      if(e.button != 1) return doMUp(e);
    }
    else if(e.which != 1) return doMUp(e);
    var leftPos = M_PosX + e.clientX - M_InitX;
    var topPos = M_PosY + e.clientY - M_InitY;
    if(topPos < 0) topPos = 0;
    if(leftPos < 0) leftPos = 0;
    oTmp.style.left = leftPos + 'px';
    oTmp.style.top = topPos + 'px';
    return false;
  }

