<?php
// licensz: GNU/GPL  Fogler Tibor
// proforma pdf kialakitsa

// 2009.06.02 vkzi 20%->25% FA kulcs vltozs kezelse

include './html2fpdf.php';

function rpad($s,$w) {
  while (strlen($s) < $w)
    $s = ' '.$s;
  if ($w==5)
    $s = substr($s,0,2).' '.substr($s,2,3);
  if ($w==6)
    $s = substr($s,0,3).' '.substr($s,3,3);
  if ($w==7)
    $s = substr($s,0,1).' '.substr($s,1,3).' '.substr($s,4,3);
  if ($w==8)
    $s = substr($s,0,2).' '.substr($s,2,3).' '.substr($s,5,3);
  return $s;
}

function createProforma($q,$q2) {
  global $config,$db,$q,$listaar,$onlinear,$kedvar,$etkezes;
  // q konfadmin - proforma rekord
  // q2 konferenciak rekord
  // beolvassa a megfelel semat
  // helyettesiti a paramtereket
  // kitrolja a proforma bizonylatot
  $proformaId = $q->valuebyname('id');
  $nev = $q->valuebyname('id');
  $FH = 10;   // font size pt
  $H =  4;   // sor magassg mm
  $L =  0.2;  // vonal vastagsag mm
  $FIZHAT = $config['fizhat'];  // fizetsi hatrid napban
  $pdf = new HTML2FPDF();
  $pdf->AddPage();
  $pdf->SetLineWidth($L);
  //$pdf->SetFont('times','',$FH);
  //$pdf->text($x,$y,'Szllt');
  //$pdf->Rect(  5,$y1,50,6,'');
  //$pdf->Line(50,$y,190,$y);
  $pdf->Image('./images/szamlahatter.jpg',8,7,190,90,'','',true);
  $pdf->SetFont('times','B',$FH);
  // szmla szma
  $pdf->SetFont('times','B',$FH);
  $pdf->text(162,20,$q->valuebyname('id').'/'.date('Y'));

  $pdf->SetFont('times','',$FH);
  // szllt
  $pdf->text(30,35,$config['cegnev0']);
  $pdf->text(30,40,$config['cegnev1']);
  $pdf->text(30,45,$config['cegnev2']);
  $pdf->text(30,50,$config['cegnev3']);
  $pdf->text(30,55,$config['cegnev4']);
  $pdf->text(30,60,$config['cegnev5']);
  $pdf->text(30,65,$config['cegnev6']);
  // vev
  $szavak = explode(' ',strip_tags($q->valuebyname('cegnev')));
  $ws = '';
  $wy = 0;
  foreach ($szavak as $szo) {
    if ($pdf->GetStringWidth($ws . $szo) < 80) {
      $ws .= $szo . ' ';
    } else {
       $pdf->text(110,35+$wy,$ws);
       $ws = $szo.' ';
       $wy = $wy + 5;
    }
  }
  $pdf->text(110,35+$wy,$ws);

  if ($q->valuebyname('cegadosz') != '')
    $pdf->text(110,40 + $wy,'Adszm:'.strip_tags($q->valuebyname('cegadosz')));
  $pdf->text(110,55,strip_tags($q->valuebyname('varos')));
  $pdf->text(110,60,strip_tags($q->valuebyname('cim')));
  $pdf->text(110,65,strip_tags($q->valuebyname('irsz')));


  // szmla kelte
  $pdf->text(30,80,date('Y. m. d.'));
  if ($q->valuebyname('fizmod')=='ATUT')
     $pdf->text(90,80,'Fizets mdja: tutals');
  else if ($q->valuebyname('fizmod')=='KP')
     $pdf->text(90,80,'Fizets mdja: kszpnz');
  else if ($q->valuebyname('fizmod')=='POSTA')
     $pdf->text(90,80,'Fizets mdja: posta');
  else
     $pdf->text(90,80,'Fizets mdja:'.strip_tags($q->valuebyname('fizmod')));

  // fizetsi hatrid
  // $pdf->SetFont('times','B',round($FH*1.2));
  // if (getPOST('elolegbekero')=='I')
  if ($q->valuebyname('fizmod')=='ATUT') {
    $fizmod = 'tutals';
    if (getPOST('elolegbekero')=='I') {
      $pdf->text(160,80,'');
    } else {
      $pdf->text(160,80,date('Y. m. d.',time() + ($FIZHAT * 24 * 3600)));
    }
  } else if ($q->valuebyname('fizmod')=='KP') {
    $fizmod = 'kszpnz';
    if (getPOST('elolegbekero')=='I')
       $pdf->text(160,80,'');
    else
       $pdf->text(160,80,date('Y. m. d.',time()));
  } else {
    $fizmod = '';
    $pdf->text(160,80,'');
  }
  $pdf->SetFont('times','',$FH);

  // lista sorok az ar1,letsz1 / ar2/letsz2.... alapjn
  $pdf->SetFont('courier','',round($FH * 0.8));
  // norml kulcsos
  $snetto = 0;
  $sbrutto = 0;
  
  // kedv.kulcsos
  $snetto1 = 0;
  $sbrutto1 = 0;
  
  //nulla kulcsos
  $snetto0 = 0;
  $sbrutto0 = 0;
  
  
  $y = 100;
  //+ 2009.06.02
  $afakulcs = '20';
  $konfido = substr($q2->valuebyname('k_ido'),0,10);
  if ($konfido >= '2009.07.01')
     $afakulcs = '25';
  if (date('Y.m.d') > '2009.07.20')
     $afakulcs = '25';
  //- 2009.06.02


  if ($q->valuebyname('letsz1') > 0) {
    $netto1 = round($q->valuebyname('ar1') * $q->valuebyname('letsz1'));
    $pdf->text(10,$y,'Felnttoktats');
    $pdf->text(70,$y,'80.42.10.9');
    $pdf->text(105,$y,rpad($q->valuebyname('letsz1'),2).'f');
    $pdf->text(125,$y,rpad(round($q->valuebyname('ar1')),5).' Ft');
    $pdf->text(147,$y,rpad($netto1,6).' Ft');
    //+ 2009.06.02
    if ($afakulcs == '20') {
      $pdf->text(165,$y,'20%');
      $pdf->text(175,$y,rpad(round($netto1 + round($netto1 * 0.2)),7).' Ft');
      $snetto = $snetto + $netto1;
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.2));
    }
    if ($afakulcs == '25') {
      $pdf->text(165,$y,'25%');
      $pdf->text(175,$y,rpad(round($netto1 + round($netto1 * 0.25)),7).' Ft');
      $snetto = $snetto + $netto1;
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.25));
    }
    //- 2009.06.02
    $y = $y + 5;
  }
  if ($q->valuebyname('letsz2') > 0) {
    $netto1 = round($q->valuebyname('ar2') * $q->valuebyname('letsz2'));
    $pdf->text(10,$y,'Felnttoktats');
    $pdf->text(70,$y,'80.42.10.9');
    $pdf->text(105,$y,rpad($q->valuebyname('letsz2'),2).'f');
    $pdf->text(125,$y,rpad(round($q->valuebyname('ar2')),5).' Ft');
    $pdf->text(147,$y,rpad($netto1,6).' Ft');
    //+ 2009.06.02
    if ($afakulcs == '20') {
      $pdf->text(165,$y,'20%');
      $pdf->text(175,$y,rpad(round($netto1 + round($netto1 * 0.2)),7).' Ft');
      $snetto = $snetto + $netto1;
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.2));
    }
    if ($afakulcs == '25') {
      $pdf->text(165,$y,'25%');
      $pdf->text(175,$y,rpad(round($netto1 + round($netto1 * 0.25)),7).' Ft');
      $snetto = $snetto + $netto1;
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.25));
    }
    //- 2009.06.02
    $y = $y + 5;
  }
  if ($q->valuebyname('letsz3') > 0) {
    $netto1 = round($q->valuebyname('ar3') * $q->valuebyname('letsz3'));
    $pdf->text(10,$y,'Felnttoktats');
    $pdf->text(70,$y,'80.42.10.9');
    $pdf->text(105,$y,rpad($q->valuebyname('letsz3'),2).'f');
    $pdf->text(125,$y,rpad(round($q->valuebyname('ar3')),5).' Ft');
    $pdf->text(147,$y,rpad($netto1,6).' Ft');
    //+ 2009.06.02
    if ($afakulcs == '20') {
      $pdf->text(165,$y,'20%');
      $pdf->text(175,$y,rpad(round($netto1 + round($netto1 * 0.2)),7).' Ft');
      $snetto = $snetto + $netto1;
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.2));
    }
    if ($afakulcs == '25') {
      $pdf->text(165,$y,'25%');
      $pdf->text(175,$y,rpad(round($netto1 + round($netto1 * 0.25)),7).' Ft');
      $snetto = $snetto + $netto1;
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.25));
    }
    //- 2009.06.02
    $y = $y + 5;
  }
  $netto1 = round($q->valuebyname('etkar') * $q->valuebyname('etkletszam'));
  $pdf->text(10,$y,'tkezs (kzvettett szolgltats)');
  $pdf->text(70,$y,'55.30.11');
  $pdf->text(105,$y,rpad($q->valuebyname('etkletszam'),2).'f');
  $pdf->text(125,$y,rpad(round($q->valuebyname('etkar')),5).' Ft');
  $pdf->text(147,$y,rpad($netto1,6).' Ft');
  //+ 2009.06.02
  if ($afakulcs == '20') {
    $pdf->text(165,$y,'20%');
    $pdf->text(175,$y,rpad(round($netto1 * 1.2),7).' Ft');
  }
  if ($afakulcs == '25') {
    $pdf->text(165,$y,'25%');
    $pdf->text(175,$y,rpad(round($netto1 * 1.25),7).' Ft');
  }
  //- 2009.06.02
  $y = $y + 5;

  $snetto = $snetto + $netto1;
  //+ 2009.06.02
  if ($afakulcs == '20')
    $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.2));
  if ($afakulcs == '25')
    $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.25));
  //- 2009.06.02

  //+2009.08.28 szllsdij, idegenforgalmi hozzjrils
  $netto1 = round($q->valuebyname('szallas') * $q->valuebyname('letsz4'));
  $ifh = round($q->valuebyname('ifh') * $q->valuebyname('letsz4'));
  if ($netto1 > 0) {
    $snetto1 = $snetto1 + $netto1;
    $pdf->text(10,$y,'Szlls (kzvettett szolgltats)');
    $pdf->text(70,$y,'');
    $pdf->text(105,$y,rpad($q->valuebyname('letsz4'),2).'f');
    $pdf->text(125,$y,rpad(round($q->valuebyname('szallas')),5).' Ft');
    $pdf->text(147,$y,rpad($netto1,6).' Ft');
    if ($afakulcs == '20') {
      $pdf->text(165,$y,'20%');
      $pdf->text(175,$y,rpad(round($netto1 * 1.2),7).' Ft');
      $sbrutto = $sbrutto + round($netto1 + round($netto1 * 0.2));
    }
    if ($afakulcs == '25') {
      $pdf->text(165,$y,'18%');
      $pdf->text(175,$y,rpad(round($netto1 * 1.18),7).' Ft');
      $sbrutto1 = $sbrutto1 + round($netto1 + round($netto1 * 0.18));
    }
    $y = $y + 5;

    $snetto2 = $snetto2 + $ifh;
    $pdf->text(10,$y,'Idegen forg.hozzjruls');
    $pdf->text(70,$y,'');
    $pdf->text(105,$y,rpad($q->valuebyname('letsz4'),2).'f');
    $pdf->text(125,$y,rpad(round($q->valuebyname('ifh')),5).' Ft');
    $pdf->text(147,$y,rpad($ifh,6).' Ft');
    $pdf->text(165,$y,' 0%');
    $pdf->text(175,$y,rpad(round($ifh*1),7).' Ft');
    $sbrutto2 = $sbrutto2 + round($ifh);
    $y = $y + 5;
  }

  //-2009.08.28 szllsdij, idegenforgalmi hozzjrils


  // sszesen
  $pdf->Line(10,$y,197,$y);
  $y = $y + 5;
  $pdf->SetFont('times','B',$FH);
  $pdf->text(10,$y,'sszesen');
  $pdf->SetFont('courier','',$FH);
  $y = $y + 5;
  $pdf->text(10,$y,'Norml kulcs');
  $pdf->text(50,$y,'Nett:  '.rpad(round($snetto),8).' Ft');
  $pdf->text(100,$y,'fa:    '.rpad(round($sbrutto - $snetto),8).' Ft');
  $pdf->text(150,$y,'Brutt: '.rpad(round($sbrutto),8).' Ft');
  $y = $y + 5;
  $pdf->text(10,$y,'18%');
  $pdf->text(50,$y,'Nett:  '.rpad(round($snetto1),8).' Ft');
  $pdf->text(100,$y,'fa:    '.rpad(round($sbrutto1 - $snetto1),8).' Ft');
  $pdf->text(150,$y,'Brutt: '.rpad(round($sbrutto1),8).' Ft');
  $y = $y + 5;
  $pdf->text(10,$y,' 0%');
  $pdf->text(50,$y,'Nett:  '.rpad(round($snetto2),8).' Ft');
  $pdf->text(100,$y,'fa:    '.rpad(round($sbrutto2 - $snetto2),8).' Ft');
  $pdf->text(150,$y,'Brutt: '.rpad(round($sbrutto2),8).' Ft');

  $y = $y + 7;
  $pdf->SetFont('courier','B',$FH);
  $pdf->text( 10,$y,' Vg sszesen');
  $pdf->SetFont('courier','',$FH);
  $pdf->text(50,$y,'Nett:  '.rpad(round($snetto + $snetto1 + $snetto2),8).' Ft');
  $pdf->text(100,$y,'fa:    '.rpad(round($sbrutto + $sbrutto1 + $sbrutto2 - $snetto - $snetto1 - $snetto2),8).' Ft');
  $pdf->text(150,$y,'Brutt: '.rpad(round($sbrutto + $sbrutto1 + $sbrutto2),8).' Ft');

  $pdf->SetFont('times','',$FH);
  $pdf->text(10,160,"Jelentkezs szakmai oktatsra:");
  $kcim = strip_tags($q2->valuebyname('k_cim'),'<br>');
  $kcim = str_replace('<br>'," ",$kcim);
  $kcim = str_replace('<br/>'," ",$kcim);
  $kcim = str_replace('<br />'," ",$kcim);
  $kcimszavak = explode(" ",$kcim);
  $kcimsorok = array();
  $s = '';
  foreach ($kcimszavak as $szo) {
    if (strlen($s) < 70)
       $s .= $szo.' ';
    else {
      $kcimsorok[] = $s;
      $s = $szo.' ';
    }
  }
  $kcimsorok[] = $s;
  for ($i=0; $i<count($kcimsorok); $i++)
    $pdf->text(10,175+($i*5),$kcimsorok[$i]);

  // szveg beolvass txt file-bl, rtelmezs, megjekenits
  $sznev='./semak/'.$q2->valuebyname('k_id').'_proforma.frg';
  $sorok=file($sznev);
  $s = '';
  for($i=0;$i<count($sorok);$i++)
    $s .= $sorok[$i];
  // html karakterek visszakodolsa
  $s = str_replace('&Aacute;','',$s);
  $s = str_replace('&aacute;','',$s);
  $s = str_replace('&Eacute;','',$s);
  $s = str_replace('&eacute;','',$s);
  $s = str_replace('&Oacute;','',$s);
  $s = str_replace('&oacute;','',$s);
  $s = str_replace('&Uacute;','',$s);
  $s = str_replace('&uacute;','',$s);
  $s = str_replace('&Iacute;','',$s);
  $s = str_replace('&iacute;','',$s);
  $s = str_replace('&Ouml;','',$s);
  $s = str_replace('&ouml;','',$s);
  $s = str_replace('&Uuml;','',$s);
  $s = str_replace('&uuml;','',$s);
  $s = str_replace('&nbsp;',' ',$s);
  $s = str_replace('&lt;','<',$s);
  $s = str_replace('&gt;','>',$s);
  $s = str_replace('&apos;',"'",$s);
  $s = str_replace('&guot;','"',$s);
  $s = str_replace('&amp;','&',$s);
  $s = str_replace('<b>','<strong>',$s);
  $s = str_replace('</b>','</strong>',$s);
  // sorokra bonts
  $s = str_replace('</p>','<br />',$s);
  $s = str_replace('<p>','<br />',$s);
  $sorok = explode('<br />',$s);
  // sorok kiirsa a pdf-be <strong> rtelmezs, paramter csere
  for($i=0;$i<count($sorok);$i++) {
    $s = $sorok[$i].' ';
    // paramter csere
    $s = str_replace('[CEGNEV]',strip_tags($q->valuebyname('cegnev')),$s);
    $s = str_replace('[NEV]',strip_tags($q->valuebyname('nev')),$s);
    $s = str_replace('[BEOSZTAS]',strip_tags($q->valuebyname('beosztas')),$s);
    $s = str_replace('[KONFIDO]',strip_tags($q2->valuebyname('k_ido')),$s);
    $s = str_replace('[MAINAP]',date('Y.m.d'),$s);
    $s = str_replace('</strong>','',$s);
    $sorok[$i] = $s;
    if (strpos($s,'<strong>') === false) {
      $pdf->text(10,190+($i*5),strip_tags($sorok[$i]));
    } else {
      $s = str_replace('<strong>','',$s);
      $pdf->SetFont('times','B',$FH);
      $pdf->text(10,190+($i*5),strip_tags($s));
      $pdf->SetFont('times','',$FH);
    }
  }
  $pdf->Line(10,270,197,270);
  $pdf->text(10,275,'Kszlt a RoBIT Bt. Konferencia-admin programjval. http://robitbt.hu');
  $pdf->Output("./proforma/$nev.pdf","F");
  $q3 = new Tquery('q3',$db);
  $q3->sql = 'update konfadmin '.
             'set prf_szam = "'.$q->valuebyname('id').'/'.date('Y').'", '.
             '    prf_datum = "'.date('Y.m.d.').'" '.
             'where konfid = '.$q->valuebyname('konfid').' and cegnev = "'.$q->valuebyname('cegnev').'" and '.
             '      varos = "'.$q->valuebyname('varos').'" and irsz="'.$q->valuebyname('irsz').'" and '.
             '      ervenyes = "I" and lemondas <> "I" and egyediar <> "I" and egyediszla <> "I"';
  $q3->execsql();
  return $proformaId;
};
?>
