<?php
/*
szmla bngsz
Author: Fogler Tibor   foglert@robitbt.hu
Licence: GNU/GPL

ez hivja a szamlabr0.php -t. (tblzatos megjelenits, sor zselekcival)
POST  act, top, selected, filter, order

*/
session_start();
global $config;
global $act,$top,$selected,$order,$filter,$uniquekeyValue;
include_once('./config.php');
include_once('./mysqldb.php');
include_once('./szamlaprn.php');
include_once('./szamlapdf.php');
include_once('./login.php');  // $db konnektlja, $q -t krel
include_once('./header.php');

// sor/lap s tblzat mret definilsa
$pageSize = 4;
$ifrmHeight = 320;

// grid oszlop fejlc cimkk definilsa
$labels = array();

$labels[] = '<var>#</var>';
$labels[] = '<var>Tipus</var>';
$labels[] = '<var>jelleg</var>';
$labels[] = '<var>v</var>';
$labels[] = '<var>Szmlaszm</var>';
$labels[] = '<var>Fizetsi md</var>';
$labels[] = '<var>Teljesits</var>';
$labels[] = '<var>Szla.dtum</var>';
$labels[] = '<var>Fiz.hatrid</var>';
$labels[] = '<var>Helyesbitett szla.</var>';
$labels[] = '<var>Nyomtatva</var>';
$labels[] = '<var>Cg nv</var>';
$labels[] = '<var>Irsz.</var>';
$labels[] = '<var>Telepls</var>';
$labels[] = '<var>Cm</var>';
$labels[] = '<var>Adszm</var>';
$labels[] = '<var>gyflszm</var>';
$labels[] = '<var>Postzsi nv</var>';
$labels[] = '<var>Postzsi irsz</var>';
$labels[] = '<var>Postzsi telepls</var>';
$labels[] = '<var>Postzsi cm</var>';
$labels[] = '<var>Rendels szm</var>';
$labels[] = '<var>Szllt levl</var>';
$labels[] = '<var>Kltsghely</var>';
$labels[] = '<var>Munkaszm (konferencia .id)</var>';
$labels[] = '<var>Kzlemny (konferencia cme)</var>';
$labels[] = '<var>Mellklet (rsztvevk)</var>';
$labels[] = '<var>Pnznem</var>';
$labels[] = '<var>Nett</var>';
$labels[] = '<var>Brutt</var>';
// segd rutinok
function datumValidate($sdatum) {
   $ev =  0 + substr($sdatum,0,4);
   $ho =  0 + substr($sdatum,5,2);
   $nap =  0 + substr($sdatum,8,2);
   $ki = checkdate($ho, $nap  , $ev);
   if ((substr($sdatum,4,1) != '.') & (substr($sdatum,4,1) != '-')) $ki = false;
   if ((substr($sdatum,7,1) != '.') & (substr($sdatum,7,1) != '-')) $ki = false;
   if (substr($sdatum,4,1) != substr($sdatum,7,1)) $ki = false;
   return $ki;
}
function echoPager($j,$j0,$i) {
     if ($j == $j0)
         echo '<big><b>'.($j+1).'</b></big>&nbsp;';
      else
         echo '<a href="#" onclick="jump('.$i.')">'.($j+1).'</a>&nbsp;';
}
function echoOption($value,$label,$actValue) {
  if ($value==$actValue)
    echo '<option value="'.$value.'" selected="selected">'.$label.'</option>'."\n";
  else
    echo '<option value="'.$value.'">'.$label.'</option>'."\n";
}
function echoOption2($value,$label,$filter) {
  if (strpos($filter,$value)===false)
    echo '<option value="'.$value.'">'.$label.'</option>'."\n";
  else
    echo '<option value="'.$value.'" selected="selected">'.$label.'</option>'."\n";
}
function echoChkBox($table,$name) {
  if ($table->valuebyname($name)=='')
    echo '<input type="checkbox" name="'.$name.'" value="X" />'."\n";
  else
    echo '<input type="checkbox" checked="checked" name="'.$name.'" value="X" />'."\n";
}

// adat kperny
function echodataform($table,$formtitle) {
      global $db,$dsClosed,$dsBrowse,$dsInsert,$dsEdit,$lastError;
      echo '<input type="hidden" name="id" value="'.$table->valuebyname('id').'">'."\n";
      echo '<h2>'.$formtitle.'</h2>'."\n";
      echo '<table border="0" cellspacing="2" cellpadding="2" width="750" style="background-color:white">'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right">Szmlaszm:</td><td align="left"><b>'.$table->valuebyname('szlszam').'</b></td>'."\n";
      echo '  <td align="right">Tipus:</td><td align="left">'.$table->valuebyname('tipus').'</td>'."\n";
      echo '  <td align="right">Jelleg:</td><td align="left">'.$table->valuebyname('jelleg').'</td>'."\n";
      echo '  <td align="right">Bels kdszm:</td><td align="left">'.$table->valuebyname('id').'</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right">Teljests:</td><td align="left">'.$table->valuebyname('teljdat').'</td>'."\n";
      echo '  <td align="right">Szmla dtuma:</td><td align="left">'.$table->valuebyname('datum').'</td>'."\n";
      echo '  <td align="right">Fiz.hatrid:</td><td align="left">'.$table->valuebyname('fizhat').'</td>'."\n";
      echo '  <td align="right">Fiz.md:</td><td align="left">'.$table->valuebyname('fizmod').'</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right">Nyomtattva:</td><td align="left">'.$table->valuebyname('nyomtatva').'</td>'."\n";
      echo '  <td align="right"></td><td align="left"></td>'."\n";
      if  ($table->valuebyname('helyesbitett') == 'HELYESBITO')
        echo '  <td align="right">Ezzel helyesbtett szla:</td><td align="left">'.$table->valuebyname('helyesbitett').'</td>'."\n";
      else
        echo '  <td align="right">Ezt helyesbti:</td><td align="left">'.$table->valuebyname('helyesbitett').'</td>'."\n";
      echo '  <td align="right"></td><td align="left"></td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right"><b>Vev<b>:</td><td align="left" colspan="3">'.$table->valuebyname('cegnev').'</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right"></td><td align="left">'.$table->valuebyname('irsz').'</td>'."\n";
      echo '  <td align="left"  colspan="2">'.$table->valuebyname('varos').'</td><td align="left"></td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right"></td><td align="left" colspan="3">'.$table->valuebyname('cim').'</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td></td><td align="left">Adszm:</td><td align="left" colspan="2">'.$table->valuebyname('adoszam').'</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right">Nett rtk:</td><td align="left"><b>'.$table->valuebyname('netto').'</b></td>'."\n";
      echo '  <td align="right">Brutt rtk:</td><td align="left"><b>'.$table->valuebyname('brutto').'</b></td>'."\n";
      echo '  <td align="left">'.$table->valuebyname('penznem').'</td><td align="left"></td>'."\n";
      echo '  <td align="right"></td><td align="left"></td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right" valign="top"></td><td align="left" colspan="3">'.$table->valuebyname('kozlemeny').'</td>'."\n";
      echo '</tr>'."\n";
      echo '<tr>'."\n";
      echo '  <td align="right" valign="top"><td><td align="left" colspan="3">'.$table->valuebyname('melleklet').'</td>'."\n";
      echo '</tr>'."\n";
      echo '</table>'."\n";
      echo '<hr>'."\n";
      // ttelsorok megjelentse
      $q3 = new Tquery('q2',$db);
      $q3->sql = 'select * from szamlatetel '.
                 'where szamlaid = '.$table->valuebyname('id').' '.
                 'order by id';
      echo '<table border="1" cellpadding="1" width="100%">'."\n";
      echo '<tr>'."\n";
           echo '<th></th>'."\n";
           echo '<th></th>'."\n";
           echo '<th>Megnevezs</th>'."\n";
           echo '<th>Mennyisg</th>'."\n";
           echo '<th>&nbsp;</th>'."\n";
           echo '<th>Nett egysgr</th>'."\n";
           echo '<th>FA kulcs</th>'."\n";
           echo '<th>Nett rtk</th>'."\n";
           echo '<th>Brutt rtk</th>'."\n";
      echo '</tr>'."\n";
      $q3->open();
      $q3->first();
      while (!$q3->eof) {
        echo '<tr>'."\n";
        echo '<td>'.$q3->valuebyname('cikkid').'</td>'."\n";
        echo '<td>'.$q3->valuebyname('cikkat').'</td>'."\n";
        echo '<td>'.$q3->valuebyname('cikknev').'</td>'."\n";
        echo '<td>'.$q3->valuebyname('mennyiseg').'</td>'."\n";
        echo '<td>'.$q3->valuebyname('me').'</td>'."\n";
        echo '<td align="right">'.$q3->valuebyname('negysar').'</td>'."\n";
        echo '<td>'.$q3->valuebyname('afa').'</td>'."\n";
        echo '<td align="right">'.$q3->valuebyname('nertek').'</td>'."\n";
        echo '<td align="right">'.$q3->valuebyname('bertek').'</td>'."\n";
        echo '</tr>'."\n";
        $q3->next();
      }
      $q3->close();
      echo '<tr>'."\n";
      echo '<td></td>'."\n";
      echo '<td></td>'."\n";
      echo '<td><b>sszesen</b></td>'."\n";
      echo '<td></td>'."\n";
      echo '<td></td>'."\n";
      echo '<td></td>'."\n";
      echo '<td></td>'."\n";
      echo '<td align="right"><b>'.$table->valuebyname('netto').'</b></td>'."\n";
      echo '<td align="right"><b>'.$table->valuebyname('brutto').'</b></td>'."\n";
      echo '</tr>'."\n";
      echo '<table>'."\n";
      echo '<p>&nbsp;</p>'."\n";
}

$act = getPOST('act'); if ($act=='') $act='browse';
$top = getPOST('top'); if ($top=='') $top=0;
$selected = getPOST('selected');  if ($selected=='') $selected=0;
$selectedId = getPOST('selectedId');  if ($selectedId=='') $selectedId='0';
$searchStr = getPOST('searchStr');
$filter = stripslashes(getPOST('filter'));  if ($filter == '') $filter = '(sz.munkaszam>=0)';
$order = getPOST('order'); if ($order == '') $order='sz.szlszam';
$totalrecords = 0;

echo '<div id="divszamla" style="background-color:white; border-style:solid; position:absolute; z-index:2; left:30px; top:30px; width:750px">'."\n";
echo '<table border="0"><tr>'."\n";
echo '<td><h1>Szmlk</h1></td>'."\n";
echo '<td><iframe name="ifrmszlaprn" id="ifrmszlaprn" width="300" height="20" frameborder="0"></iframe></td>'."\n";
echo '</tr></table>'."\n";

if ($act=='dofilter') {
  $filter1 = '';
  $filter2 = '';
  if (getPOST('filkonfid') != '')
    $filter1 .= trim(getPOST('filkonfid'));
  if (getPOST('filltipus') != '')
    $filter2 .= ' and '.getPOST('filltipus');
  if (getPOST('filljelleg') != '')
    $filter2 .= ' and '.getPOST('filljelleg');
  if (getPOST('fillev') != '')
    $filter2 .= ' and '.getPOST('fillev');

  if ($filter2 != '') {
    if ($filter1 != '')
      $filter = '('.$filter1.') '.$filter2;
    else
      $filter = $filter2;

  } else {
    if ($filter1 != '')
      $filter = '('.$filter1.')';
    else
      $filter = '';
  }
  $top = 0;
  $selected = 0;

  $act = 'browse';
}
if ($act=='doorder') {
   // j $order kialakitsa
   if (getPOST('newOrder') != '') {
     $order = getPOST('newOrder');
     $top = 0;
     $selected = 0;
     $act = 'browse';
   }
}
if ($act=='searchFirst') {
  $top = 0;
  $selected = -1;
  $act='searchNext'; // r csorog a kvetkez if -re!
  if ($searchStr == '')
     $act='browse';
}
if ($act=='searchNext') {
  // sszes rekorszm lekr sql
  if ($filter=='')
       $q->sql = 'select count(*) from '.$config['dbpre'].'szamla sz '.
                 'where sz.id >= 0 ';
  else
       $q->sql = 'select count(*) from '.$config['dbpre'].'szamla sz '.
                 'where  sz.id >= 0 and '.$filter;
  $q->open();
  if ($q->recordCount > 0) {
      $q->first();
      $totalRecords = $q->fields[0]->value;
  } else {
      $totalRecords = 0;
  }
  $q->close();
  // sql lekrs, soros keress $top+$selected -tl
  // j $top, $selected belltsa
  $selected = $selected + 1;
  $sql = 'select sz.* from '.$config['dbpre'].'szamla sz '.
               'where sz.id >= 0 ';
  if ($filter != '')
     $sql .= ' and '.$filter;
  if ($order != '')
     $sql .= ' order by '.$order.',id';
  $find = -1;
  // vgig olvass 1000 rekordos darabokban
  $recNo = $top + $selected;
  for ($top1 = ($top + $selected); (($top1 < $totalRecords) & ($find < 0)); $top1 = $top1 + 4000) {
    $q->sql = $sql.' limit '.$top1.',4000';
    $q->open();
    if ($q->recordCount > 0) {
       $q->first();
       while (!$q->eof) {
         $jo = false;
         for ($j=0; $j < count($q->fields); $j++) {
           if (!(stripos($q->fields[$j]->value,$searchStr) === false))
              $jo = true;
         }
         if ($jo) {
           $find = $recNo;
           $q->last();
         }
         $q->next();
         $recNo++;
       }
    }
    $q->close;
  }
  // j $top, $selected meghatrozsa a $fin -bl
  if ($find >= 0) {
    $top = 0;
    while ($find >= $pageSize) {
      $top = $top + $pageSize;
      $find = $find - $pageSize;
    }
    $selected = $find;
  } else {
    if ($selected > 0)
       $selected = $selected - 1;
    echo '<script type="text/JavaScript">alert("Nincs ilyen! ('.$searchStr.')");</script>'."\n";
  }
  $act='browse';
}
// sszes rekorszm lekr sql

if ($act == 'formStorno') {
  // eredeti szmla ellenrzse
  $q->sql = 'select szlszam,jelleg,helyesbitett from szamla where id = '.$selectedId;
  $q->open();
  if ($q->recordCount > 0) {
     $q->first();
     $oldSzlszam = $q->fields[0]->value;
  } else {
     $oldSzlszam = '';
  }
  if ($q->valuebyname('jelleg')=='HELYESBITO') {
     $q->close();
     echo "<h1>$oldSzlaszam maga is helyesbit (storniroz) szmla!</h1>";
     include_once('./footer.php');
     exit();
  }
  if ($q->valuebyname('helyesbitett')!='') {
     $q->close();
     echo "<h1>$oldSzlaszam mr stornirozva van!</h1>";
     include_once('./footer.php');
     exit();
  }
  // storno szmla szvegnek bekrse
  echo '<form method="post" action="szamlabr.php">'."\n";
  echo '<p>A '.$oldSzlszam.' szmlval azonos tartalm  - de negativ -rtkeket - '.
       'tartalmaz HELYESBIT szmla kszl. A szmla aljn lv kzlemnyt '.
       'itt kell megadmi (automatikusan a konferencia nv s id sem szerepel rajta).</p>';
  echo '<p>Szveg a storniroz szmlra:</p>'."\n";
  echo '<textarea name="txt" cols="60" rows="10">Stornozs indoka</textarea>'."\n";
  echo '<p>Szmla dtuma:<input type="text" name="szladat" value="'.date('Y.m.d').'" /></p>';
  echo '<input type="hidden" name = "selectedId" value="'.$selectedId.'" />'."\n";
  echo '<input type="hidden" name = "act" value="doStorno" />'."\n";
  echo '<p><button type="submit">Rendben</button>&nbsp;'."\n";
  $url = "'szamlabr.php'";
  echo '<button type="button" onclick="location='.$url.';">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  include_once('./footer.php');
  exit();
}
if ($act == 'doStorno') {

  // eredeti szmlaszm lekrdezse
  $q->sql = 'select szlszam,jelleg,helyesbitett from szamla where id = '.$selectedId;
  $q->open();
  if ($q->recordCount > 0) {
     $q->first();
     $oldSzlszam = $q->fields[0]->value;
  } else {
     $oldSzlszam = '';
  }
  if ($q->valuebyname('jelleg')=='HELYESBITO') {
     $q->close();
     echo "<h1>$oldSzlaszam maga is helyesbit (storniroz) szmla!</h1>";
     include_once('./footer.php');
     exit();
  }
  if ($q->valuebyname('helyesbitett')!='') {
     $q->close();
     echo "<h1>$oldSzlaszam mr stornirozva van!</h1>";
     include_once('./footer.php');
     exit();
  }
  $q->close();

  if (!datumValidate(getPOST('szladat'))) {
    echo '<h2>nem j dtum adat! '.getPOST('szladat').'</h2>';
    include_once('./footer.php');
    exit();
  }



  // j szmla rekord generlsa $selectedId -bl kiindulva getPOST('txt') is felhasznlva
  // id auto, szlszam=res, szla kelte=now(), fizhat=now(), fizmod=res,
  // kozlemeny = getPOST(txt), jelleg = "HELYESBITO', helyesbitett = eredeti.szlaszam
  // tbbi adat tmsolva a $selectedid rekordbl
  $szladat = getPOST('szladat');
  $q->sql = "
  insert into szamla
	(tipus, jelleg, ev, szlszam, fizmod,
	teljdat, datum, fizhat, helyesbitett,
	nyomtatva, cegnev, irsz, varos, cim,
	adoszam, ugyfelszam, pnev, pirsz,
	pvaros, pcim, rendelesszam, szallitolevel,
	koltseghely, munkaszam, kozlemeny,
	mellekletek, penznem, tartalek1,
	tartalek2, tartalek3)
  select tipus, 'HELYESBITO', '".substr($szladat,0,4)."', '', '',
	teljdat, '$szladat', '$szladat', '$oldSzlszam',
	0, cegnev, irsz, varos, cim,
	adoszam, ugyfelszam, pnev, pirsz,
	pvaros, pcim, rendelesszam, szallitolevel,
	koltseghely, munkaszam, '".getPOST('txt')."',
	mellekletek, penznem, tartalek1,
	tartalek2, tartalek3
  from szamla where id = ".$selectedId;
  $q->execsql();
  if ($lastError != '') {
     echo '<h2>Hiba az stornoz biz.krelsa kzben</h2>'."\n";
     echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
     include_once('./footer.php');
     exit();
  }
  // j szamlaid lekrdezse
  $q->sql = 'select max(id) maxid from szamla';
  $q->open();
  if ($q->recordCount > 0) {
     $q->first();
     $newId = $q->fields[0]->value;
  } else {
     $newId = 0;
  }
  $q->close();
  $newSzlszam = date('Y').'/'.substr((1000000+$newId),2,5);

  // j szmla ttelek generlsa $selectedId felhasznlsval,
  // adatok tvve az eredeti szmlbl de minden szm negativ eljel
  $q->sql = "
    insert into szamlatetel
	(szamlaid, cikkid, cikkat, cikkod,
	cikknev, tovabszsz, mennyiseg, me,
	negysar, afa, nertek, bertek, elolegszla,
	kontirT, kontirK, tartalek1, tartalek2,
	tartalek3)
	select $newId, cikkid, cikkat, cikkod,
	cikknev, tovabszsz, mennyiseg, me,
	0 - negysar, afa, 0 - nertek, 0 - bertek, elolegszla,
	kontirK, kontirT, tartalek1, tartalek2,
	tartalek3
    from szamlatetel where szamlaid = ".$selectedId." order by id";
  $q->execsql();
  if ($lastError != '') {
     echo '<h2>Hiba a stornoz bizonylat tteleinek generlsa kzben</h2>'."\n";
     echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
     include_once('./footer.php');
     exit();
  }
  // j szmla rekordba a szmlaszm kitltse
  $q->sql = "
  update szamla
  set szlszam = concat(ev,'/',substr((100000+id),2,5))
  where szlszam = '';";
  $q->execsql();
  if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

  // ujSzlaszam beirsa az eredeti rekordba a helyesbitett mezbe
  $q->sql = 'update szamla set helyesbitett="'.$newSzlszam.'" where id= '.$selectedId;
  $q->execsql();
  if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

  // adatok trlse a konfadmin tblbl
  $q->sql = 'update konfadmin '.
            'set eszla_szam = "", eszla_datum="", eszla_osszeg="" '.
            'where eszla_szam="'.$oldSzlszam.'"';
  $q->execsql();
  if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";
  $q->sql = 'update konfadmin '.
            'set vszla_szam = "", vszla_datum="", vszla_osszeg="" '.
            'where vszla_szam="'.$oldSzlszam.'"';
  $q->execsql();
  if ($lastError != '') echo '<hr>'.$lastError.'<br>'.$q->sql.'<hr>'."\n";

  // j szmla nyomtatsa
  $selectedId = $newId;
  $act='doPrint2';
}
// a doStorno -bl is r csoroghat!
if (($act == 'doPrint') | ($act == 'doPrint2')) {
     if (file_exists('./work/szamla.szl'))
        unlink('./work/szamla.szl');
     $fp = fopen('./work/szamla.szl','w+');
     fwrite($fp,'<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/html40/loose.dtd">'."\n");
     fwrite($fp,'<html>'."\n");
     fwrite($fp,'<head>'."\n");
     fwrite($fp,'  <meta HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-2">'."\n");
     fwrite($fp,'  <title>Systemmedia szmlz rendszer</title>'."\n");
     fwrite($fp,'</head>'."\n");
     fwrite($fp,'<body>'."\n");
     szamlanyomtato($selectedId,$db,$txt);
     if ($act == 'doPrint2')
       szamlanyomtato($selectedId,$db,$txt);
     $fp = fopen('./work/szamla.szl','a+');
     fwrite($fp,'</body></html>');
     echo '<script type="text/javascript">'."\n";
     echo 'document.getElementById("ifrmszlaprn").src = "./dwl.php?f='.$config['rootpath'].'/work/szamla.szl";'."\n";
     echo '</script>';
     $act = 'browse';
}
if ($act == 'doPdf') {
     if (file_exists('./work/szamla.pdf'))
        unlink('./work/szamla.pdf');
     szamlaPdfbe($selectedId,$db,$txt);
     echo '<script type="text/javascript">'."\n";
     //echo 'document.getElementById("ifrmszlaprn").src = "'.$config['rooturl'].'/work/szamla.pdf";'."\n";
     echo 'window.open("'.'./work/szamla.pdf","","left=10,right=10,width=800,height=400");'."\n";
     echo '</script>';
     $act = 'browse';
}
if ($filter=='')
   $q->sql = 'select count(*) from '.$config['pre'].'szamla sz '.
             'where sz.id >= 0';
else
   $q->sql = 'select count(*) from '.$config['pre'].'szamla sz '.
             'where sz.id >= 0 and '.$filter;

$q->open();
if ($q->recordCount > 0) {
  $q->first();
  $totalRecords = $q->fields[0]->value;
} else {
  $totalRecords = 0;
}
$q->close();

// order form
echo '<div class="orderform">'."\n";
echo '<form name="frmorder" action="./szamlabr.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="doorder">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p>Rendezs:<select name="newOrder">'."\n";
     echoOption('sz.szlszam','Szmlaszm',$order);
     echoOption('sz.datum','Szmla dtum',$order);
     echoOption('sz.teljdat','Teljests kelte (konferencia dtuma)',$order);
     echoOption('sz.cegnev','Partner neve',$order);
echo '</select>'."\n";
echo '<button type="submit">trendez</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// filter form rajzolsa, kezd rtkek a $filter-bl jnnek
$filkonfid = '';
$w = explode(')',$filter);
if (count($w) > 1) {
  $w2 = explode("=",$w[0]);
  $filkonfid = trim($w2[1]);
}
echo '<div class="filterform">'."\n";
echo '<form name="frmfilter" action="./szamlabr.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="dofilter">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<p><b>Szrs:</b>&nbsp;&nbsp;&nbsp;'."\n";
echo '<var>Konferencia:</var>'."\n";
echo '<select name="filkonfid">'."\n";
echo '<option value="sz.munkaszam>=0" selected="selected">sszes</option>'."\n";
$q->sql = 'select k_id, k_ido, k_cim from '.$config['dbpre2'].'konferenciak order by k_ido';
$q->open();
if ($q->recordCount > 0) {
  $q->first();
  while (!$q->eof) {
    if ($filkonfid==$q->fields[0]->value)
      echo '<option value="sz.munkaszam='.$q->fields[0]->value.'" selected="selected">'.substr($q->fields[1]->value.' '.$q->fields[2]->value,0,100).'</option>'."\n";
    else
      echo '<option value="sz.munkaszam='.$q->fields[0]->value.'">'.
        substr($q->fields[1]->value.' '.$q->fields[2]->value,0,100).'</option>'."\n";
    $q->next();
  }
}
$q->close();
echo '</select><br>'."\n";
echo '<p>'."\n";
echo '<select name="filltipus">'."\n";
echoOption2("sz.tipus<>'@'","Minden szmla tipus",$filter);
echoOption2("sz.tipus='ELOLEG'","Elleg szmlk",$filter);
echoOption2("sz.tipus='VEGSZLA'","Vg szmlk",$filter);
echo '</select>&nbsp;'."\n";
echo '<select name="filljelleg">'."\n";
echoOption2("sz.jelleg<>'@'","Minden szmla jelleg",$filter);
echoOption2("sz.jelleg='NORMAL'","Norml szmlk",$filter);
echoOption2("sz.jelleg='HELYESBITO'","Helyesbit szmlk",$filter);
echo '</select>&nbsp'."\n";
echo '<select name="fillev">'."\n";
echoOption2("sz.ev<>0","sszes v",$filter);
echoOption2("sz.ev=2009","2009 vi szmlk",$filter);
echoOption2("sz.ev=2010","2010 vi szmlk",$filter);
echoOption2("sz.ev=2011","2011 vi szmlk",$filter);
echoOption2("sz.ev=2012","2012 vi szmlk",$filter);
echoOption2("sz.ev=2013","2013 vi szmlk",$filter);
echoOption2("sz.ev=2014","2014 vi szmlk",$filter);
echoOption2("sz.ev=2015","2015 vi szmlk",$filter);
echoOption2("sz.ev=2016","2016 vi szmlk",$filter);
echoOption2("sz.ev=2017","2017 vi szmlk",$filter);
echo '</select>&nbsp'."\n";

echo '<button type="submit">Szrst alkalmaz</button></p>'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// bngsz iframe
echo '<center><iframe name="ifrm0" width="98%" height="'.$ifrmHeight.'"></iframe></center>'."\n";
// bngsz tblzat iframe-be betltshez szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmbongeszo" action="./szamlabr0.php" method="post" target="ifrm0">'."\n";
echo '<input type="hidden" name="act" value="'.$browse.'">'."\n";
echo '<input type="hidden" name="pageSize" value="'.$pageSize.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '<input type="hidden" name="labels" value="'.implode(';',$labels).'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// lapoz gombsor kiirsa
echo '<p class="gridjumper">';
echo 'sszesen '.$totalRecords.' sor &nbsp;&nbsp;&nbsp;';
echo 'Oldalak:&nbsp;'."\n";
       $j0 = ($top / $pageSize); // current page
       $jmax = ($totalRecords / $pageSize); // max page
       $elozoKiirva = false;
       $i = 0; // rekordszm
       $j = 0; // oldalszm
       while ($j <= $jmax) {
          if (($j < 5) |
              ($j > $jmax - 5) |
              (abs($j - $jmax/2) < 5) |
              (abs($j - $j0) < 5)
             ) {
               echoPager($j,$j0,$i);
               $elozoKiirva = treu;
          } else {
               if ($elozoKiirva) echo '...';
               $elozoKiirva = false;
          }
          $i = $i + $pageSize;
          $j++;
       }
echo '</p>'."\n";

// bngsz iframe feltltse
echo '<script type="text/javascript">'."\n";
echo 'document.forms.frmbongeszo.submit();'."\n";
echo '</script>'."\n";

// manipull gombsor
echo '<p><button type="button" onclick="viewform();"><img src="./images/info.gif">Megnz</button>&nbsp;';
echo '<button type="button" onclick="doPrint();"><img src="./images/buttonprn.gif">jra nyomtat</button>&nbsp'."\n";
echo '<button type="button" onclick="doPdf();"><img src="./images/buttonpdf.gif">Pdf msolat</button>&nbsp'."\n";
echo '<button type="button" onclick="formStorno();"><img src="./images/buttondel.gif">Storniroz</button>&nbsp'."\n";
echo '<button type="button" onclick="searchFirst();"><img src="./images/buttonfind.gif">Keres ellrl</button>&nbsp;'."\n";
echo '<button type="button" onclick="searchNext();"><img src="./images/buttonfind.gif">Tovbb Keres</button>&nbsp;'."\n";
echo '<button type="button" onclick="doexcelexport();"><img src="./images/grid.gif">Export EXCEL-be</button>&nbsp;'."\n";
$url = "'index.php'";
echo '<button type="button" onclick="location='.$url.'"><img src="images/buttoncancel.gif">Vissza a kezd lapra</button></p>'."\n";

// sajtmaga visszahivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="visszahivo" action="./szamlabr.php" method="post">'."\n";
echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
echo '<input type="hidden" name="selectedId" value="'.$selectedId.'">'."\n";
echo '<input type="hidden" name="searchStr" value="'.$searchStr.'">'."\n";
echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

// mysql2excel hivshoz szksges rejtett form
echo '<div style="display:none">'."\n";
echo '<form name="frmcsv" action="./mysql2excel.php" method="post">'."\n";
echo '<input type="hidden" name="selectsql" value="">'."\n";
echo '<input type="hidden" name="countsql" value="">'."\n";
echo '<input type="hidden" name="csvnev" value="">'."\n";
echo '<input type="hidden" name="terminator" value=",">'."\n";
echo '</form>'."\n";
echo '</div>'."\n";

if ($act == 'viewform') {
  echo '<div style="display:block; position:absolute; z-index:99; left:50px; top:20px; width:800px; background-color:silver; border-style:solid;">'."\n";
  echo '<form name="adatform" action="./szamlabr.php" method="post">'."\n";
  echo '<input type="hidden" name="act" value="'.$act.'">'."\n";
  echo '<input type="hidden" name="top" value="'.$top.'">'."\n";
  echo '<input type="hidden" name="selected" value="'.$selected.'">'."\n";
  echo '<input type="hidden" name="filter" value="'.$filter.'">'."\n";
  echo '<input type="hidden" name="order" value="'.$order.'">'."\n";
  $q->sql = 'select 	sz.id, sz.tipus, sz.jelleg, sz.ev, sz.szlszam, sz.fizmod, '.
            'sz.teljdat, sz.datum, sz.fizhat, sz.helyesbitett, '.
            'sz.nyomtatva, sz.cegnev, sz.irsz, sz.varos, sz.cim, sz.adoszam, '.
            'sz.ugyfelszam, sz.pnev, sz.pirsz, '.
            'sz.pvaros, sz.pcim, sz.rendelesszam, '.
            'sz.szallitolevel, sz.koltseghely, sz.munkaszam, '.
            'sz.kozlemeny, sz.mellekletek, sz.penznem, '.
            'sum(szt.nertek) netto, sum(szt.bertek) brutto '.
            'from '.$config['dbpre'].'szamla sz, '.
            '     '.$config['dbpre'].'szamlatetel szt '.
            'where sz.id = szt.szamlaid  and sz.id = '.$selectedId.' '.
            'group by sz.id, sz.tipus, sz.jelleg, sz.ev, sz.szlszam, sz.fizmod, '.
            '                sz.teljdat, sz.datum, sz.fizhat, sz.helyesbitett, '.
            '                sz.nyomtatva, sz.cegnev, sz.irsz, sz.varos, sz.cim, sz.adoszam, '.
            '                sz.ugyfelszam, sz.pnev, sz.pirsz, '.
	    '                sz.pvaros, sz.pcim, sz.rendelesszam, '.
            '                sz.szallitolevel, sz.koltseghely, sz.munkaszam, '.
            '                sz.kozlemeny, sz.mellekletek, sz.penznem ';
  $q->open();
  $q->first();
  echodataform($q,'Szmla adatok');
  $q->close();
  echo '<p style="text-align:right"><button type="button" onclick="cancel()"><img src="./images/buttonok.gif">Rendben</button>&nbsp;'."\n";
  echo '<button type="button" onclick="cancel()"><img src="./images/buttoncancel.gif">Mgsem</button></p>'."\n";
  echo '</form>'."\n";
  echo '</div>'."\n";
  echo '<script type="text/javascript">'."\n";
  echo 'inputs = document.getElementsByTagName("INPUT");'."\n";
  // input mezk set readonly
  echo 'for (i=0; i < inputs.length; i++) {'."\n";
  echo '  inputs[i].readOnly = true;'."\n";
  echo '  inputs[i].disabled = true;'."\n";
  echo '}'."\n";
  echo '</script>'."\n";
}


echo '<script type="text/javascript">'."\n";
echo 'selected = '.$selected.';'."\n";
echo 'selectedId = '.$selectedId.';'."\n";
echo 'document.getElementById("divszamlabr").style.width=screen.width - 80;'."\n";
echo 'function jump(newTop) {'."\n";
echo '  selected = 0;'."\n";
echo '  document.forms.visszahivo.top.value=newTop;'."\n";
echo '  document.forms.visszahivo.selected.value="0";'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchFirst() {'."\n";
echo '  document.forms.visszahivo.searchStr.value=prompt("Keresend:");'."\n";
echo '  document.forms.visszahivo.act.value="searchFirst";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function searchNext() {'."\n";
echo '  document.forms.visszahivo.act.value="searchNext";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";

echo 'function formStorno() {'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  if (confirm("Storno szmlt akar killtani ehez a szmlhoz?")) ';
echo '     document.forms.visszahivo.act.value="formStorno";'."\n";
echo '  else'."\n";
echo '     document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";

echo 'function doPrint() {'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.act.value="doPrint";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";

echo 'function doPdf() {'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.act.value="doPdf";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";

echo 'function doexcelexport() {'."\n";
echo '  document.forms.visszahivo.action="mysql2excel.php";'."\n";

if ($filter=='')
   $sql = $config['pre'].'szamla sz '.
             'where sz.id >= 0';
else
   $sql = $config['pre'].'szamla sz '.
             'where sz.id >= 0 and '.$filter;



echo '  document.forms.frmcsv.selectsql.value="'.
     'select sz.* '.
     'from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.countsql.value="select count(sz.id) from '.$sql.'";'."\n";
echo '  document.forms.frmcsv.csvnev.value="szamlabr";'."\n";
echo '  document.forms.frmcsv.submit();'."\n";
echo '}'."\n";

echo 'function doload() {'."\n";
echo '  location="./szamlabrload.php";'."\n";
echo '}'."\n";
echo 'function viewform() {'."\n";
echo '  document.forms.visszahivo.act.value="viewform";'."\n";
echo '  document.forms.visszahivo.selectedId.value=selectedId;'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function ok() {'."\n";
echo '  inputs = document.getElementsByTagName("INPUT");'."\n";
echo '  for (i=0; i < inputs.length; i++) {'."\n";
echo '    inputs[i].readOnly = false;'."\n";
echo '    inputs[i].disabled = false;'."\n";
echo '  }'."\n";
if ($act == 'insertform')
   echo '  document.forms.adatform.act.value="doinsert";'."\n";
if ($act == 'updateform')
   echo '  document.forms.adatform.act.value="doupdate";'."\n";
if ($act == 'viewform')
   echo '  document.forms.adatform.act.value="browse";'."\n";
echo '  document.forms.adatform.submit();'."\n";
echo '}'."\n";
echo 'function cancel() {'."\n";
echo '  inputs = document.getElementsByTagName("INPUT");'."\n";
echo '  for (i=0; i < inputs.length; i++) {'."\n";
echo '    inputs[i].readOnly = false;'."\n";
echo '    inputs[i].disabled = false;'."\n";
echo '  }'."\n";
echo '  document.forms.visszahivo.act.value="browse";'."\n";
echo '  document.forms.visszahivo.submit();'."\n";
echo '}'."\n";
echo 'function celclick(row,col) {'."\n";
echo '  selected = row;'."\n";
echo '  document.forms.visszahivo.selected.value=row;'."\n";
echo '}'."\n";
echo '</script>'."\n";
echo '</div>'."\n";
include_once('./footer.php');
?>
