<?php
/*  szmla nyomtat rutin
    Licensz: GNU/GPL  foglert@robitbt.hu

    a rutin feladata: a ./work/szamla.sz -hez hozzirni a megadott szmlt
    2 pldnyban

    szamlanyomtato($szid,$db,$szoveg) {
       $szid = nyomtatand szmla ID
       $db Database objektum
       $szoveg  A stmlra irand szveg
       Hivsakor a "./work/szamla.sz" mr ltezik.


*/
global $config,$debugLevel;
include_once('./config.php');
include_once('./mysqldb.php');
include "./Numbers/Words.php";

class TafaSum {
  var $db = 0;
  var $kulcsok = array();
  var $nettok = array();
  var $bruttok = array();
  function TafaSum() {
    $this->db = 0;
    $this->kulcsok = array();
    $this->nettok = array();
    $this->bruttok = array();
  }
  function add($netto,$afakulcs,$brutto) {
    $i = 0;
	$J = count($this->kulcsok);
	while ($i < $J) {
	   if ($this->kulcsok[$i]==$afakulcs) {
	      $this->nettok[$i] = $this->nettok[$i] + round($netto);
	      $this->bruttok[$i] = $this->bruttok[$i] + round($brutto);
		  $i = 999;
	   }
	   $i++;
	}
	if ($i == $J) {
       $this->kulcsok[$i] = $afakulcs;
   	   $this->nettok[$i] = round($netto);
	   $this->bruttok[$i] = round($brutto);
	}
  }
  function count() {
    return count($this->kulcsok);
  }
  function printel($htmlprint, &$y) {
      $htmlprint->SetFont('courier','','','medium');
	  $y = $y + 10;
      $htmlprint->text(10,$y,'FA sszests');
	  $snetto = 0;
	  $sbrutto = 0;
	  for ($i=0; $i<count($this->kulcsok); $i++) {
  	    $y = $y + 5;
	    $snetto = $snetto + $this->nettok[$i];
	    $sbrutto = $sbrutto + $this->bruttok[$i];
        $htmlprint->text(20,$y,$this->kulcsok[$i]);
        $htmlprint->text(50,$y,'Nett:');
        $htmlprint->text(65,$y,rpad(round($this->nettok[$i]),10));
        $htmlprint->text(100,$y,'AFA:');
        $htmlprint->text(115,$y,rpad(round($this->bruttok[$i] - $this->nettok[$i]),8));
        $htmlprint->text(150,$y,'Brutt:');
        $htmlprint->text(165,$y,rpad(round($this->bruttok[$i]),10));
	  }
	  $y = $y + 10;
      $htmlprint->text(20,$y,'Vg sszessen');
      $htmlprint->text(50,$y,'Nett: ');
      $htmlprint->text(65,$y,rpad(round($snetto),10));
      $htmlprint->text(100,$y,'FA: ');
      $htmlprint->text(115,$y,rpad(round($sbrutto - $snetto),8));
      $htmlprint->text(150,$y,'Brutt: ');
      $htmlprint->text(165,$y,rpad(round($sbrutto),10));
   }
}
class HTMLPRINT {
   var $fontSize = 12;
   var $fontName = 'roman';
   var $fontWeight = 'normal';
   var $fontStyle = 'normal';
   var $inPage = false;
   var $ki = '';
   function HTMLPRINT() {
     $this->fontSize = 12;
     $this->fontName = 'roman';
     $this->fontWeight = '';
     $this->inPage = false;
     $this->ki = '';
   }
   function addPage() {
     $this->ki .= "\n".'<div style="page-break-before:allways" />';
     $this->inPage = true;
   }
   function line($x1,$y1,$x2,$y2) {
     $this->ki .= "\n".'<hr style="position:absolute; top:'.$y1.'mm; left:'.$x1.'mm; width:'.($x2 - $x1).'mm; height:1mm" />';

   }
   function image($filename,$x,$y,$w,$h) {
      $this->ki .= "\n".'<img src="logo.bmp" style="position:absolute; left:'.$x.'mm; top:'.$y.'mm; width:'.$w.'mm; height:'.$h.'mm;" />';
   }
   function setFont($fontName,$weight,$fontStyle,$fontSize) {
     $this->fontName = $fontName;
     $this->fontWeight = $weight;
     $this->fontStyle = $fontStyle;
     $this->fontSize = $fontSize;
   }
   function text($x,$y,$txt) {
     $fw = 'normal';
     $fs = 'normal';

     if ($this->fontWeight == 'B')
       $fw = 'bold';
     else
       $fw = 'normal';

     if ($this->fontStyle == 'I')
       $fs = 'italic';
     else
       $fs = 'normal';

    // html entity-k szrse
    $txt = html_entity_decode($txt);
    $txt = str_replace('&#336;','',$txt);
    $txt = str_replace('&#337;','',$txt);
    $txt = str_replace('&#9642;','-',$txt);
    $this->ki .= "\n".'<div style="position:absolute; top:'.$y.'mm; left:'.$x.'mm; '.
                  'font-family:'.$this->fontName.'; font-size:'.$this->fontSize.
                  '; font-weight:'.$fw.'; font-style:'.$fs.';">'.
                  strip_tags($txt).
                  '</div>';
   }
   function textWordWrap($x,$y,$charWidth,$txt) {
     // html entity-k szrse
     $txt = html_entity_decode($txt);
     $w = '';
     $wy = $y;
     $txt = str_replace("\n"," \n ",$txt);
     $words = explode(' ',strip_tags($txt));
     $i = 0;
     for ($i = 0; $i < count($words); $i++) {
       if ($words[$i] == "\n") {
         $this->text($x,$wy,$w);
         $w = $words[$i].' ';
         $wy = $wy + 5;
       } else if (strlen($w.' '.$words[$i]) <= $charWidth)
          $w .= $words[$i].' ';
       else {
         $this->text($x,$wy,$w);
         $w = $words[$i].' ';
         $wy = $wy + 5;
       }
     }
     $this->text($x,$wy,$w);
   }
   function _echo($txt) {
     $this->ki .= $txt;
   }
   function output($path) {
     $fp = fopen($path,'a+');
     fwrite($fp,$this->ki);
     fclose($fp);
   }
}

function rpad($s,$w) {
  while (strlen($s) < $w)
    $s = '_'.$s;
  if ($w==5)
    $s = substr($s,0,2).'_'.substr($s,2,3);
  if ($w==6)
    $s = substr($s,0,3).'_'.substr($s,3,3);
  if ($w==7)
    $s = substr($s,0,1).'_'.substr($s,1,3).'_'.substr($s,4,3);
  if ($w==8)
    $s = substr($s,0,2).'_'.substr($s,2,3).'_'.substr($s,5,3);
  if ($w==9)
    $s = substr($s,0,3).'_'.substr($s,3,3).'_'.substr($s,6,3);
  if ($w==10)
    $s = substr($s,0,1).'_'.substr($s,1,3).'_'.substr($s,4,3).'_'.substr($s,7,3);
  return $s;
}

function szamlanyomtato($szid,$db,$szoveg) {
  global $config;
  $q1 = new Tquery('q1',$db);
  $q2 = new Tquery('q2',$db);
  $q1->sql = 'select * from szamla where id = '.$szid;
  $q1->open();
  if ($q1->recordCount > 0) {
    $q1->first();

    $nyomtatva = $q1->valuebyname('nyomtatva');
    $nyomtatva = $nyomtatva + 1;
    $szlszam = $q1->valuebyname('szlszam');
    $nev = $q1->valuebyname('id');
    $FH = 10;   // font size pt
    $H =  4;   // sor magassg mm
    $L =  0.2;  // vonal vastagsag mm
    $FIZHAT = $config['fizhat'];  // fizetsi hatrid napban
    $htmlprint = new HTMLPRINT();

    $htmlprint->AddPage();
    $htmlprint->SetFont('times','','','medium');
    $htmlprint->Image('logo.bmp',5,5,200,97);

    $htmlprint->SetFont('times','B','I','larger');
    if ($q1->valuebyname('tipus') == 'ELOLEG')
      $w = 'Ellegszmla';
    else
      $w = 'Szmla';
    if ($q1->valuebyname('jelleg') != 'NORMAL')
      $w = 'SZMLVAL EGY TEKINTET AL ES OKIRAT';
    $htmlprint->SetFont('times','B','I','larger');
    $htmlprint->text(15,12,$w);
    $htmlprint->SetFont('times','B','','medium');

    // szmla szma
    $htmlprint->SetFont('times','B','','larger');
    $htmlprint->text(162,20,$q1->valuebyname('szlszam'));

    $htmlprint->SetFont('times','','','medium');
    // szllt
    $htmlprint->text(30,35,$config['cegnev0']);
    $htmlprint->text(30,40,$config['cegnev1']);
    $htmlprint->text(30,45,$config['cegnev2']);
    $htmlprint->text(30,50,$config['cegnev3']);
    $htmlprint->text(30,55,$config['cegnev4']);
    $htmlprint->text(30,60,$config['cegnev5']);
    $htmlprint->text(30,65,$config['cegnev6']);
    // vev

    $htmlprint->SetFont('times','B','','large');
    $htmlprint->textWordWrap(110,35,35,$q1->valuebyname('cegnev'));
    $htmlprint->SetFont('times','','','medium');

    $htmlprint->text(110,55,$q1->valuebyname('adoszam'));
    $htmlprint->text(110,60,$q1->valuebyname('varos'));
    $htmlprint->text(110,65,$q1->valuebyname('cim'));
    $htmlprint->text(110,70,$q1->valuebyname('irsz'));

    // dtumok s fizmod
    $htmlprint->SetFont('times','B','','medium');
    if ($q1->valuebyname('fizmod') == 'KP')
       $htmlprint->text(20,85,'Kszpnz');
    else if ($q1->valuebyname('fizmod') == 'ATUT')
       $htmlprint->text(20,85,'tutals');
    else
       $htmlprint->text(20,85,$q1->valuebyname('fizmod'));
    $htmlprint->text(70,85,$q1->valuebyname('teljdat'));
    $htmlprint->text(120,85,$q1->valuebyname('datum'));
    $htmlprint->text(170,85,$q1->valuebyname('fizhat'));

    $htmlprint->SetFont('courier','','','small');
    $snetto = 0;
    $sbrutto = 0;
    $afaSum = new Tafasum();
	$T = '';
    $K = '';
    $y = 103;
    $q2->sql = 'select * from szamlatetel where szamlaid = '.$szid.
               ' order by id';
    $q2->open();
    if ($q2->recordCount > 0) {
      $q2->first();
      while (!$q2->eof) {
        $netto1 = round($q2->valuebyname('nertek'));
        $brutto1 = round($q2->valuebyname('bertek'));
        $htmlprint->text(10,$y,$q2->valuebyname('cikknev'));
        $htmlprint->text(65,$y,$q2->valuebyname('cikkod'));
        $htmlprint->text(90,$y,rpad(round($q2->valuebyname('mennyiseg')),2).
                             $q2->valuebyname('me'));
        $htmlprint->text(115,$y,rpad(round($q2->valuebyname('negysar')),8).' ');
        $htmlprint->text(135,$y,rpad($netto1,8).' ');
        $htmlprint->text(155,$y,$q2->valuebyname('afa'));
        $htmlprint->text(165,$y,rpad(round($brutto1 - $netto1),8).' ');
        $htmlprint->text(185,$y,rpad(round($brutto1),8).' ');
        $snetto = $snetto + $netto1;
        $sbrutto = $sbrutto + $brutto1;
		$afaSum->add($netto1,$q2->valuebyname('afa'),$brutto1);
        if (strpos($T,$q2->valuebyname('kontirT').',')===false)
           $T .= $q2->valuebyname('kontirT').',';
        if (strpos($K,$q2->valuebyname('kontirK').',')===false)
           $K .= $q2->valuebyname('kontirK').',';
        $y = $y + 5;
        $q2->next();
      }
      $q2->close();
    }
    $htmlprint->Line(10,$y,200,$y);

    // sszesen
	if ($afaSum->count() > 1) 
	  $afaSum->printel($htmlprint,$y);
	else {  
      $htmlprint->SetFont('courier','','','medium');
      $htmlprint->text(105,$y + 10,'sszesen');
      $htmlprint->text(152,$y + 10,'Nett:     '.rpad(round($snetto),8).' ');
      $htmlprint->text(152,$y + 16,'fa:       '.rpad(round($sbrutto - $snetto),8).' ');
      $htmlprint->text(152,$y + 22,'Brutt:    '.rpad(round($sbrutto),8).' ');
    }
	
	if (($sbrutto - $snetto) >= 0)
       $K .= '4671';
    if (($sbrutto - $snetto) < 0)
       $T .= '4671';
    $htmlprint->text(152,$y + 28,'Fizetend: '.rpad(round($sbrutto),8).' ');
    $htmlprint->text(195,$y + 28,$q1->valuebyname('penznem'));
    if ((abs($sbrutto) <= 0) |
        ($q1->valuebyname('fizmod') == 'Fizetve') |
        ($q1->valuebyname('tipus') == 'ELOLEG')) {
       $htmlprint->text(140,$y + 34,'Pnzgyi rendezst nem ignyel.');
    }
    $azaz = new Numbers_Words();
    $htmlprint->SetFont('times','B','','medium');
    $htmlprint->text(20,$y + 46, 'Azaz: '.$azaz->toWords($sbrutto,'hu_HU'));
    $htmlprint->SetFont('times','','','medium');

    // kzlemny s mellkletek szveg
    $htmlprint->textWordWrap(10,$y + 60,90,$q1->valuebyname('kozlemeny'));
    $htmlprint->SetFont('times','','','medium');
    $htmlprint->textWordWrap(10,$y + 80,90,$q1->valuebyname('mellekletek'));
    $htmlprint->textWordWrap(10,$y + 90,90,$szoveg);

    if ($q1->valuebyname('jelleg') == 'HELYESBITO')
      $htmlprint->text(10,230, 'Az okirat a kvetkez szmlhoz tartozik: '.$q1->valuebyname('helyesbitett'));


    $htmlprint->SetFont('times','','','medium');
    // kontirozs
    if ((trim($T) != '') | trim($K != ''))
       $htmlprint->text(10,255,'T: '.$T.'&nbsp;&nbsp;&nbsp;  K: '.$K);

    if ($nyomtatva == 1) {
       $htmlprint->text(22,22,'Els, eredeti pldny');
    } else {
       $htmlprint->text(22,22,$nyomtatva.'. nyomtatott pldny (msolat)');
    }
    $htmlprint->Line(10,260,200,260);
    $htmlprint->SetFont('times','','','small');
    $htmlprint->text(10,262,'Kszlt a RoBIT Bt. Konferencia-admin programjval. http://robitbt.hu');
    //$htmlprint->Output("./work/szamla.szl");
    $htmlprint->Output("./work/szamla.szl");
    $htmlprint->SetFont('times','','','medium');
    // upate nyomtatva rtk
    $q2->sql = 'update szamla '.
               'set nyomtatva = '.$nyomtatva.' '.
               'where id = '.$szid;
    $q2->execsql();

  } // megvan a szamla rekord
  $q1->close();
}

?>
